cap restore
clear all


import excel using "${folder}/Input_data.xlsx", firstrow clear

gen yearnavg7 = (yearn2 + yearn3 + yearn4 + yearn5 + yearn6 + yearn7)/6
gen yearnavg7_dif = yearnavg7 - xearn6

gen college = (educ > 12)
gen collegedegree = (educ > 15)

gen agewgt45 = (agew > 45)
gen agewgt55 = (agew > 55)
gen agewgt65 = (agew > 65)


egen interaction_group = group(male collegedegree agewgt45 agewgt55 agewgt65)

br interaction_group yearlpr
sort interaction_group yearlpr
tab interaction_group, gen(interaction_group_dummies)

local X_x_Z "interaction_group_dummies*"

ds `X_x_Z'

foreach vv1 in `r(varlist)' {
	summarize `vv1'
	if `r(sum)' > 0 {
		gen X_`vv1' = yearlpr
		summarize `vv1'
		gen intvar = `vv1' - `r(mean)'
		replace X_`vv1' = X_`vv1' * intvar
		drop intvar
	}
}

reg yearnavg7 yearlpr educ agew male college agewgt55 agewgt65 interaction_group_dummies*, robust
reg yearnavg7 yearlpr educ agew male college agewgt55 agewgt65 interaction_group_dummies* X_*, robust

gen obs = _n
gen ones = 1

save "${folder}/Pre-regression data.dta", replace

quietly do "${folder}/Stats for bivariate.do" 

*** EOF ***


