function [ Yout_1, Yout_0, Xout, Zout, gamma_out ] = Gen_Obs_sparse_UC( beta_alt, beta_null, kappa, rhosq, nu, eta, var_e, par)
%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here

M1 = eye(par.N) - ones(par.N,1)*ones(par.N,1)'/par.N;
Z2 = normrnd(0,1,[par.N,par.K-floor(eta*par.K)]);
Z1 = normrnd(0,1,[par.N,floor(eta*par.K)]);
Z = [Z1,Z2];
Zout = Z;

% X = Z*mu + ex
mu = zeros(par.K,1);
idxfst = floor((1-nu)*eta*par.K) + 1;
idxlst = idxfst + floor(eta*par.K) - 1;
mu(idxfst:idxlst) = 1;
ex = normrnd(0,1,[par.N,1]);
M1Z = M1*Z;
M1ex = M1*ex;
PM1Z = M1Z*((M1Z'*M1Z)\(M1Z'));
a1 = mu'*M1Z'*PM1Z*M1Z*mu - mu'*(M1Z'*M1Z)*mu*rhosq;
a2 = 2*mu'*M1Z'*PM1Z*M1ex - 2*mu'*M1Z'*M1ex*rhosq;
a3 = M1ex'*PM1Z*M1ex - (M1ex'*M1ex)*rhosq;
c_mu = roots([a1 a2 a3]);
c_mu = max(c_mu);
mu = mu*c_mu;
Xout = Z*mu + ex;

% assert(c_mu > 0)
assert(abs(((M1*Xout)'*PM1Z*(M1*Xout))/((M1*Xout)'*(M1*Xout)) - rhosq) < 10^(-5))


% Y = X*beta + Z*gamma + ee
ee = normrnd(0,1,[par.N,1]);
gamma = zeros(par.K,1);
idx = floor(eta*par.K);
gamma(1:idx)=1;
c_gamma = kappa/norm(M1*Z*gamma);
gamma = gamma*c_gamma;
assert(abs(norm(M1*Z*gamma)^2 - kappa^2) < 10^(-5))
gamma_out = gamma;

Yout_1 = Xout*beta_alt + Zout*gamma_out + 1 + ee;
Yout_0 = Zout*gamma_out + 1 + ee;

end