(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.4' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    200833,       3897]
NotebookOptionsPosition[    197851,       3845]
NotebookOutlinePosition[    198192,       3860]
CellTagsIndexPosition[    198149,       3857]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"cvtab", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"Drop", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"Drop", "[", 
        RowBox[{
         RowBox[{"Import", "[", 
          RowBox[{
          "\"\<c:/dropbox/mystuff/sparsity/revision/cvmat_5.txt\>\"", ",", 
           "\"\<Table\>\""}], "]"}], ",", "1"}], "]"}], "]"}], ",", "1"}], 
     "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6802757949988256`*^9, 3.6802759391463957`*^9}, 
   3.816708877114637*^9},ExpressionUUID->"4f7c1080-6353-4780-b76f-\
e5885a4b4456"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "=", 
  RowBox[{"ListInterpolation", "[", 
   RowBox[{"cvtab", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0.025", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.025", ",", "1"}], "}"}]}], "}"}], ",", 
    RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6802759566448526`*^9, 3.680275960923235*^9}, {
  3.680276077114462*^9, 3.680276089499346*^9}, {3.680276122958325*^9, 
  3.6802761251491537`*^9}, {3.6802777060617867`*^9, 3.6802777099180317`*^9}, {
  3.680278168814519*^9, 3.680278172623664*^9}, {3.680278875390028*^9, 
  3.6802788767977457`*^9}, {3.6802789689900475`*^9, 3.6802789836139607`*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"5a8d6e68-ea0e-4dfa-8635-0a3d7a848cb8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["InterpolatingFunction",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{
               GrayLevel[0.6], 
               AbsolutePointSize[5], 
               PointBox[{1, 1}], 
               PointBox[{2, 4}], 
               PointBox[{3, 2}], 
               PointBox[{4, 3}]}, {{}, {}, {
                AbsoluteThickness[1], 
                Opacity[1.], 
                LineBox[CompressedData["
1:eJwBMQPO/CFib1JlAgAAADIAAAACAAAA4ScLwZmZ6T/ACPskWpOYv4AjHgZ5
3Os/cnpQh5xu1j/qWn1XCVDuP5K7ih5ptuc/r+pongFN8D/CUK87BHLxP46d
cUQ/bPE/ujUa8/qu9j9TbqBw1aPyP/TWyyAhFfw/neDJZqDG8z+QAqdF9GsA
QM1wGePDAfU/VsVD/9nXAkCidscSKDf2P6Bp73exDQVA/B1wDMFX9z+TpM3k
wfUGQDzjPoyykPg/7M3Z+O7ZCEABSgjW2LT5P3pl9LwNcgpAbCYw0z/T+j86
ypori9cLQL0gflb/Cfw/lpOs9xIqDUCTvMaj8yv9Pw4alcoYNg5AT3Y1d0Bm
/j+pB2LLtyIPQLClAv7Nmv8/NnA5bbjSD0BLO2UnSF0AQFrcILXmpw9AsTLc
klX5AED+sDHBQukOQNp6UGP9igFAbZ+lR/sLDkD10dd20SgCQNHi3Mj38wxA
42MO5MXDAkAZdr6AZb8LQJRGQrZUVANArv7zEMKHCkA4OInLD/EDQLBlMO3M
IglAnnrNRWWDBEA3d8OX6skHQNf3wBnbEgVAD3D3ndNyBkADhMcwfa4FQHOK
7Wak/wRA8WDLrLk/BkC/MhCgYawDQNJM4msi3QZAwss/TmVLAkCGc6iEq3cH
QIsIg92+BgFA/OprAs8HCECrPCvgePD/P2VxQsMepAhAKXVLE0Xg/j+RSBbp
CDYJQPRz0a7WJ/4/kFqZaBPFCUDN4sX5uLj9P4J7LytKYApAvh1MbRmT/T82
7cJSG/EKQHzT1YZwwv0/3W1pvRiOC0B2LZ/10lT+P0c/DY2wIAxAVrX8MJA7
/z+DS2C2aLAMQElWzbMzPQBAsmbGIk1MDUCi9bAadCABQKTSKfTL3Q1AYexd
q+EpAkCJTaAId3sOQFyS/ndEhgNAQAPGdkIWD0BHWcLdahwFQLoJ6Umopg9A
vd1CiejSBkCTjw8wnSEQQPiVkXD08QhAq0KpbbNqEEBsk2Azxi4LQCyTGthZ
shBAYCBYjj+gDUAnaxVkFgARQMwfdA9ySBBAg+uOIqBIEUBj/5rHgMsRQNFn
q5SZmRFAL++xNeOlE0Dwt3AR
                 "]]}}}, AspectRatio -> 1, Axes -> False, Background -> 
             GrayLevel[0.93], Frame -> True, FrameStyle -> Directive[
               GrayLevel[0.7], 
               Thickness[Tiny]], FrameTicks -> None, ImageSize -> {Automatic, 
               Dynamic[
               3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])]}, PlotRange -> {{0, 5}, {0, 5}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.025`", ",", "0.9999999999999999`"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"0.025`", ",", "0.9999999999999999`"}], "}"}]}], 
                    "}"}], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"scalar\"", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{
               GrayLevel[0.6], 
               AbsolutePointSize[5], 
               PointBox[{1, 1}], 
               PointBox[{2, 4}], 
               PointBox[{3, 2}], 
               PointBox[{4, 3}]}, {{}, {}, {
                AbsoluteThickness[1], 
                Opacity[1.], 
                LineBox[CompressedData["
1:eJwBMQPO/CFib1JlAgAAADIAAAACAAAA4ScLwZmZ6T/ACPskWpOYv4AjHgZ5
3Os/cnpQh5xu1j/qWn1XCVDuP5K7ih5ptuc/r+pongFN8D/CUK87BHLxP46d
cUQ/bPE/ujUa8/qu9j9TbqBw1aPyP/TWyyAhFfw/neDJZqDG8z+QAqdF9GsA
QM1wGePDAfU/VsVD/9nXAkCidscSKDf2P6Bp73exDQVA/B1wDMFX9z+TpM3k
wfUGQDzjPoyykPg/7M3Z+O7ZCEABSgjW2LT5P3pl9LwNcgpAbCYw0z/T+j86
ypori9cLQL0gflb/Cfw/lpOs9xIqDUCTvMaj8yv9Pw4alcoYNg5AT3Y1d0Bm
/j+pB2LLtyIPQLClAv7Nmv8/NnA5bbjSD0BLO2UnSF0AQFrcILXmpw9AsTLc
klX5AED+sDHBQukOQNp6UGP9igFAbZ+lR/sLDkD10dd20SgCQNHi3Mj38wxA
42MO5MXDAkAZdr6AZb8LQJRGQrZUVANArv7zEMKHCkA4OInLD/EDQLBlMO3M
IglAnnrNRWWDBEA3d8OX6skHQNf3wBnbEgVAD3D3ndNyBkADhMcwfa4FQHOK
7Wak/wRA8WDLrLk/BkC/MhCgYawDQNJM4msi3QZAwss/TmVLAkCGc6iEq3cH
QIsIg92+BgFA/OprAs8HCECrPCvgePD/P2VxQsMepAhAKXVLE0Xg/j+RSBbp
CDYJQPRz0a7WJ/4/kFqZaBPFCUDN4sX5uLj9P4J7LytKYApAvh1MbRmT/T82
7cJSG/EKQHzT1YZwwv0/3W1pvRiOC0B2LZ/10lT+P0c/DY2wIAxAVrX8MJA7
/z+DS2C2aLAMQElWzbMzPQBAsmbGIk1MDUCi9bAadCABQKTSKfTL3Q1AYexd
q+EpAkCJTaAId3sOQFyS/ndEhgNAQAPGdkIWD0BHWcLdahwFQLoJ6Umopg9A
vd1CiejSBkCTjw8wnSEQQPiVkXD08QhAq0KpbbNqEEBsk2Azxi4LQCyTGthZ
shBAYCBYjj+gDUAnaxVkFgARQMwfdA9ySBBAg+uOIqBIEUBj/5rHgMsRQNFn
q5SZmRFAL++xNeOlE0Dwt3AR
                 "]]}}}, AspectRatio -> 1, Axes -> False, Background -> 
             GrayLevel[0.93], Frame -> True, FrameStyle -> Directive[
               GrayLevel[0.7], 
               Thickness[Tiny]], FrameTicks -> None, ImageSize -> {Automatic, 
               Dynamic[
               3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])]}, PlotRange -> {{0, 5}, {0, 5}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.025`", ",", "0.9999999999999999`"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"0.025`", ",", "0.9999999999999999`"}], "}"}]}], 
                    "}"}], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"scalar\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"Hermite\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["False", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel"],
    DynamicModuleValues:>{}], "]"}],
  InterpolatingFunction[{{0.025, 0.9999999999999999}, {0.025, 
   0.9999999999999999}}, {
   5, 7, 0, {40, 40}, {3, 3}, 0, 0, 0, 0, Automatic, {}, {}, 
    False}, CompressedData["
1:eJzt0MsJwkAUheHBTty5t4DTgyUIurUe7cC1K3cBISAoIoooSogxxqh5lODj
zt+BWw8Mw8x898LcZnfQ6TWcc9/V+qzR0CK/j9W2TDhP5SwB9zP1LaF82VwL
H70sK+7X+I2W9rylbke/Pe6AO+JOuAgX0z/Gn3lPqLvgUupT3BWX4W64nH45
7o574J64AlfgSlyFq/lvrf/8fpvfG33uMKU=
   "], {Developer`PackedArrayForm, CompressedData["
1:eJwd2FMMGMoSANBb27Zt2+atbdu2bbu9tW3btm3beKdvkpNMMn+b7M7OJGjQ
tkKbAP/880+BoP/8P/7mAQlEYILwtxSM4IQgJKEITRjCEo7wRCAikYhMFKIS
jejEICaxiE0c4hKP+CQgIYlITBKSkozkpCAlqUhNGtKSjvRkICOZyEwWspKN
7OQgJ7nITR7yko/8f8+BghSiMEUoSjGKU4KSlKI0ZSjLv5SjPBWoSCUqU4Wq
VKM6NahJLWpTh7rUoz4NaEgjGtOEpjSjOS1oSSta04a2tKM9HehIJzrTha50
ozs96EkvetOHvvSjPwMYyCAGM4ShDGM4IxjJKEYzhrGMYzwTmMgkJjOFqUxj
OjOYySxmM4e5zOM/5rOAhSxiMUtYyjKWs4KVrGI1a1jLOtazgY1sYjNb2Mo2
trODnexiN3vYyz72c4CDHOIwRzjKMY5zgpOc4jRnOMs5znOBi1ziMle4yjWu
c4Ob3OI2d7jLPe7zgIc84jFPeMoznvOCl7ziNW94yzve84GPfOIzX/jKN77z
g5/84jd/+Hv5AxCQQAQmCEEJRnBCEJJQhCYMYQlHeCIQkUhEJgpRiUZ0YhCT
WMQmDnGJR3wSkJBEJCYJSUlGclKQklSkJg1pSUd6MpCRTGQmC1nJRnZykJNc
5CYPeclHfgpQkEIUpghFKUZxSlCSUpSmDGX5l3KUpwIVqURlqlCValSnBjWp
RW3qUJd61KcBDWlEY5rQlGY0pwUtaUVr/j7gbWlHezrQkU50pgtd6UZ3etCT
XvSmD33pR38GMJBBDGYIQxnGcEYwklGMZgxjGcd4JjCRSUxmClOZxnRmMJNZ
zGYOc5nHf8xnAQtZxGKWsJRlLGcFK1nFatawlnWsZwMb2cRmtrCVbWxnBzvZ
xW72sJd97OcABznEYY5wlGMc5wQnOcVpznCWc5znAhe5xGWucJVrXOcGN7nF
be5wl3vc5wEPecRjnvCUZzznBS95xWve8JZ3vOcDH/nEZ77wlW985wc/+cVv
/vC38QcgIIEITBCCEozghCAkoQhNGMISjvBEICKRiEwUohKN6MQgJrGITRzi
Eo/4JCAhiUhMEpKSjOSkICWpSE0a0pKO9GQgI5nITBayko3s5CAnuchNHvKS
j/wUoCCFKEwRilKM4pSgJKUoTRnK8i/lKE8FKlKJylShKtWoTg1qUova1KEu
9ahPAxrSiMY0oSnNaE4LWtKK1rShLe1oTwc60onOdKEr3ehOD3rSi970oS/9
6M8ABjKIwQxhKMMYzghGMorRjGEs4xjPBCYyiclMYSrTmM4MZjKL2cxhLvP4
j/ksYCGLWMwSlrKM5axgJatYzRrWso71bGAjm9jMFrayje3sYCe72M0e9rKP
/RzgIIc4zBGOcozjnOAkpzjNGc5yjvNc4CKXuMwVrnKN69zgJre4zR3uco/7
POAhj3jME57yjOe84CWveM0b3vKO93zgI5/4zBe+8o3v/OAnv/jNH/5++gMQ
kEAEJghBCUZwQhCSUIQmDGEJR3giEJFIRCYKUYlGdGIQk1jEJg5xiUd8EpCQ
RCQmCUlJRnJSkJJUpCYNaUlHejKQkUxkJgtZyUZ2cpCTXOQmD3nJR34KUJBC
FKYIRSlGcUpQklKUpgxl+ZdylKcCFalEZapQlWpUpwY1qUVt6lCXetSnAQ1p
RGOa0JRmNKcFLWlFa9rQlna0pwMd6URnutCVbnSnBz3pRW/60Jd+9GcAAxnE
YIYwlGEMZwQjGcVoxjCWcYxnAhOZxGSmMJVpTGcGM5nFbOYwl3n8x3wWsJBF
LGYJS1nGclawklWsZg1rWcd6NrCRTWxmC1vZxnZ2sJNd7GYPe9nHfg5wkEMc
5ghHOcZxTnCSU5zmDGc5x3kucJFLXOYKV7nGdW5wk1vc5g53ucd9HvCQRzzm
CU95xnNe8JJXvOYNb3nHez7wkU985gtf+cZ3fvCTX/zmD38H/gAEJBCBCUJQ
ghGcEIQkFKEJQ1jCEZ4IRCQSkYlCVKIRnRjEJBaxiUNc4hGfBCQkEYlJQlKS
kZwUpCQVqUlDWtKRngxkJBOZyUJWspGdHOQkF7nJQ17ykZ8CFKQQhSlCUYpR
nBKUpBSlKUNZ/qUc5alARSpRmSpUpRrVqUFNalGbOtSlHvVpQEMa0ZgmNKUZ
zWlBS1rRmja0pR3t6UBHOtGZLnSlG93pQU960Zs+9KUf/RnAQAYxmCEMZRjD
GcFIRjGaMYxlHOOZwEQmMZkpTGUa05nBTGYxmznMZR7/MZ8FLGQRi1nCUpax
nBWsZBWrWcNa1rGeDWxkE5vZwla2sZ0d7GQXu9nDXvaxnwMc5BCHOcJRjnGc
E5zkFKc5w1nOcZ4LXOQSl7nCVa5xnRvc5Ba3ucNd7nGfBzzkEY95wlOe8ZwX
vOQVr3nDW97xng985BOf+cJXvvGdH/zkF7/5w99lXwACEojABCEowQhOCEIS
itCEISzhCE8EIhKJyEQhKtGITgxiEovYxCEu8YhPAhKSiMQkISnJSE4KUpKK
1KQhLelITwYykonMZCEr2chODnKSi9zkIS/5yE8BClKIwhShKMUoTglKUorS
lKEs/1KO8lSgIpWoTBWqUo3q1KAmtahNHepSj/o0oCGNaEwTmtKM5rSgJa1o
TRva0o72dKAjnehMF7rSje70oCe96E0f+tKP/gxgIIMYzBCGMozhjGAkoxjN
GMYyjvFMYCKTmMwUpjKN6cxgJrOYzRzmMo//mM8CFrKIxSxhKctYzgpWsorV
rGEt61jPBjayic1sYSvb2M4OdrKL3exhL/vYzwEOcojDHOEoxzjOCU5yitOc
4SznOM8FLnKJy1zhKte4zg1ucovb3OEu97jPAx7yiMc84SnPeM4LXvKK17zh
Le94zwc+8onPfOEr3/jOD37yi9/84e+iPwABCURgghCUYAQnBCEJRWjCEJZw
hCcCEYlEZKIQlWhEJwYxiUVs4hCXeMQnAQlJRGKSkJRkJCcFKUlFatKQlnSk
JwMZyURmspCVbGQnBznJRW7ykJd85Od/oBYXzg==
    "], CompressedData["
1:eJxNWndcTu8bLtrvOhqSpESiIiNklLtERQghychIUbREpYiMUlZGEUVUElIa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    "]}, {Automatic, Automatic}],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{
  3.680276090145027*^9, 3.680276125566363*^9, 3.680277710263952*^9, 
   3.68027817337766*^9, 3.680278877435465*^9, {3.680278973587251*^9, 
   3.680278984414102*^9}, 3.6802846843198614`*^9, 3.816704417762062*^9, 
   3.816704492482462*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"608df5a2-08cc-4b62-81bb-31145e579ddd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"cv", "[", 
    RowBox[{
     RowBox[{"r_", "?", "NumericQ"}], ",", "k_"}], "]"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"m", "=", 
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"r", "^", "2"}], "/", 
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{"r", "^", "2"}]}], ")"}]}], "+", 
          RowBox[{"k", "^", "2"}]}], "]"}]}], ",", 
       RowBox[{"phi", "=", 
        RowBox[{"ArcTan", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"k", " ", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"1", "-", 
              RowBox[{"r", "^", "2"}]}], "]"}]}], ")"}], "/", "r"}], 
         "]"}]}]}], "}"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"Log", "[", "m", "]"}], "+", 
         RowBox[{"Log", "[", "200", "]"}]}], 
        RowBox[{"2", " ", 
         RowBox[{"Log", "[", "200", "]"}]}]], ",", 
       RowBox[{"phi", "/", 
        RowBox[{"(", 
         RowBox[{"Pi", "/", "2"}], ")"}]}]}], "]"}]}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.680276133299838*^9, 3.680276133935529*^9}, {
   3.680276225418919*^9, 3.6802763419860425`*^9}, {3.6802763736111813`*^9, 
   3.6802764054990644`*^9}, {3.680276632712514*^9, 3.680276745468498*^9}, {
   3.680276889300146*^9, 3.6802769553077574`*^9}, {3.680277231613946*^9, 
   3.680277251004743*^9}, {3.6802773139009643`*^9, 3.680277318316716*^9}, {
   3.680277693669625*^9, 3.6802777335004807`*^9}, 3.6802778059166603`*^9, {
   3.6802778499814825`*^9, 3.680277869116851*^9}, {3.6802779801096354`*^9, 
   3.680277984429101*^9}, {3.680278066413269*^9, 3.6802780734208856`*^9}, {
   3.680278108269631*^9, 3.680278115101808*^9}, {3.6802788883655214`*^9, 
   3.6802788886052094`*^9}, 3.680278951613824*^9, 3.6802791279818993`*^9, 
   3.6802794572697587`*^9},
 CellLabel->"In[3]:=",ExpressionUUID->"08afb1a4-3625-4f10-ba16-6c8a9f09f48a"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   RowBox[{
    TagBox["InterpolatingFunction",
     "SummaryHead"], "[", 
    DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
     TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquarePlusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
               Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 3.5 CurrentValue["FontCapHeight"]/
                 AbsoluteCurrentValue[Magnification]}]], 
             GraphicsBox[{{
                GrayLevel[0.6], 
                AbsolutePointSize[5], 
                PointBox[{1, 1}], 
                PointBox[{2, 4}], 
                PointBox[{3, 2}], 
                PointBox[{4, 3}]}, {{}, {}, {
                 AbsoluteThickness[1], 
                 Opacity[1.], 
                 LineBox[CompressedData["
1:eJwBMQPO/CFib1JlAgAAADIAAAACAAAA4ScLwZmZ6T/ACPskWpOYv4AjHgZ5
3Os/cnpQh5xu1j/qWn1XCVDuP5K7ih5ptuc/r+pongFN8D/CUK87BHLxP46d
cUQ/bPE/ujUa8/qu9j9TbqBw1aPyP/TWyyAhFfw/neDJZqDG8z+QAqdF9GsA
QM1wGePDAfU/VsVD/9nXAkCidscSKDf2P6Bp73exDQVA/B1wDMFX9z+TpM3k
wfUGQDzjPoyykPg/7M3Z+O7ZCEABSgjW2LT5P3pl9LwNcgpAbCYw0z/T+j86
ypori9cLQL0gflb/Cfw/lpOs9xIqDUCTvMaj8yv9Pw4alcoYNg5AT3Y1d0Bm
/j+pB2LLtyIPQLClAv7Nmv8/NnA5bbjSD0BLO2UnSF0AQFrcILXmpw9AsTLc
klX5AED+sDHBQukOQNp6UGP9igFAbZ+lR/sLDkD10dd20SgCQNHi3Mj38wxA
42MO5MXDAkAZdr6AZb8LQJRGQrZUVANArv7zEMKHCkA4OInLD/EDQLBlMO3M
IglAnnrNRWWDBEA3d8OX6skHQNf3wBnbEgVAD3D3ndNyBkADhMcwfa4FQHOK
7Wak/wRA8WDLrLk/BkC/MhCgYawDQNJM4msi3QZAwss/TmVLAkCGc6iEq3cH
QIsIg92+BgFA/OprAs8HCECrPCvgePD/P2VxQsMepAhAKXVLE0Xg/j+RSBbp
CDYJQPRz0a7WJ/4/kFqZaBPFCUDN4sX5uLj9P4J7LytKYApAvh1MbRmT/T82
7cJSG/EKQHzT1YZwwv0/3W1pvRiOC0B2LZ/10lT+P0c/DY2wIAxAVrX8MJA7
/z+DS2C2aLAMQElWzbMzPQBAsmbGIk1MDUCi9bAadCABQKTSKfTL3Q1AYexd
q+EpAkCJTaAId3sOQFyS/ndEhgNAQAPGdkIWD0BHWcLdahwFQLoJ6Umopg9A
vd1CiejSBkCTjw8wnSEQQPiVkXD08QhAq0KpbbNqEEBsk2Azxi4LQCyTGthZ
shBAYCBYjj+gDUAnaxVkFgARQMwfdA9ySBBAg+uOIqBIEUBj/5rHgMsRQNFn
q5SZmRFAL++xNeOlE0Dwt3AR
                  "]]}}}, AspectRatio -> 1, Axes -> False, Background -> 
              GrayLevel[0.93], Frame -> True, FrameStyle -> Directive[
                GrayLevel[0.7], 
                Thickness[Tiny]], FrameTicks -> None, ImageSize -> {Automatic, 
                Dynamic[
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])]}, PlotRange -> {{0, 5}, {0, 5}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.025`", ",", "0.9999999999999999`"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"0.025`", ",", "0.9999999999999999`"}], "}"}]}], 
                    "}"}], "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}], True -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquareMinusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = False), Appearance -> None,
                Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 3.5 CurrentValue["FontCapHeight"]/
                 AbsoluteCurrentValue[Magnification]}]], 
             GraphicsBox[{{
                GrayLevel[0.6], 
                AbsolutePointSize[5], 
                PointBox[{1, 1}], 
                PointBox[{2, 4}], 
                PointBox[{3, 2}], 
                PointBox[{4, 3}]}, {{}, {}, {
                 AbsoluteThickness[1], 
                 Opacity[1.], 
                 LineBox[CompressedData["
1:eJwBMQPO/CFib1JlAgAAADIAAAACAAAA4ScLwZmZ6T/ACPskWpOYv4AjHgZ5
3Os/cnpQh5xu1j/qWn1XCVDuP5K7ih5ptuc/r+pongFN8D/CUK87BHLxP46d
cUQ/bPE/ujUa8/qu9j9TbqBw1aPyP/TWyyAhFfw/neDJZqDG8z+QAqdF9GsA
QM1wGePDAfU/VsVD/9nXAkCidscSKDf2P6Bp73exDQVA/B1wDMFX9z+TpM3k
wfUGQDzjPoyykPg/7M3Z+O7ZCEABSgjW2LT5P3pl9LwNcgpAbCYw0z/T+j86
ypori9cLQL0gflb/Cfw/lpOs9xIqDUCTvMaj8yv9Pw4alcoYNg5AT3Y1d0Bm
/j+pB2LLtyIPQLClAv7Nmv8/NnA5bbjSD0BLO2UnSF0AQFrcILXmpw9AsTLc
klX5AED+sDHBQukOQNp6UGP9igFAbZ+lR/sLDkD10dd20SgCQNHi3Mj38wxA
42MO5MXDAkAZdr6AZb8LQJRGQrZUVANArv7zEMKHCkA4OInLD/EDQLBlMO3M
IglAnnrNRWWDBEA3d8OX6skHQNf3wBnbEgVAD3D3ndNyBkADhMcwfa4FQHOK
7Wak/wRA8WDLrLk/BkC/MhCgYawDQNJM4msi3QZAwss/TmVLAkCGc6iEq3cH
QIsIg92+BgFA/OprAs8HCECrPCvgePD/P2VxQsMepAhAKXVLE0Xg/j+RSBbp
CDYJQPRz0a7WJ/4/kFqZaBPFCUDN4sX5uLj9P4J7LytKYApAvh1MbRmT/T82
7cJSG/EKQHzT1YZwwv0/3W1pvRiOC0B2LZ/10lT+P0c/DY2wIAxAVrX8MJA7
/z+DS2C2aLAMQElWzbMzPQBAsmbGIk1MDUCi9bAadCABQKTSKfTL3Q1AYexd
q+EpAkCJTaAId3sOQFyS/ndEhgNAQAPGdkIWD0BHWcLdahwFQLoJ6Umopg9A
vd1CiejSBkCTjw8wnSEQQPiVkXD08QhAq0KpbbNqEEBsk2Azxi4LQCyTGthZ
shBAYCBYjj+gDUAnaxVkFgARQMwfdA9ySBBAg+uOIqBIEUBj/5rHgMsRQNFn
q5SZmRFAL++xNeOlE0Dwt3AR
                  "]]}}}, AspectRatio -> 1, Axes -> False, Background -> 
              GrayLevel[0.93], Frame -> True, FrameStyle -> Directive[
                GrayLevel[0.7], 
                Thickness[Tiny]], FrameTicks -> None, ImageSize -> {Automatic, 
                Dynamic[
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])]}, PlotRange -> {{0, 5}, {0, 5}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.025`", ",", "0.9999999999999999`"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"0.025`", ",", "0.9999999999999999`"}], "}"}]}], 
                    "}"}], "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"2", ",", "2"}], "}"}], "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["False", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}]}, 
        Dynamic[Typeset`open$$], ImageSize -> Automatic]},
      "SummaryPanel"],
     DynamicModuleValues:>{}], "]"}],
   InterpolatingFunction[{{0.025, 0.9999999999999999}, {0.025, 
    0.9999999999999999}}, {
    5, 7, 0, {40, 40}, {3, 3}, 0, 0, 0, 0, Automatic, {}, {}, 
     False}, CompressedData["
1:eJzt0MsJwkAUheHBTty5t4DTgyUIurUe7cC1K3cBISAoIoooSogxxqh5lODj
zt+BWw8Mw8x898LcZnfQ6TWcc9/V+qzR0CK/j9W2TDhP5SwB9zP1LaF82VwL
H70sK+7X+I2W9rylbke/Pe6AO+JOuAgX0z/Gn3lPqLvgUupT3BWX4W64nH45
7o574J64AlfgSlyFq/lvrf/8fpvfG33uMKU=
    "], {Developer`PackedArrayForm, CompressedData["
1:eJwd2FMMGMoSANBb27Zt2+atbdu2bbu9tW3btm3beKdvkpNMMn+b7M7OJGjQ
tkKbAP/880+BoP/8P/7mAQlEYILwtxSM4IQgJKEITRjCEo7wRCAikYhMFKIS
jejEICaxiE0c4hKP+CQgIYlITBKSkozkpCAlqUhNGtKSjvRkICOZyEwWspKN
7OQgJ7nITR7yko/8f8+BghSiMEUoSjGKU4KSlKI0ZSjLv5SjPBWoSCUqU4Wq
VKM6NahJLWpTh7rUoz4NaEgjGtOEpjSjOS1oSSta04a2tKM9HehIJzrTha50
ozs96EkvetOHvvSjPwMYyCAGM4ShDGM4IxjJKEYzhrGMYzwTmMgkJjOFqUxj
OjOYySxmM4e5zOM/5rOAhSxiMUtYyjKWs4KVrGI1a1jLOtazgY1sYjNb2Mo2
trODnexiN3vYyz72c4CDHOIwRzjKMY5zgpOc4jRnOMs5znOBi1ziMle4yjWu
c4Ob3OI2d7jLPe7zgIc84jFPeMoznvOCl7ziNW94yzve84GPfOIzX/jKN77z
g5/84jd/+Hv5AxCQQAQmCEEJRnBCEJJQhCYMYQlHeCIQkUhEJgpRiUZ0YhCT
WMQmDnGJR3wSkJBEJCYJSUlGclKQklSkJg1pSUd6MpCRTGQmC1nJRnZykJNc
5CYPeclHfgpQkEIUpghFKUZxSlCSUpSmDGX5l3KUpwIVqURlqlCValSnBjWp
RW3qUJd61KcBDWlEY5rQlGY0pwUtaUVr/j7gbWlHezrQkU50pgtd6UZ3etCT
XvSmD33pR38GMJBBDGYIQxnGcEYwklGMZgxjGcd4JjCRSUxmClOZxnRmMJNZ
zGYOc5nHf8xnAQtZxGKWsJRlLGcFK1nFatawlnWsZwMb2cRmtrCVbWxnBzvZ
xW72sJd97OcABznEYY5wlGMc5wQnOcVpznCWc5znAhe5xGWucJVrXOcGN7nF
be5wl3vc5wEPecRjnvCUZzznBS95xWve8JZ3vOcDH/nEZ77wlW985wc/+cVv
/vC38QcgIIEITBCCEozghCAkoQhNGMISjvBEICKRiEwUohKN6MQgJrGITRzi
Eo/4JCAhiUhMEpKSjOSkICWpSE0a0pKO9GQgI5nITBayko3s5CAnuchNHvKS
j/wUoCCFKEwRilKM4pSgJKUoTRnK8i/lKE8FKlKJylShKtWoTg1qUova1KEu
9ahPAxrSiMY0oSnNaE4LWtKK1rShLe1oTwc60onOdKEr3ehOD3rSi970oS/9
6M8ABjKIwQxhKMMYzghGMorRjGEs4xjPBCYyiclMYSrTmM4MZjKL2cxhLvP4
j/ksYCGLWMwSlrKM5axgJatYzRrWso71bGAjm9jMFrayje3sYCe72M0e9rKP
/RzgIIc4zBGOcozjnOAkpzjNGc5yjvNc4CKXuMwVrnKN69zgJre4zR3uco/7
POAhj3jME57yjOe84CWveM0b3vKO93zgI5/4zBe+8o3v/OAnv/jNH/5++gMQ
kEAEJghBCUZwQhCSUIQmDGEJR3giEJFIRCYKUYlGdGIQk1jEJg5xiUd8EpCQ
RCQmCUlJRnJSkJJUpCYNaUlHejKQkUxkJgtZyUZ2cpCTXOQmD3nJR34KUJBC
FKYIRSlGcUpQklKUpgxl+ZdylKcCFalEZapQlWpUpwY1qUVt6lCXetSnAQ1p
RGOa0JRmNKcFLWlFa9rQlna0pwMd6URnutCVbnSnBz3pRW/60Jd+9GcAAxnE
YIYwlGEMZwQjGcVoxjCWcYxnAhOZxGSmMJVpTGcGM5nFbOYwl3n8x3wWsJBF
LGYJS1nGclawklWsZg1rWcd6NrCRTWxmC1vZxnZ2sJNd7GYPe9nHfg5wkEMc
5ghHOcZxTnCSU5zmDGc5x3kucJFLXOYKV7nGdW5wk1vc5g53ucd9HvCQRzzm
CU95xnNe8JJXvOYNb3nHez7wkU985gtf+cZ3fvCTX/zmD38H/gAEJBCBCUJQ
ghGcEIQkFKEJQ1jCEZ4IRCQSkYlCVKIRnRjEJBaxiUNc4hGfBCQkEYlJQlKS
kZwUpCQVqUlDWtKRngxkJBOZyUJWspGdHOQkF7nJQ17ykZ8CFKQQhSlCUYpR
nBKUpBSlKUNZ/qUc5alARSpRmSpUpRrVqUFNalGbOtSlHvVpQEMa0ZgmNKUZ
zWlBS1rRmja0pR3t6UBHOtGZLnSlG93pQU960Zs+9KUf/RnAQAYxmCEMZRjD
GcFIRjGaMYxlHOOZwEQmMZkpTGUa05nBTGYxmznMZR7/MZ8FLGQRi1nCUpax
nBWsZBWrWcNa1rGeDWxkE5vZwla2sZ0d7GQXu9nDXvaxnwMc5BCHOcJRjnGc
E5zkFKc5w1nOcZ4LXOQSl7nCVa5xnRvc5Ba3ucNd7nGfBzzkEY95wlOe8ZwX
vOQVr3nDW97xng985BOf+cJXvvGdH/zkF7/5w99lXwACEojABCEowQhOCEIS
itCEISzhCE8EIhKJyEQhKtGITgxiEovYxCEu8YhPAhKSiMQkISnJSE4KUpKK
1KQhLelITwYykonMZCEr2chODnKSi9zkIS/5yE8BClKIwhShKMUoTglKUorS
lKEs/1KO8lSgIpWoTBWqUo3q1KAmtahNHepSj/o0oCGNaEwTmtKM5rSgJa1o
TRva0o72dKAjnehMF7rSje70oCe96E0f+tKP/gxgIIMYzBCGMozhjGAkoxjN
GMYyjvFMYCKTmMwUpjKN6cxgJrOYzRzmMo//mM8CFrKIxSxhKctYzgpWsorV
rGEt61jPBjayic1sYSvb2M4OdrKL3exhL/vYzwEOcojDHOEoxzjOCU5yitOc
4SznOM8FLnKJy1zhKte4zg1ucovb3OEu97jPAx7yiMc84SnPeM4LXvKK17zh
Le94zwc+8onPfOEr3/jOD37yi9/84e+iPwABCURgghCUYAQnBCEJRWjCEJZw
hCcCEYlEZKIQlWhEJwYxiUVs4hCXeMQnAQlJRGKSkJRkJCcFKUlFatKQlnSk
JwMZyURmspCVbGQnBznJRW7ykJd85Od/oBYXzg==
     "], CompressedData["
1:eJxNWndcTu8bLtrvOhqSpESiIiNklLtERQghychIUbREpYiMUlZGEUVUElIa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     "]}, {Automatic, Automatic}],
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"Log", "[", "200", "]"}], "+", 
     RowBox[{"Log", "[", 
      SqrtBox[
       RowBox[{
        SuperscriptBox["k", "2"], "+", 
        FractionBox[
         SuperscriptBox["r", "2"], 
         RowBox[{"1", "-", 
          SuperscriptBox["r", "2"]}]]}]], "]"}]}], 
    RowBox[{"2", " ", 
     RowBox[{"Log", "[", "200", "]"}]}]], ",", 
   FractionBox[
    RowBox[{"2", " ", 
     RowBox[{"ArcTan", "[", 
      FractionBox[
       RowBox[{"k", " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["r", "2"]}]]}], "r"], "]"}]}], "\[Pi]"]}], 
  "]"}]], "Output",
 CellChangeTimes->{
  3.680276745889617*^9, {3.680276894002657*^9, 3.680276907052389*^9}, {
   3.680276941529128*^9, 3.680276955977539*^9}, {3.6802772461598268`*^9, 
   3.6802772513205814`*^9}, 3.6802773195289288`*^9, {3.6802777151168633`*^9, 
   3.6802777337441454`*^9}, 3.6802778063678603`*^9, {3.6802778502943554`*^9, 
   3.680277869402583*^9}, 3.680277984843269*^9, {3.680278066862446*^9, 
   3.680278073770916*^9}, {3.6802781105778313`*^9, 3.680278115667384*^9}, 
   3.6802781780661325`*^9, {3.6802788807783604`*^9, 3.6802788890002403`*^9}, {
   3.6802789530526533`*^9, 3.6802789871814184`*^9}, 3.6802791286917596`*^9, 
   3.6802846875273943`*^9, 3.8167044256409316`*^9, 3.8167044972195654`*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"2ff4ab2a-0c45-4a32-8c29-d0ee9a1cc470"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"style", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "1.0", "]"}], ",", "Black"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "1.0", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], "]"}], ",", "Black"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"8", ",", "2"}], "}"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "1.0", "]"}], ",", "Black"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"8", ",", "0"}], "}"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", ".8", "]"}], ",", "Black"}], "}"}]}],
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"p", "=", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"cv", "[", 
       RowBox[{"0.5", ",", "k"}], "]"}], ",", 
      RowBox[{"cv", "[", 
       RowBox[{"0.95", ",", "k"}], "]"}], ",", 
      RowBox[{"cv", "[", 
       RowBox[{"0.99", ",", "k"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "0", ",", "10"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2.8", ",", "4.2"}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", "style"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times New Roman\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "12"}]}], "}"}]}], ",", 
    RowBox[{"AxesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"AbsoluteThickness", "[", ".8", "]"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"AbsoluteThickness", "[", ".8", "]"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "250"}]}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6802794602537417`*^9, 3.680279542446396*^9}, {
  3.6802846978869524`*^9, 3.680284706432686*^9}, {3.6802851381804085`*^9, 
  3.6802851705123873`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"32d18162-e3f1-4b86-ad66-a9f242aae1f4"],

Cell[BoxData[
 TemplateBox[{
  "InterpolatingFunction","dmval",
   "\"Input value \\!\\(\\*RowBox[{\\\"{\\\", RowBox[{\\\"0.4481622141773509`\
\\\", \\\",\\\", \\\"0.00022525722501460802`\\\"}], \\\"}\\\"}]\\) lies \
outside the range of data in the interpolating function. Extrapolation will \
be used.\"",2,5,1,28487392231707643097,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.6802847080249214`*^9, {3.6802851547244253`*^9, 3.68028517191512*^9}, 
   3.816704499955086*^9},
 CellLabel->
  "During evaluation of \
In[4]:=",ExpressionUUID->"1ec9e4fb-c458-41ce-a6cd-2d393ed210fb"],

Cell[BoxData[
 TemplateBox[{
  "InterpolatingFunction","dmval",
   "\"Input value \\!\\(\\*RowBox[{\\\"{\\\", RowBox[{\\\"0.6050010863242036`\
\\\", \\\",\\\", \\\"0.00004274613198066354`\\\"}], \\\"}\\\"}]\\) lies \
outside the range of data in the interpolating function. Extrapolation will \
be used.\"",2,5,2,28487392231707643097,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.6802847080249214`*^9, {3.6802851547244253`*^9, 3.68028517191512*^9}, 
   3.8167044999894447`*^9},
 CellLabel->
  "During evaluation of \
In[4]:=",ExpressionUUID->"8f171c43-e82f-41c7-87e3-25ebc69dda1b"],

Cell[BoxData[
 TemplateBox[{
  "InterpolatingFunction","dmval",
   "\"Input value \\!\\(\\*RowBox[{\\\"{\\\", RowBox[{\\\"0.6838760594540867`\
\\\", \\\",\\\", \\\"0.000018531452633959196`\\\"}], \\\"}\\\"}]\\) lies \
outside the range of data in the interpolating function. Extrapolation will \
be used.\"",2,5,3,28487392231707643097,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.6802847080249214`*^9, {3.6802851547244253`*^9, 3.68028517191512*^9}, 
   3.8167045000959764`*^9},
 CellLabel->
  "During evaluation of \
In[4]:=",ExpressionUUID->"051a8da8-486e-41f3-9b2c-f0a1fc71355f"],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"InterpolatingFunction\\\
\", \\\"::\\\", \\\"dmval\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,5,4,28487392231707643097,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.6802847080249214`*^9, {3.6802851547244253`*^9, 3.68028517191512*^9}, 
   3.8167045001119547`*^9},
 CellLabel->
  "During evaluation of \
In[4]:=",ExpressionUUID->"8aa40cd3-8163-43f6-bd0c-f6ed72ef59ff"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.], Opacity[1.], 
      LineBox[CompressedData["
1:eJwd23c8lt0bAHB7P489Mx4jFFGSVTlXVhIlm4yiUDKLkJasFCErovGSdhEV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       "]]},
     Annotation[#, "Charting`Private`Tag$2892#1"]& ], 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.], Opacity[1.], 
      AbsoluteDashing[{2, 2}], LineBox[CompressedData["
1:eJwc23c81d8fB3BZ2fe6xsXFvRchpIyK1n0nI5JkZISQ0LCSiErJCMnIllH4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       "]]},
     Annotation[#, "Charting`Private`Tag$2892#2"]& ], 
    TagBox[
     {GrayLevel[0], AbsoluteThickness[1.], Opacity[1.], 
      AbsoluteDashing[{8, 2}], LineBox[CompressedData["
1:eJwd13k4FW0bAPCkOtYclPU420iFlCIS5pYIiUqyK7sQWUOKUNZK8marlCgp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       "]]},
     Annotation[#, "Charting`Private`Tag$2892#3"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 2.8},
  AxesStyle->{{
     AbsoluteThickness[0.8]}, {
     AbsoluteThickness[0.8]}},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->250,
  LabelStyle->{FontFamily -> "Times New Roman", FontSize -> 12},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0., 9.999999795918367}, {2.8, 4.2}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.6802794727038484`*^9, 3.6802795438681817`*^9}, 
   3.6802847081642923`*^9, {3.6802851548487206`*^9, 3.6802851720374727`*^9}, 
   3.8167045004036903`*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"4013be4e-6647-4a15-969f-d8e105eb87f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<c:/dropbox/mystuff/sparsity/cvplot.pdf\>\"", ",", "p"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6802795479349704`*^9, 
  3.6802795570863447`*^9}},ExpressionUUID->"844265d3-4c6c-475f-a1f8-\
53df769235c5"],

Cell[BoxData["\<\"c:/dropbox/mystuff/sparsity/cvplot.pdf\"\>"], "Output",
 CellChangeTimes->{3.6802795605284843`*^9, 3.6802847146174583`*^9, 
  3.6802851753612866`*^9},ExpressionUUID->"41d1a9f6-b1d7-4421-8731-\
9c1a63fab8b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Si", "=", 
  RowBox[{"Inverse", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"r", "^", "2"}]}], ")"}]}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], "}"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x0", "=", 
   RowBox[{
    RowBox[{"Minimize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y1", ",", 
           RowBox[{"y2", "-", 
            RowBox[{"r", " ", "d"}]}]}], "}"}], ".", "Si", ".", 
         RowBox[{"{", 
          RowBox[{"y1", ",", 
           RowBox[{"y2", "-", 
            RowBox[{"r", " ", "d"}]}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "k"}], "<", "d", "<", " ", "k"}], "}"}]}], "}"}], ",", 
      "d"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x1", "=", 
   RowBox[{
    RowBox[{"Minimize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"y1", "-", "b"}], ",", 
           RowBox[{"y2", "-", 
            RowBox[{"r", " ", "d"}], "-", "b"}]}], "}"}], ".", "Si", ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"y1", "-", "b"}], ",", 
           RowBox[{"y2", "-", 
            RowBox[{"r", " ", "d"}], "-", "b"}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "k"}], "<", "d", "<", "k"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"d", ",", "b"}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"aa", "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     RowBox[{"x0", "-", "x1"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"0", "<", "r", "<", "1"}], ",", 
       RowBox[{"k", ">", "00"}], ",", 
       RowBox[{"y1", "!=", "0"}], ",", 
       RowBox[{"y2", "!=", "0"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"aax", "=", 
  RowBox[{"(", 
   RowBox[{"aa", "/.", 
    RowBox[{"y1", "\[Rule]", 
     RowBox[{"z1", "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"1", "-", 
        RowBox[{"r", "^", "2"}]}], "]"}]}]}]}], ")"}]}]}], "Input",
 CellChangeTimes->{{3.6802853956957397`*^9, 3.6802853980951405`*^9}, {
   3.816708703448748*^9, 3.8167087252147083`*^9}, 3.816708902734933*^9},
 CellLabel->"In[32]:=",ExpressionUUID->"da159c27-9395-4d73-960c-c85b444a3e27"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       FractionBox["1", 
        RowBox[{"1", "-", 
         SuperscriptBox["r", "2"]}]]}]], ",", 
     RowBox[{"-", 
      FractionBox["1", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["1", 
         RowBox[{"1", "-", 
          SuperscriptBox["r", "2"]}]]}]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        FractionBox["1", 
         RowBox[{"1", "-", 
          SuperscriptBox["r", "2"]}]]}]]}], ",", 
     FractionBox["1", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox["r", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox["1", 
          RowBox[{"1", "-", 
           SuperscriptBox["r", "2"]}]]}], ")"}]}]]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.680285484791723*^9, 3.816704435716273*^9, 
  3.816704506904915*^9, 3.816708728464978*^9, 3.8167089041287575`*^9},
 CellLabel->"Out[32]=",ExpressionUUID->"380d5192-caa3-4729-8ed6-01ba0cb14c7f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{"-", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["r", "2"]}], ")"}], " ", 
             SuperscriptBox["z1", "2"]}], 
            RowBox[{"1", "-", 
             SuperscriptBox["r", "2"]}]]}], 
          RowBox[{
           RowBox[{
            FractionBox["z1", 
             SqrtBox[
              RowBox[{"1", "-", 
               SuperscriptBox["r", "2"]}]]], "<", 
            RowBox[{"y2", "+", 
             RowBox[{"r", " ", 
              RowBox[{"(", 
               RowBox[{"k", "+", 
                FractionBox[
                 RowBox[{"r", " ", "z1"}], 
                 SqrtBox[
                  RowBox[{"1", "-", 
                   SuperscriptBox["r", "2"]}]]]}], ")"}]}]}]}], "&&", 
           RowBox[{
            RowBox[{"y2", "+", 
             FractionBox[
              RowBox[{
               SuperscriptBox["r", "2"], " ", "z1"}], 
              SqrtBox[
               RowBox[{"1", "-", 
                SuperscriptBox["r", "2"]}]]]}], "<", 
            RowBox[{
             RowBox[{"k", " ", "r"}], "+", 
             FractionBox["z1", 
              SqrtBox[
               RowBox[{"1", "-", 
                SuperscriptBox["r", "2"]}]]]}]}]}]},
         {
          FractionBox[
           RowBox[{
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["r", "2"]}], "+", 
            SuperscriptBox["y2", "2"], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox["r", "2"]}], ")"}], " ", "y2", " ", "z1"}], 
             SqrtBox[
              RowBox[{"1", "-", 
               SuperscriptBox["r", "2"]}]]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox["r", "2"]}], ")"}], " ", 
              SuperscriptBox["z1", "2"]}], 
             RowBox[{"1", "-", 
              SuperscriptBox["r", "2"]}]], "-", 
            RowBox[{"2", " ", "k", " ", "r", " ", 
             RowBox[{"(", 
              RowBox[{"y2", "+", 
               FractionBox[
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "1"}], "+", 
                   SuperscriptBox["r", "2"]}], ")"}], " ", "z1"}], 
                SqrtBox[
                 RowBox[{"1", "-", 
                  SuperscriptBox["r", "2"]}]]]}], ")"}]}]}], 
           SuperscriptBox["r", "2"]], 
          RowBox[{
           RowBox[{"y2", "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r", "2"], " ", "z1"}], 
             SqrtBox[
              RowBox[{"1", "-", 
               SuperscriptBox["r", "2"]}]]]}], "\[GreaterEqual]", 
           RowBox[{
            RowBox[{"k", " ", "r"}], "+", 
            FractionBox["z1", 
             SqrtBox[
              RowBox[{"1", "-", 
               SuperscriptBox["r", "2"]}]]]}]}]},
         {
          FractionBox[
           RowBox[{
            RowBox[{
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["r", "2"]}], "+", 
            SuperscriptBox["y2", "2"], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox["r", "2"]}], ")"}], " ", "y2", " ", "z1"}], 
             SqrtBox[
              RowBox[{"1", "-", 
               SuperscriptBox["r", "2"]}]]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                SuperscriptBox["r", "2"]}], ")"}], " ", 
              SuperscriptBox["z1", "2"]}], 
             RowBox[{"1", "-", 
              SuperscriptBox["r", "2"]}]], "+", 
            RowBox[{"2", " ", "k", " ", "r", " ", 
             RowBox[{"(", 
              RowBox[{"y2", "+", 
               FractionBox[
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "1"}], "+", 
                   SuperscriptBox["r", "2"]}], ")"}], " ", "z1"}], 
                SqrtBox[
                 RowBox[{"1", "-", 
                  SuperscriptBox["r", "2"]}]]]}], ")"}]}]}], 
           SuperscriptBox["r", "2"]], 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}},
        Selectable->True]}
     },
     GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False,
    StripWrapperBoxes->True], ")"}], "-", 
  RowBox[{"(", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{"-", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["r", "2"]}], ")"}], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", "r"}], "+", "y2", "-", 
                FractionBox["z1", 
                 SqrtBox[
                  RowBox[{"1", "-", 
                   SuperscriptBox["r", "2"]}]]]}], ")"}], "2"]}], 
            SuperscriptBox["r", "2"]]}], 
          RowBox[{
           RowBox[{
            RowBox[{"k", " ", "r"}], "+", "y2"}], "<", 
           FractionBox["z1", 
            SqrtBox[
             RowBox[{"1", "-", 
              SuperscriptBox["r", "2"]}]]]}]},
         {
          RowBox[{"-", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["r", "2"]}], ")"}], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"k", " ", "r"}], "-", "y2", "+", 
                FractionBox["z1", 
                 SqrtBox[
                  RowBox[{"1", "-", 
                   SuperscriptBox["r", "2"]}]]]}], ")"}], "2"]}], 
            SuperscriptBox["r", "2"]]}], 
          RowBox[{
           RowBox[{
            RowBox[{"k", " ", "r"}], "+", 
            FractionBox["z1", 
             SqrtBox[
              RowBox[{"1", "-", 
               SuperscriptBox["r", "2"]}]]]}], "<", "y2"}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}},
        Selectable->True]}
     },
     GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False,
    StripWrapperBoxes->True], ")"}]}]], "Output",
 CellChangeTimes->{3.680285484791723*^9, 3.816704435716273*^9, 
  3.816704506904915*^9, 3.816708728464978*^9, 3.8167089072246213`*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"1c0bd859-7f1a-4d2e-b361-1ec1b0655d85"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"style", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "1.0", "]"}], ",", "Black"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "1.0", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], "]"}], ",", "Black"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"8", ",", "2"}], "}"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "1.0", "]"}], ",", "Black"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"1", ",", "5"}], "}"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", "1.0", "]"}], ",", "Black"}], 
      "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6802870507690907`*^9, 3.680287082400325*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"a9c4345e-31c2-4484-84e7-2f90444ca2a0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"rx", "=", "0.95"}], "\[IndentingNewLine]", 
 RowBox[{"p", "=", 
  RowBox[{"ContourPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"aax", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"k", "\[Rule]", "0"}], ",", 
           RowBox[{"r", "\[Rule]", "rx"}]}], "}"}]}], ")"}], "==", 
       RowBox[{"cv", "[", 
        RowBox[{"rx", ",", "0"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"aax", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"k", "\[Rule]", "1"}], ",", 
           RowBox[{"r", "\[Rule]", "rx"}]}], "}"}]}], ")"}], "==", 
       RowBox[{"cv", "[", 
        RowBox[{"rx", ",", "1"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"aax", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"k", "\[Rule]", "3"}], ",", 
           RowBox[{"r", "\[Rule]", "rx"}]}], "}"}]}], ")"}], "\[Equal]", 
       RowBox[{"cv", "[", 
        RowBox[{"rx", ",", "3"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"aax", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"k", "\[Rule]", "10"}], ",", 
           RowBox[{"r", "\[Rule]", "rx"}]}], "}"}]}], ")"}], "\[Equal]", 
       RowBox[{"cv", "[", 
        RowBox[{"rx", ",", "10"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z1", ",", 
      RowBox[{"-", "7"}], ",", "7"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y2", ",", 
      RowBox[{"-", "13"}], ",", "13"}], "}"}], ",", 
    RowBox[{"ContourStyle", "\[Rule]", "style"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times New Roman\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "12"}]}], "}"}]}], ",", 
    RowBox[{"AxesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"AbsoluteThickness", "[", ".8", "]"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"AbsoluteThickness", "[", ".8", "]"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "250"}], ",", 
    RowBox[{"FrameStyle", "->", 
     RowBox[{"AbsoluteThickness", "[", ".8", "]"}]}]}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6802853862716417`*^9, 3.6802854823993764`*^9}, {
  3.6802856436187816`*^9, 3.680285837072138*^9}, {3.6802858756166997`*^9, 
  3.6802859182250185`*^9}, {3.6802859692668147`*^9, 3.6802859992966824`*^9}, {
  3.6802860566562967`*^9, 3.6802861065129237`*^9}, {3.6802861399689226`*^9, 
  3.680286176224371*^9}, {3.6802863228484135`*^9, 3.680286410848483*^9}, {
  3.6802864894244404`*^9, 3.680286489728219*^9}, {3.6802866934087*^9, 
  3.6802867067689953`*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"d127a92a-c15c-4d6e-846f-31d454ef3f18"],

Cell[BoxData["0.95`"], "Output",
 CellChangeTimes->{
  3.680285999925456*^9, {3.680286061041937*^9, 3.680286107554695*^9}, {
   3.6802861410257573`*^9, 3.6802861767848597`*^9}, {3.680286331714983*^9, 
   3.680286413184724*^9}, 3.6802864903839936`*^9, 3.680286708772298*^9, {
   3.680287064533255*^9, 3.680287085045616*^9}, 3.8167044499751067`*^9, 
   3.8167045402836213`*^9, 3.816708738464801*^9, 3.8167089234393935`*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"8f9c71ff-5af2-4c0a-8f21-db615bd7de52"],

Cell[BoxData[
 TemplateBox[{
  "InterpolatingFunction","dmval",
   "\"Input value \\!\\(\\*RowBox[{\\\"{\\\", RowBox[{\\\"0.6050010861114703`\
\\\", \\\",\\\", \\\"0.`\\\"}], \\\"}\\\"}]\\) lies outside the range of data \
in the interpolating function. Extrapolation will be used.\"",2,39,13,
   28487392231707643097,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.680285999960477*^9, {3.6802860610800724`*^9, 3.6802861075938053`*^9}, {
   3.680286141064811*^9, 3.680286176820956*^9}, {3.68028633175309*^9, 
   3.6802864132238007`*^9}, 3.680286490427078*^9, 3.680286708810398*^9, {
   3.6802870645733657`*^9, 3.6802870850867243`*^9}, 3.8167044532528152`*^9, 
   3.8167045410697575`*^9, 3.816708738621113*^9, 3.8167089236086493`*^9},
 CellLabel->
  "During evaluation of \
In[38]:=",ExpressionUUID->"6d54d0de-b009-46ed-a997-a7db5e1c5440"],

Cell[BoxData[
 TemplateBox[{
  "InterpolatingFunction","dmval",
   "\"Input value \\!\\(\\*RowBox[{\\\"{\\\", RowBox[{\\\"0.6050010861114703`\
\\\", \\\",\\\", \\\"0.`\\\"}], \\\"}\\\"}]\\) lies outside the range of data \
in the interpolating function. Extrapolation will be used.\"",2,39,14,
   28487392231707643097,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.680285999960477*^9, {3.6802860610800724`*^9, 3.6802861075938053`*^9}, {
   3.680286141064811*^9, 3.680286176820956*^9}, {3.68028633175309*^9, 
   3.6802864132238007`*^9}, 3.680286490427078*^9, 3.680286708810398*^9, {
   3.6802870645733657`*^9, 3.6802870850867243`*^9}, 3.8167044532528152`*^9, 
   3.8167045410697575`*^9, 3.816708738621113*^9, 3.8167089236275663`*^9},
 CellLabel->
  "During evaluation of \
In[38]:=",ExpressionUUID->"1422df95-2d39-40e0-a9d2-e9df3c751693"],

Cell[BoxData[
 TemplateBox[{
  "InterpolatingFunction","dmval",
   "\"Input value \\!\\(\\*RowBox[{\\\"{\\\", RowBox[{\\\"0.6050010861114703`\
\\\", \\\",\\\", \\\"0.`\\\"}], \\\"}\\\"}]\\) lies outside the range of data \
in the interpolating function. Extrapolation will be used.\"",2,39,15,
   28487392231707643097,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.680285999960477*^9, {3.6802860610800724`*^9, 3.6802861075938053`*^9}, {
   3.680286141064811*^9, 3.680286176820956*^9}, {3.68028633175309*^9, 
   3.6802864132238007`*^9}, 3.680286490427078*^9, 3.680286708810398*^9, {
   3.6802870645733657`*^9, 3.6802870850867243`*^9}, 3.8167044532528152`*^9, 
   3.8167045410697575`*^9, 3.816708738621113*^9, 3.816708925031145*^9},
 CellLabel->
  "During evaluation of \
In[38]:=",ExpressionUUID->"e23d7764-8195-4949-990e-627cd962cb18"],

Cell[BoxData[
 TemplateBox[{
  "General","stop",
   "\"Further output of \\!\\(\\*StyleBox[RowBox[{\\\"InterpolatingFunction\\\
\", \\\"::\\\", \\\"dmval\\\"}], \\\"MessageName\\\"]\\) will be suppressed \
during this calculation.\"",2,39,16,28487392231707643097,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.680285999960477*^9, {3.6802860610800724`*^9, 3.6802861075938053`*^9}, {
   3.680286141064811*^9, 3.680286176820956*^9}, {3.68028633175309*^9, 
   3.6802864132238007`*^9}, 3.680286490427078*^9, 3.680286708810398*^9, {
   3.6802870645733657`*^9, 3.6802870850867243`*^9}, 3.8167044532528152`*^9, 
   3.8167045410697575`*^9, 3.816708738621113*^9, 3.8167089250445986`*^9},
 CellLabel->
  "During evaluation of \
In[38]:=",ExpressionUUID->"7cf6c7f5-a3b6-4ac2-9758-4a75a70a6c55"],

Cell[BoxData[
 GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJxlXXdYVMfbXXpvu7ALu6CIiIqxd2Oc0dh77F1jN/ZeUcSusZfY8rP3Ents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    "], {{}, {}, 
     TagBox[
      TooltipBox[
       {GrayLevel[0], AbsoluteThickness[1.], 
        LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 
         18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 
         35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 
         52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 
         69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 
         86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 
         102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115,
          116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 128, 
         129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142,
          143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 
         156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169,
          170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 
         183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196,
          197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 
         210, 211, 212, 213, 214, 215}], LineBox[CompressedData["
1:eJwt0sVSFgAAhdEfG2zFTixE7O7uFhMLxU7s7m7FRAUFOxC7fRC7u7vrOOPi
LL+Zu7hhsXFR44MCgcAjrnKN69zgJre4zR3uco/7PODh/+4xT3jKM57zgpe8
4jVveMs73vOBj3ziM1/4yje+84Of/OI3fwgYGkQ60pOBjGQiM1kIJoSsZCM7
OchJLnKTh7yEko/8FKAghShMEYpSjOKUoCRhlKI0ZShLOcIpTwQViKQilahM
FapSjerUoCa1qE0d6lKP+jSgIY1oTBOa0ozmtKAlrWhNG9rSjvZ0oCOd6EwX
utKNKLrTg570ojd9iKYv/ejPAAYSwyAGE8sQhjKM4YxgJKMYzRjGMo5/B4tj
AhOZxGSmMJVpTGcGM5nFbOYwl3nMZwELWcRilrCUZSxnBStZxWrWsJZ1rGcD
8WxkE5vZwla2kcB2drCTRJLYxW6SSWEPe9nHfg5wkEMc5ghHSeUYaRznBCc5
xWnOcJZznOcCF7nEZa7wF1IhbYg=
         "]]},
       RowBox[{
         RowBox[{
           RowBox[{"(", 
             TagBox[
              GridBox[{{"\[Piecewise]", 
                 GridBox[{{
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}], "<", 
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"2.890313176181822`", " ", 
                    TagBox["z1", HoldForm]}]}]}], "&&", 
                    RowBox[{
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"2.890313176181822`", " ", 
                    TagBox["z1", HoldForm]}]}], "<", 
                    RowBox[{
                    RowBox[{"0.`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}]}]}, {
                    RowBox[{"1.10803324099723`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"0.`", "\[VeryThinSpace]"}], "+", 
                    SuperscriptBox[
                    TagBox["y2", HoldForm], "2"], "-", 
                    RowBox[{"0.6244997998398398`", " ", 
                    TagBox["y2", HoldForm], " ", 
                    TagBox["z1", HoldForm]}], "+", 
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}]}], ")"}]}], 
                    TagBox["True", "PiecewiseDefault", AutoDelete -> True]}}, 
                  ColumnAlignments -> {Left}, ColumnSpacings -> 1.2, 
                  ColumnWidths -> Automatic, 
                  AllowedDimensions -> {2, Automatic}, Selectable -> True, 
                  Editable -> True]}}, ColumnAlignments -> {Left}, 
               ColumnSpacings -> 0.5, ColumnWidths -> Automatic], "Piecewise",
               SyntaxForm -> Equal, SelectWithContents -> True, 
              StripWrapperBoxes -> True, Selectable -> False, Editable -> 
              False, DeleteWithContents -> True], ")"}], "-", 
           RowBox[{"(", 
             TagBox[
              GridBox[{{"\[Piecewise]", 
                 GridBox[{{
                    RowBox[{"0.10803324099722995`", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"0.`", "\[VeryThinSpace]"}], "+", 
                    TagBox["y2", HoldForm], "-", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"0.`", "\[VeryThinSpace]"}], "+", 
                    TagBox["y2", HoldForm]}], "<", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}, {
                    RowBox[{"0.10803324099722995`", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"0.`", "\[VeryThinSpace]"}], "-", 
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"0.`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], "<", 
                    TagBox["y2", HoldForm]}]}, {"0", 
                    TagBox["True", "PiecewiseDefault", AutoDelete -> True]}}, 
                  ColumnAlignments -> {Left}, ColumnSpacings -> 1.2, 
                  ColumnWidths -> Automatic, 
                  AllowedDimensions -> {2, Automatic}, Selectable -> True, 
                  Editable -> True]}}, ColumnAlignments -> {Left}, 
               ColumnSpacings -> 0.5, ColumnWidths -> Automatic], "Piecewise",
               SyntaxForm -> Equal, SelectWithContents -> True, 
              StripWrapperBoxes -> True, Selectable -> False, Editable -> 
              False, DeleteWithContents -> True], ")"}]}], "\[Equal]", 
         "3.815195725319702`"}]],
      Annotation[#, Piecewise[{{1. HoldForm[$CellContext`z1]^2, 
            And[
            3.202563076101742 HoldForm[$CellContext`z1] < 
             HoldForm[$CellContext`y2] + 
              2.890313176181822 HoldForm[$CellContext`z1], 
             HoldForm[$CellContext`y2] + 
              2.890313176181822 HoldForm[$CellContext`z1] < 
             0. + 3.202563076101742 HoldForm[$CellContext`z1]]}}, 
          1.10803324099723 (0. + HoldForm[$CellContext`y2]^2 - 
           0.6244997998398398 HoldForm[$CellContext`y2] 
           HoldForm[$CellContext`z1] + 1. HoldForm[$CellContext`z1]^2)] - 
        Piecewise[{{
          0.10803324099722995` (0. + HoldForm[$CellContext`y2] - 
             3.202563076101742 HoldForm[$CellContext`z1])^2, 
           0. + HoldForm[$CellContext`y2] < 
           3.202563076101742 HoldForm[$CellContext`z1]}, {
          0.10803324099722995` (0. - HoldForm[$CellContext`y2] + 
             3.202563076101742 HoldForm[$CellContext`z1])^2, 
           0. + 3.202563076101742 HoldForm[$CellContext`z1] < 
           HoldForm[$CellContext`y2]}}, 0] == 3.815195725319702, 
       "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {GrayLevel[0], AbsoluteThickness[1.], AbsoluteDashing[{2, 2}], 
        LineBox[CompressedData["
1:eJwV0FN7FgAAQOFvy7axlm3b5rJrWVu2l23b/AnZtm1j2fV28T7PuT6h4ZFh
EUGBQCCaPWIv+9jPAQ5yiMMc4SjHOM4JTnKK05zhLOc4zwUuconLXOEq17jO
DW5yi9vc4S73uM8DHvKIxzzhKc94zgte8orXvOEt73hPNB/4yCc+84WvfOM7
P/jJL37zh7//hwQHAkEEE4OYxCI2cYhLPOKTgIQkIjFJSEoykpOClKQiNWlI
SzrSk4GMZCIzIWQhlKxkIzs5yEkucpOHvOQjPwUoSCEKU4SiFKM4JShJKUpT
hrKUozwVqEglKlOFqlSjOjWoSS1qU4e61KM+DWhIIxrThDCa0ozmtKAlrWhN
G9rSjvZ0oCOd6Ew4XehKN7rTg570ojd96Es/IoikPwMYyCAGM4ShDGM4IxjJ
KEYzhrGMYzwTmEgUk5jMFKYyjenMYCazmM0c5jKP+SxgIYtYzBKWsozlrGAl
q1jNGtayjvVsYCOb2MwWtrKN7exgJ7vYzT+xWXkp
         "]], LineBox[CompressedData["
1:eJwNw2N0FgAAAMBvy7Zt27a97Frmsm3bxv9s27Ztcxl371260LCQnkGBQCDc
dcGBwHo3uNFNbnaLW93mdne4013udo973ed+D3jQQx72iEc95nFPeNJTnvaM
Zz3neS940Ute9opXveZ1b3jTW972jne9530f+NBHPvaJT33mc1/40le+9o1v
fed7P/jRT372i18N95vf/eFPf/nbP/71n4EIgUCQwUYwopGMbBSjGs3oxjCm
sYxtHOMaz/gmMKGJTGwSk5rM5KYwpalMbRrTms70ZjCjmcxsFrOazezmMKe5
zG0e85rP/BawoIUsbBGLWszilrCkpSxtGctazvJWsKKVrGwVq1rN6tawprWs
bR3rWs8Q69vAhjaysU1sajOb28KWtrK1bWxrqO1sbwc72snOdrGr3exuD3sa
Zi9728e+9rO/AxzoIAc7xKEOc7gjHOkoRzvGsY5zvBOc6CQnO8WpTnO6M5zp
LGc7x7nOc74LXOgiF7vEpS5zuStc6SpXu8a1/geXuH4l
         "]]},
       RowBox[{
         RowBox[{
           RowBox[{"-", 
             RowBox[{"(", 
               TagBox[
                GridBox[{{"\[Piecewise]", 
                   GridBox[{{
                    RowBox[{"0.10803324099722995`", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"0.95`", "\[VeryThinSpace]"}], "+", 
                    TagBox["y2", HoldForm], "-", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"0.95`", "\[VeryThinSpace]"}], "+", 
                    TagBox["y2", HoldForm]}], "<", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}, {
                    RowBox[{"0.10803324099722995`", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"0.95`", "\[VeryThinSpace]"}], "-", 
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"0.95`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], "<", 
                    TagBox["y2", HoldForm]}]}, {"0", 
                    TagBox["True", "PiecewiseDefault", AutoDelete -> True]}}, 
                    ColumnAlignments -> {Left}, ColumnSpacings -> 1.2, 
                    ColumnWidths -> Automatic, 
                    AllowedDimensions -> {2, Automatic}, Selectable -> True, 
                    Editable -> True]}}, ColumnAlignments -> {Left}, 
                 ColumnSpacings -> 0.5, ColumnWidths -> Automatic], 
                "Piecewise", SyntaxForm -> Equal, SelectWithContents -> True, 
                StripWrapperBoxes -> True, Selectable -> False, Editable -> 
                False, DeleteWithContents -> True], ")"}]}], "+", 
           RowBox[{"(", 
             TagBox[
              GridBox[{{"\[Piecewise]", 
                 GridBox[{{
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}], "<", 
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"0.95`", " ", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"3.0424349222966547`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}]}]}]}], "&&", 
                    RowBox[{
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"2.890313176181822`", " ", 
                    TagBox["z1", HoldForm]}]}], "<", 
                    RowBox[{
                    RowBox[{"0.95`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}]}]}, {
                    RowBox[{"1.10803324099723`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"0.9025`", "\[VeryThinSpace]"}], "+", 
                    SuperscriptBox[
                    TagBox["y2", HoldForm], "2"], "-", 
                    RowBox[{"1.9`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    TagBox["y2", HoldForm], "-", 
                    RowBox[{"0.3122498999199199`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}]}], "-", 
                    RowBox[{"0.6244997998398398`", " ", 
                    TagBox["y2", HoldForm], " ", 
                    TagBox["z1", HoldForm]}], "+", 
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}]}], ")"}]}], 
                    RowBox[{
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"2.890313176181822`", " ", 
                    TagBox["z1", HoldForm]}]}], "\[GreaterEqual]", 
                    RowBox[{
                    RowBox[{"0.95`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}]}, {
                    RowBox[{"1.10803324099723`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"0.9025`", "\[VeryThinSpace]"}], "+", 
                    SuperscriptBox[
                    TagBox["y2", HoldForm], "2"], "+", 
                    RowBox[{"1.9`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    TagBox["y2", HoldForm], "-", 
                    RowBox[{"0.3122498999199199`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}]}], "-", 
                    RowBox[{"0.6244997998398398`", " ", 
                    TagBox["y2", HoldForm], " ", 
                    TagBox["z1", HoldForm]}], "+", 
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}]}], ")"}]}], 
                    TagBox["True", "PiecewiseDefault", AutoDelete -> True]}}, 
                  ColumnAlignments -> {Left}, ColumnSpacings -> 1.2, 
                  ColumnWidths -> Automatic, 
                  AllowedDimensions -> {2, Automatic}, Selectable -> True, 
                  Editable -> True]}}, ColumnAlignments -> {Left}, 
               ColumnSpacings -> 0.5, ColumnWidths -> Automatic], "Piecewise",
               SyntaxForm -> Equal, SelectWithContents -> True, 
              StripWrapperBoxes -> True, Selectable -> False, Editable -> 
              False, DeleteWithContents -> True], ")"}]}], "\[Equal]", 
         "3.2365080016586982`"}]],
      Annotation[#, -
         Piecewise[{{
            0.10803324099722995` (0.95 + HoldForm[$CellContext`y2] - 
               3.202563076101742 HoldForm[$CellContext`z1])^2, 
             0.95 + HoldForm[$CellContext`y2] < 
             3.202563076101742 HoldForm[$CellContext`z1]}, {
            0.10803324099722995` (0.95 - HoldForm[$CellContext`y2] + 
               3.202563076101742 HoldForm[$CellContext`z1])^2, 
             0.95 + 3.202563076101742 HoldForm[$CellContext`z1] < 
             HoldForm[$CellContext`y2]}}, 0] + 
        Piecewise[{{1. HoldForm[$CellContext`z1]^2, 
            And[
            3.202563076101742 HoldForm[$CellContext`z1] < 
             HoldForm[$CellContext`y2] + 
              0.95 (1 + 3.0424349222966547` HoldForm[$CellContext`z1]), 
             HoldForm[$CellContext`y2] + 
              2.890313176181822 HoldForm[$CellContext`z1] < 
             0.95 + 3.202563076101742 HoldForm[$CellContext`z1]]}, {
           1.10803324099723 (0.9025 + HoldForm[$CellContext`y2]^2 - 
             1.9 (HoldForm[$CellContext`y2] - 0.3122498999199199 
              HoldForm[$CellContext`z1]) - 0.6244997998398398 
             HoldForm[$CellContext`y2] HoldForm[$CellContext`z1] + 
             1. HoldForm[$CellContext`z1]^2), 
            HoldForm[$CellContext`y2] + 
             2.890313176181822 HoldForm[$CellContext`z1] >= 
            0.95 + 3.202563076101742 HoldForm[$CellContext`z1]}}, 
          1.10803324099723 (0.9025 + HoldForm[$CellContext`y2]^2 + 
           1.9 (HoldForm[$CellContext`y2] - 0.3122498999199199 
             HoldForm[$CellContext`z1]) - 0.6244997998398398 
           HoldForm[$CellContext`y2] HoldForm[$CellContext`z1] + 
           1. HoldForm[$CellContext`z1]^2)] == 3.2365080016586982`, 
       "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {GrayLevel[0], AbsoluteThickness[1.], AbsoluteDashing[{8, 2}], 
        LineBox[CompressedData["
1:eJwNw1OQFQAAAMB3ddk2Ltu2bdu2bduuz2zbtm3bdu3ObEiLrjW6BAUCgR8u
Dh0ILHGpy1zuCle6ytWuca3rXO8GN7rJzW5xq9vc7g53usvd7nGv+9zvAQ96
yMMe8ajHPO4JT3rK057xrOc87wUvesnLXvGq17zuDW96y9ve8a73vO8DH/rI
xz7xqc987gtf+srXvvGt73zvBz/6yc9+8avf/O4Pf/rL3/7xr/8MBAcCQYYy
tMGGMazhDG8EIxrJyEYxqtGMbgxjGsvYxjGu8YxvAhOayMQmManJTG6IKUxp
KlObxrSmM70ZzGgmM5vFrGYzuznMaS5zm8e85jO/BSxoIQtbxKIWs7glLGkp
S1vGspazvBWsaCUrW8WqVrO6NaxpLWtbx7rWs74NbGgjG9vEpjazuS1saStb
28a2trO9HexoJzvbxa52s7s97Gkve9vHvvazvwMc6CAHO8ShDnO4IxzpKEc7
xrGOc7wTnOgkJzvFqU5zujOc6SxnO8e5znO+C1zoIv8DzmaBVQ==
         "]], LineBox[CompressedData["
1:eJwNwwN3kAEAAMBvtWXbtWzbNpddy1q27Z+Qbdu2bds27t678Mi+EVEhQRB8
cE5oEMx1nvNd4EIXudglLnWZy13hSle52jWudZ3r3eBGN7nZLW51m9vd4U53
uds97nWf+z3gQQ952CMe9ZjHPeFJT3naM571nOe94EUvedkrXvWa173hTW95
2zve9Z73feBDH/nYJz71mc994Utf+do3vvWd7/3gRz/52S9+9Zvf/eFPf/nb
P/71n0FYEIQYzeiGGmYMYxrL2MYxrvGMbwITmsjEJjGpyUxuClOaytSmMa3p
TG8GM5rJcDObxaxmM7s5zGkuc5vHvOYzvwUsaCELW8SiFrO4JSxpKUtbxrKW
s7wVrGglK1vFqlazujWsaS1rW8e61rO+DWxoIyNsbBOb2szmtrClrWxtG9va
zvZ2sKORdrKzXexqN7vbw572srd9jLKv/ezvAAc6yMEOcajDHO4IRzrK0Y5x
rOMc7wQnOsnJTnGq05zuDGc6y9n+BwN2fbw=
         "]]},
       RowBox[{
         RowBox[{
           RowBox[{"-", 
             RowBox[{"(", 
               TagBox[
                GridBox[{{"\[Piecewise]", 
                   GridBox[{{
                    RowBox[{"0.10803324099722995`", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2.8499999999999996`", "\[VeryThinSpace]"}], "+", 
                    TagBox["y2", HoldForm], "-", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"2.8499999999999996`", "\[VeryThinSpace]"}], "+", 
                    TagBox["y2", HoldForm]}], "<", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}, {
                    RowBox[{"0.10803324099722995`", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2.8499999999999996`", "\[VeryThinSpace]"}], "-", 
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"2.8499999999999996`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], "<", 
                    TagBox["y2", HoldForm]}]}, {"0", 
                    TagBox["True", "PiecewiseDefault", AutoDelete -> True]}}, 
                    ColumnAlignments -> {Left}, ColumnSpacings -> 1.2, 
                    ColumnWidths -> Automatic, 
                    AllowedDimensions -> {2, Automatic}, Selectable -> True, 
                    Editable -> True]}}, ColumnAlignments -> {Left}, 
                 ColumnSpacings -> 0.5, ColumnWidths -> Automatic], 
                "Piecewise", SyntaxForm -> Equal, SelectWithContents -> True, 
                StripWrapperBoxes -> True, Selectable -> False, Editable -> 
                False, DeleteWithContents -> True], ")"}]}], "+", 
           RowBox[{"(", 
             TagBox[
              GridBox[{{"\[Piecewise]", 
                 GridBox[{{
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}], "<", 
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"0.95`", " ", 
                    RowBox[{"(", 
                    RowBox[{"3", "+", 
                    RowBox[{"3.0424349222966547`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}]}]}]}], "&&", 
                    RowBox[{
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"2.890313176181822`", " ", 
                    TagBox["z1", HoldForm]}]}], "<", 
                    RowBox[{
                    RowBox[{"2.8499999999999996`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}]}]}, {
                    RowBox[{"1.10803324099723`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"8.1225`", "\[VeryThinSpace]"}], "+", 
                    SuperscriptBox[
                    TagBox["y2", HoldForm], "2"], "-", 
                    RowBox[{"5.699999999999999`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    TagBox["y2", HoldForm], "-", 
                    RowBox[{"0.3122498999199199`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}]}], "-", 
                    RowBox[{"0.6244997998398398`", " ", 
                    TagBox["y2", HoldForm], " ", 
                    TagBox["z1", HoldForm]}], "+", 
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}]}], ")"}]}], 
                    RowBox[{
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"2.890313176181822`", " ", 
                    TagBox["z1", HoldForm]}]}], "\[GreaterEqual]", 
                    RowBox[{
                    RowBox[{"2.8499999999999996`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}]}, {
                    RowBox[{"1.10803324099723`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"8.1225`", "\[VeryThinSpace]"}], "+", 
                    SuperscriptBox[
                    TagBox["y2", HoldForm], "2"], "+", 
                    RowBox[{"5.699999999999999`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    TagBox["y2", HoldForm], "-", 
                    RowBox[{"0.3122498999199199`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}]}], "-", 
                    RowBox[{"0.6244997998398398`", " ", 
                    TagBox["y2", HoldForm], " ", 
                    TagBox["z1", HoldForm]}], "+", 
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}]}], ")"}]}], 
                    TagBox["True", "PiecewiseDefault", AutoDelete -> True]}}, 
                  ColumnAlignments -> {Left}, ColumnSpacings -> 1.2, 
                  ColumnWidths -> Automatic, 
                  AllowedDimensions -> {2, Automatic}, Selectable -> True, 
                  Editable -> True]}}, ColumnAlignments -> {Left}, 
               ColumnSpacings -> 0.5, ColumnWidths -> Automatic], "Piecewise",
               SyntaxForm -> Equal, SelectWithContents -> True, 
              StripWrapperBoxes -> True, Selectable -> False, Editable -> 
              False, DeleteWithContents -> True], ")"}]}], "\[Equal]", 
         "3.957218585171359`"}]],
      Annotation[#, -
         Piecewise[{{
            0.10803324099722995` (2.8499999999999996` + 
               HoldForm[$CellContext`y2] - 3.202563076101742 
               HoldForm[$CellContext`z1])^2, 
             2.8499999999999996` + HoldForm[$CellContext`y2] < 
             3.202563076101742 HoldForm[$CellContext`z1]}, {
            0.10803324099722995` (2.8499999999999996` - 
               HoldForm[$CellContext`y2] + 
               3.202563076101742 HoldForm[$CellContext`z1])^2, 
             2.8499999999999996` + 
              3.202563076101742 HoldForm[$CellContext`z1] < 
             HoldForm[$CellContext`y2]}}, 0] + 
        Piecewise[{{1. HoldForm[$CellContext`z1]^2, 
            And[
            3.202563076101742 HoldForm[$CellContext`z1] < 
             HoldForm[$CellContext`y2] + 
              0.95 (3 + 3.0424349222966547` HoldForm[$CellContext`z1]), 
             HoldForm[$CellContext`y2] + 
              2.890313176181822 HoldForm[$CellContext`z1] < 
             2.8499999999999996` + 
              3.202563076101742 HoldForm[$CellContext`z1]]}, {
           1.10803324099723 (8.1225 + HoldForm[$CellContext`y2]^2 - 
             5.699999999999999 (HoldForm[$CellContext`y2] - 
              0.3122498999199199 HoldForm[$CellContext`z1]) - 
             0.6244997998398398 HoldForm[$CellContext`y2] 
             HoldForm[$CellContext`z1] + 1. HoldForm[$CellContext`z1]^2), 
            HoldForm[$CellContext`y2] + 
             2.890313176181822 HoldForm[$CellContext`z1] >= 
            2.8499999999999996` + 
             3.202563076101742 HoldForm[$CellContext`z1]}}, 
          1.10803324099723 (8.1225 + HoldForm[$CellContext`y2]^2 + 
           5.699999999999999 (HoldForm[$CellContext`y2] - 0.3122498999199199 
             HoldForm[$CellContext`z1]) - 0.6244997998398398 
           HoldForm[$CellContext`y2] HoldForm[$CellContext`z1] + 
           1. HoldForm[$CellContext`z1]^2)] == 3.957218585171359, 
       "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {GrayLevel[0], AbsoluteThickness[1.], AbsoluteDashing[{1, 5}], 
        LineBox[CompressedData["
1:eJwNxGeAiAUAANDvykkaIlRUEkkIJatFRVkpirTQqRDujEq7UMnohjPuzu0z
bu874/aRtM3KrGxpae96P95rGxYxMjwkCILeigwNgiiiiWEJsSxlGctZQRzx
JLCSRJJIJoVU0kgng1WsZg1rySSLbHLIJY98CiikiGJKKKWMctaxng1spIJK
qqimhlrqqGcTm3mHLbzLVt7jfT7gQz7iYz5hG9vZwU52sZtP+YzP2cNe9rGf
AxzkC77kKw5xmCMc5RjHOcFJvuYU3/At3/E9P3CaH/mJn/mFX/mN3/mDP/mL
v/mHf/mPoGEQhHAGZ9KAUBpyFo04m8acw7mcx/k04QKa0owLaU4LWnIRF3MJ
rWjNpVzG5bThCtpyJe1oz1V04Go6cg2d6EwXrqUr3ejOdVxPD26gJ73oTR/6
ciM3cTO3cCv96M9t3M4dDGAgd3IXgxjMEIYyjLsZzj3cywhGch/3M4rRPMAY
HuQhHuYRHmUs4xjPY4Qxgcd5gieZyCQm8xRTmMo0wolgOjOYySye5hmeZTbP
8Twv8CIv8TKv8CqvMYe5zON13uBN5vMWC1jIIhbzNpFEEU0MS4hlKctYzgri
iCeBlSSSRDIppJJGOhmsYjVrWEsmWWSTQy555FNAIUUUU0IpZZSzjvVsYCMV
VFJFNTXUUkc9m9jM/zpFrJM=
         "]], LineBox[CompressedData["
1:eJwN0+eDyAUAgOGfO+6O484dEhmRQhHJiNAgipIVZZWRpr2ijJItFFmVhq2S
lVU0jDMP5+y99zjcuTs3PB+e9z94S3Xq0bx7jiAImsmmsCDYTBxb2Mo2trOD
ncSzi93sIYG9JLKP/RzgIIc4zBGOcozjnOAkpzjNGc5yjvNc4CKXuMwVrnKN
69zgJknc4jZ3SCaFu6SSRjr3yCCTLLIJwoMgByGEkpNchBFOBLnJQyR5yUcU
0eQnhlgKUJBCPEBhHqQIRXmIYhSnBCV5mFKU5hHK8CiPUZZylOdxnqACFXmS
SlTmKarwNFWpRnVq8Aw1qcWz1KYOdXmO53mBF6lHfV6iAQ15mVdoRGNe5TWa
8DpNaUZzWtCSN2hFa97kLdrQlna0pwNv8w4d6URnuvAuXXmP9/mAD/mIj+lG
d3rQk170pg996Ud/BvAJAxnEp3zGYIYwlGF8zhcM50tGMJJRjGYMYxnHeL5i
AhOZxNd8w2Sm8C1TmcZ0ZjCT7/ieH5jFj/zEz/zCbOYwl3nMZwELWcSv/Mbv
LOYPlrCUZSxnBX+yklWsZg1r+Yu/Wcd6/uFf/uN/NrCRTWwmji1sZRvb2cFO
4tnFbvaQwF4S2cd+DnCQQxzmCEc5xnFOcJJTnOYMZznHeS5wkUtc5gpXucZ1
bnCTJG5xmzskk8JdUkkjnXtkkEkW2QQR/ieEUHKSizDCiSA3eYgkL/mIIpr8
xBBLAQpSiPtEoL+V
         "]]},
       RowBox[{
         RowBox[{
           RowBox[{"-", 
             RowBox[{"(", 
               TagBox[
                GridBox[{{"\[Piecewise]", 
                   GridBox[{{
                    RowBox[{"0.10803324099722995`", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"9.5`", "\[VeryThinSpace]"}], "+", 
                    TagBox["y2", HoldForm], "-", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"9.5`", "\[VeryThinSpace]"}], "+", 
                    TagBox["y2", HoldForm]}], "<", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}, {
                    RowBox[{"0.10803324099722995`", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"9.5`", "\[VeryThinSpace]"}], "-", 
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"9.5`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}], "<", 
                    TagBox["y2", HoldForm]}]}, {"0", 
                    TagBox["True", "PiecewiseDefault", AutoDelete -> True]}}, 
                    ColumnAlignments -> {Left}, ColumnSpacings -> 1.2, 
                    ColumnWidths -> Automatic, 
                    AllowedDimensions -> {2, Automatic}, Selectable -> True, 
                    Editable -> True]}}, ColumnAlignments -> {Left}, 
                 ColumnSpacings -> 0.5, ColumnWidths -> Automatic], 
                "Piecewise", SyntaxForm -> Equal, SelectWithContents -> True, 
                StripWrapperBoxes -> True, Selectable -> False, Editable -> 
                False, DeleteWithContents -> True], ")"}]}], "+", 
           RowBox[{"(", 
             TagBox[
              GridBox[{{"\[Piecewise]", 
                 GridBox[{{
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}], "<", 
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"0.95`", " ", 
                    RowBox[{"(", 
                    RowBox[{"10", "+", 
                    RowBox[{"3.0424349222966547`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}]}]}]}], "&&", 
                    RowBox[{
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"2.890313176181822`", " ", 
                    TagBox["z1", HoldForm]}]}], "<", 
                    RowBox[{
                    RowBox[{"9.5`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}]}]}, {
                    RowBox[{"1.10803324099723`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"90.25`", "\[VeryThinSpace]"}], "+", 
                    SuperscriptBox[
                    TagBox["y2", HoldForm], "2"], "-", 
                    RowBox[{"19.`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    TagBox["y2", HoldForm], "-", 
                    RowBox[{"0.3122498999199199`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}]}], "-", 
                    RowBox[{"0.6244997998398398`", " ", 
                    TagBox["y2", HoldForm], " ", 
                    TagBox["z1", HoldForm]}], "+", 
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}]}], ")"}]}], 
                    RowBox[{
                    RowBox[{
                    TagBox["y2", HoldForm], "+", 
                    RowBox[{"2.890313176181822`", " ", 
                    TagBox["z1", HoldForm]}]}], "\[GreaterEqual]", 
                    RowBox[{
                    RowBox[{"9.5`", "\[VeryThinSpace]"}], "+", 
                    RowBox[{"3.202563076101742`", " ", 
                    TagBox["z1", HoldForm]}]}]}]}, {
                    RowBox[{"1.10803324099723`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"90.25`", "\[VeryThinSpace]"}], "+", 
                    SuperscriptBox[
                    TagBox["y2", HoldForm], "2"], "+", 
                    RowBox[{"19.`", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    TagBox["y2", HoldForm], "-", 
                    RowBox[{"0.3122498999199199`", " ", 
                    TagBox["z1", HoldForm]}]}], ")"}]}], "-", 
                    RowBox[{"0.6244997998398398`", " ", 
                    TagBox["y2", HoldForm], " ", 
                    TagBox["z1", HoldForm]}], "+", 
                    RowBox[{"1.`", " ", 
                    SuperscriptBox[
                    TagBox["z1", HoldForm], "2"]}]}], ")"}]}], 
                    TagBox["True", "PiecewiseDefault", AutoDelete -> True]}}, 
                  ColumnAlignments -> {Left}, ColumnSpacings -> 1.2, 
                  ColumnWidths -> Automatic, 
                  AllowedDimensions -> {2, Automatic}, Selectable -> True, 
                  Editable -> True]}}, ColumnAlignments -> {Left}, 
               ColumnSpacings -> 0.5, ColumnWidths -> Automatic], "Piecewise",
               SyntaxForm -> Equal, SelectWithContents -> True, 
              StripWrapperBoxes -> True, Selectable -> False, Editable -> 
              False, DeleteWithContents -> True], ")"}]}], "\[Equal]", 
         "3.9896441783253778`"}]],
      Annotation[#, -
         Piecewise[{{
            0.10803324099722995` (9.5 + HoldForm[$CellContext`y2] - 
               3.202563076101742 HoldForm[$CellContext`z1])^2, 
             9.5 + HoldForm[$CellContext`y2] < 
             3.202563076101742 HoldForm[$CellContext`z1]}, {
            0.10803324099722995` (9.5 - HoldForm[$CellContext`y2] + 
               3.202563076101742 HoldForm[$CellContext`z1])^2, 
             9.5 + 3.202563076101742 HoldForm[$CellContext`z1] < 
             HoldForm[$CellContext`y2]}}, 0] + 
        Piecewise[{{1. HoldForm[$CellContext`z1]^2, 
            And[
            3.202563076101742 HoldForm[$CellContext`z1] < 
             HoldForm[$CellContext`y2] + 
              0.95 (10 + 3.0424349222966547` HoldForm[$CellContext`z1]), 
             HoldForm[$CellContext`y2] + 
              2.890313176181822 HoldForm[$CellContext`z1] < 
             9.5 + 3.202563076101742 HoldForm[$CellContext`z1]]}, {
           1.10803324099723 (90.25 + HoldForm[$CellContext`y2]^2 - 
             19. (HoldForm[$CellContext`y2] - 0.3122498999199199 
              HoldForm[$CellContext`z1]) - 0.6244997998398398 
             HoldForm[$CellContext`y2] HoldForm[$CellContext`z1] + 
             1. HoldForm[$CellContext`z1]^2), 
            HoldForm[$CellContext`y2] + 
             2.890313176181822 HoldForm[$CellContext`z1] >= 
            9.5 + 3.202563076101742 HoldForm[$CellContext`z1]}}, 
          1.10803324099723 (90.25 + HoldForm[$CellContext`y2]^2 + 
           19. (HoldForm[$CellContext`y2] - 0.3122498999199199 
             HoldForm[$CellContext`z1]) - 0.6244997998398398 
           HoldForm[$CellContext`y2] HoldForm[$CellContext`z1] + 
           1. HoldForm[$CellContext`z1]^2)] == 3.9896441783253778`, 
       "Tooltip"]& ]}], {}},
  AspectRatio->1,
  AxesLabel->{None, None},
  AxesOrigin->{0., 0.},
  AxesStyle->{{
     AbsoluteThickness[0.8]}, {
     AbsoluteThickness[0.8]}},
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{{None, None}, {None, None}},
  FrameStyle->AbsoluteThickness[0.8],
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->250,
  LabelStyle->{FontFamily -> "Times New Roman", FontSize -> 12},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "GridLinesInFront" -> 
    True},
  PlotRange->{{-7, 7}, {-13, 13}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.680285999925456*^9, {3.680286061041937*^9, 3.680286107554695*^9}, {
   3.6802861410257573`*^9, 3.6802861767848597`*^9}, {3.680286331714983*^9, 
   3.680286413184724*^9}, 3.6802864903839936`*^9, 3.680286708772298*^9, {
   3.680287064533255*^9, 3.680287085045616*^9}, 3.8167044499751067`*^9, 
   3.8167045402836213`*^9, 3.816708738464801*^9, 3.816708925079446*^9},
 CellLabel->"Out[39]=",ExpressionUUID->"c22e1991-3a5b-4735-ad44-cb092fb27651"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\<c:/dropbox/mystuff/sparsity/accplot.pdf\>\"", ",", "p"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.680286426304603*^9, 
  3.6802864268009233`*^9}},ExpressionUUID->"e65363f7-bed9-4e11-a03b-\
8b0e9d49bdb2"],

Cell[BoxData["\<\"c:/dropbox/mystuff/sparsity/accplot.pdf\"\>"], "Output",
 CellChangeTimes->{3.6802864284071913`*^9, 3.6802864951656857`*^9, 
  3.680286714329796*^9, 
  3.680287094782564*^9},ExpressionUUID->"a86931e8-1659-4ed0-b2fa-\
da3081b41861"]
}, Open  ]]
},
WindowSize->{1272, 966},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 592, 16, 102, "Input",ExpressionUUID->"4f7c1080-6353-4780-b76f-e5885a4b4456"],
Cell[CellGroupData[{
Cell[1175, 40, 794, 16, 43, "Input",ExpressionUUID->"5a8d6e68-ea0e-4dfa-8635-0a3d7a848cb8"],
Cell[1972, 58, 26750, 478, 112, "Output",ExpressionUUID->"608df5a2-08cc-4b62-81bb-31145e579ddd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28759, 541, 2059, 51, 153, "Input",ExpressionUUID->"08afb1a4-3625-4f10-ba16-6c8a9f09f48a"],
Cell[30821, 594, 27999, 509, 220, "Output",ExpressionUUID->"2ff4ab2a-0c45-4a32-8c29-d0ee9a1cc470"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58857, 1108, 2337, 63, 218, "Input",ExpressionUUID->"32d18162-e3f1-4b86-ad66-a9f242aae1f4"],
Cell[61197, 1173, 608, 13, 65, "Message",ExpressionUUID->"1ec9e4fb-c458-41ce-a6cd-2d393ed210fb"],
Cell[61808, 1188, 610, 13, 65, "Message",ExpressionUUID->"8f171c43-e82f-41c7-87e3-25ebc69dda1b"],
Cell[62421, 1203, 611, 13, 65, "Message",ExpressionUUID->"051a8da8-486e-41f3-9b2c-f0a1fc71355f"],
Cell[63035, 1218, 537, 12, 35, "Message",ExpressionUUID->"8aa40cd3-8163-43f6-bd0c-f6ed72ef59ff"],
Cell[63575, 1232, 56626, 954, 279, "Output",ExpressionUUID->"4013be4e-6647-4a15-969f-d8e105eb87f7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[120238, 2191, 260, 6, 43, "Input",ExpressionUUID->"844265d3-4c6c-475f-a1f8-53df769235c5"],
Cell[120501, 2199, 225, 3, 49, "Output",ExpressionUUID->"41d1a9f6-b1d7-4421-8731-9c1a63fab8b0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[120763, 2207, 2614, 80, 160, "Input",ExpressionUUID->"da159c27-9395-4d73-960c-c85b444a3e27"],
Cell[123380, 2289, 1235, 41, 82, "Output",ExpressionUUID->"380d5192-caa3-4729-8ed6-01ba0cb14c7f"],
Cell[124618, 2332, 8801, 253, 496, "Output",ExpressionUUID->"1c0bd859-7f1a-4d2e-b361-1ec1b0655d85"]
}, Open  ]],
Cell[133434, 2588, 1109, 30, 102, "Input",ExpressionUUID->"a9c4345e-31c2-4484-84e7-2f90444ca2a0"],
Cell[CellGroupData[{
Cell[134568, 2622, 2844, 73, 218, "Input",ExpressionUUID->"d127a92a-c15c-4d6e-846f-31d454ef3f18"],
Cell[137415, 2697, 500, 7, 49, "Output",ExpressionUUID->"8f9c71ff-5af2-4c0a-8f21-db615bd7de52"],
Cell[137918, 2706, 865, 16, 35, "Message",ExpressionUUID->"6d54d0de-b009-46ed-a997-a7db5e1c5440"],
Cell[138786, 2724, 865, 16, 35, "Message",ExpressionUUID->"1422df95-2d39-40e0-a9d2-e9df3c751693"],
Cell[139654, 2742, 863, 16, 35, "Message",ExpressionUUID->"e23d7764-8195-4949-990e-627cd962cb18"],
Cell[140520, 2760, 810, 15, 35, "Message",ExpressionUUID->"7cf6c7f5-a3b6-4ac2-9758-4a75a70a6c55"],
Cell[141333, 2777, 55954, 1048, 392, "Output",ExpressionUUID->"c22e1991-3a5b-4735-ad44-cb092fb27651"]
}, Open  ]],
Cell[CellGroupData[{
Cell[197324, 3830, 259, 6, 43, "Input",ExpressionUUID->"e65363f7-bed9-4e11-a03b-8b0e9d49bdb2"],
Cell[197586, 3838, 249, 4, 49, "Output",ExpressionUUID->"a86931e8-1659-4ed0-b2fa-da3081b41861"]
}, Open  ]]
}
]
*)

