(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    240527,       4823]
NotebookOptionsPosition[    235206,       4742]
NotebookOutlinePosition[    235547,       4757]
CellTagsIndexPosition[    235504,       4754]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"lvs", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "5", ",", "10"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"cvtab", "[", "j", "]"}], "=", 
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"\"\<c:/dropbox/mystuff/sparsity/revision/cvmat_\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"lvs", "[", 
         RowBox[{"[", "j", "]"}], "]"}], "]"}], "<>", "\"\<.txt\>\""}], ",", 
      "\"\<Table\>\""}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.7743621845562167`*^9, 3.7743622521216984`*^9}, {
  3.8167091035943394`*^9, 3.8167091066039686`*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"3d4ac21e-7a3a-48f4-9649-5da9cf0516ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"getcv", "[", 
   RowBox[{"j_", ",", "kg_", ",", "wb_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "=", "40"}], ",", "x", ",", "i", ",", "w", ",", "wc"}], 
     "}"}], ",", 
    RowBox[{
     RowBox[{"x", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"0.5", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"0.5", 
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{
               RowBox[{"kg", "^", "2"}], "+", 
               RowBox[{"wb", "^", "2"}]}], "]"}], "/", 
             RowBox[{"Log", "[", "200.0", "]"}]}]}], "+", "1"}], ")"}]}], ",", 
        RowBox[{"2", " ", 
         RowBox[{
          RowBox[{"ArcTan", "[", 
           RowBox[{"kg", "/", "wb"}], "]"}], "/", "Pi"}]}]}], "}"}]}], ";", 
     RowBox[{"x", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Min", "[", 
          RowBox[{
           RowBox[{"Max", "[", 
            RowBox[{"#", ",", 
             RowBox[{"1", "/", "n"}]}], "]"}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"n", "-", "1"}], ")"}], "/", "n"}]}], "]"}], "&"}], ",", 
        "x"}], "]"}]}], ";", 
     RowBox[{"i", "=", 
      RowBox[{"Floor", "[", 
       RowBox[{"n", " ", "x"}], "]"}]}], ";", 
     RowBox[{"w", "=", 
      RowBox[{
       RowBox[{"n", " ", "x"}], "-", "i"}]}], ";", 
     RowBox[{"wc", "=", 
      RowBox[{"1", "-", "w"}]}], ";", 
     RowBox[{
      RowBox[{
       RowBox[{"wc", "[", 
        RowBox[{"[", "1", "]"}], "]"}], 
       RowBox[{"wc", "[", 
        RowBox[{"[", "2", "]"}], "]"}], 
       RowBox[{
        RowBox[{"cvtab", "[", "j", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"i", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"i", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"w", "[", 
        RowBox[{"[", "1", "]"}], "]"}], 
       RowBox[{"wc", "[", 
        RowBox[{"[", "2", "]"}], "]"}], 
       RowBox[{
        RowBox[{"cvtab", "[", "j", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{
           RowBox[{"i", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "+", "1"}], ",", 
          RowBox[{"i", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"wc", "[", 
        RowBox[{"[", "1", "]"}], "]"}], 
       RowBox[{"w", "[", 
        RowBox[{"[", "2", "]"}], "]"}], 
       RowBox[{
        RowBox[{"cvtab", "[", "j", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"i", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"i", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "+", "1"}]}], "]"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"w", "[", 
        RowBox[{"[", "1", "]"}], "]"}], 
       RowBox[{"w", "[", 
        RowBox[{"[", "2", "]"}], "]"}], 
       RowBox[{
        RowBox[{"cvtab", "[", "j", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{
           RowBox[{"i", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "+", "1"}], ",", 
          RowBox[{
           RowBox[{"i", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "+", "1"}]}], "]"}], 
        "]"}]}]}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7743622898706207`*^9, 3.774362368442382*^9}, {
   3.7743624401858263`*^9, 3.774362675610347*^9}, {3.7743627092860737`*^9, 
   3.7743627098199368`*^9}, 3.7743627597567844`*^9, {3.7743628505055676`*^9, 
   3.7743629501622066`*^9}, {3.7743630002908883`*^9, 
   3.7743630034078197`*^9}, {3.7743630943893604`*^9, 3.774363117176735*^9}, {
   3.7743631769207044`*^9, 3.7743631999134293`*^9}, {3.774363237416684*^9, 
   3.7743633166898203`*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"9edc577c-7c94-401f-853c-b9d64fbbb3b7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"getcv", "[", 
  RowBox[{"2", ",", "1.3", ",", "3.0"}], "]"}]], "Input",
 CellChangeTimes->{{3.7743627630704765`*^9, 3.7743627719044914`*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"a043ac67-3015-4b9f-bc44-090fa1b49c07"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.6117953380820508`", ",", "0.26031880898606`"}], "}"}]], "Print",
 CellChangeTimes->{3.7743630065440826`*^9, 3.774363107778665*^9, 
  3.7743631379986157`*^9, 3.774363206680865*^9, 3.7743632412684765`*^9, 
  3.7743633074598866`*^9},
 CellLabel->
  "During evaluation of \
In[26]:=",ExpressionUUID->"18548309-c5de-4571-ae65-15cf6b08f666"],

Cell[BoxData["3.396848972850956`"], "Output",
 CellChangeTimes->{
  3.774362772833346*^9, {3.774362866310855*^9, 3.774362890872083*^9}, {
   3.7743629336756744`*^9, 3.7743629544687147`*^9}, 3.7743630066061606`*^9, 
   3.77436310783864*^9, 3.7743631380606174`*^9, 3.7743632067428637`*^9, 
   3.774363241272488*^9, 3.7743633074639187`*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"7e281518-edc0-44fb-bb1e-3e85b0b3fed5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"x0", "=", 
   RowBox[{
    RowBox[{"Minimize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"y1", "^", "2"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"y2", "-", "g"}], ")"}], "^", "2"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "kg"}], "<", "g", "<", "kg"}], "}"}]}], "}"}], ",", 
      "g"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x1", "=", 
   RowBox[{
    RowBox[{"Minimize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"y1", "-", "b"}], ")"}], "^", "2"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"y2", "-", 
            RowBox[{"wb", " ", "b"}], "-", "g"}], ")"}], "^", "2"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "kg"}], "<", "g", "<", "kg"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "b"}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getLRr", "[", 
   RowBox[{"y1_", ",", "y2_", ",", "kg_", ",", "wb_"}], "]"}], "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"x0", "-", "x1"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"kg", ">", "00"}], ",", 
      RowBox[{"wb", ">", "0"}], ",", 
      RowBox[{"y1", "!=", "0"}], ",", 
      RowBox[{"y2", "!=", "0"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.7743636494638805`*^9, 3.774363681351466*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"325567e3-c8e7-4dc2-bc13-8d12ca1d2914"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          SuperscriptBox["y1", "2"], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"y2", ">", "0"}], "&&", 
             RowBox[{"kg", ">", "y2"}]}], ")"}], "||", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"y2", "\[LessEqual]", "0"}], "&&", 
             RowBox[{
              RowBox[{"kg", "+", "y2"}], ">", "0"}]}], ")"}]}]},
         {
          RowBox[{
           SuperscriptBox["y1", "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"kg", "-", "y2"}], ")"}], "2"]}], 
          RowBox[{"kg", "\[LessEqual]", "y2"}]},
         {
          RowBox[{
           SuperscriptBox["y1", "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"kg", "+", "y2"}], ")"}], "2"]}], 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}},
        Selectable->True]}
     },
     GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False,
    StripWrapperBoxes->True], ")"}], "-", 
  RowBox[{"(", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"kg", "+", 
              RowBox[{"wb", " ", "y1"}], "-", "y2"}], ")"}], "2"], 
           RowBox[{"1", "+", 
            SuperscriptBox["wb", "2"]}]], 
          RowBox[{
           RowBox[{"kg", "+", 
            RowBox[{"wb", " ", "y1"}]}], "<", "y2"}]},
         {
          FractionBox[
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"kg", "-", 
              RowBox[{"wb", " ", "y1"}], "+", "y2"}], ")"}], "2"], 
           RowBox[{"1", "+", 
            SuperscriptBox["wb", "2"]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"y1", "<", "0"}], "&&", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"wb", "<", 
                  FractionBox[
                   RowBox[{"kg", "+", "y2"}], "y1"]}], "&&", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"kg", "+", "y2"}], "\[GreaterEqual]", "0"}], "&&", 
                    RowBox[{"y2", "<", "0"}]}], ")"}], "||", 
                   RowBox[{"y2", ">", "0"}]}], ")"}]}], ")"}], "||", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"kg", "+", "y2"}], "<", "0"}], "&&", 
                 RowBox[{"wb", "\[LessEqual]", 
                  FractionBox[
                   RowBox[{"kg", "+", "y2"}], "y1"]}]}], ")"}]}], ")"}]}], 
            ")"}], "||", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"y1", ">", "0"}], "&&", 
             RowBox[{
              RowBox[{"kg", "+", "y2"}], "<", 
              RowBox[{"wb", " ", "y1"}]}]}], ")"}]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}},
        Selectable->True]}
     },
     GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False,
    StripWrapperBoxes->True], ")"}]}]], "Output",
 CellChangeTimes->{
  3.7743636393326283`*^9, {3.7743636697927103`*^9, 3.774363683008649*^9}, 
   3.7743700408884044`*^9, 3.7744577135830164`*^9, 3.7744689656651077`*^9, 
   3.77452691136388*^9, 3.7775666122456465`*^9, 3.7775666516371794`*^9, 
   3.777566710326913*^9, 3.7775726060433617`*^9, {3.777573359001824*^9, 
   3.777573362236889*^9}, 3.777574958095066*^9, 3.77763657237955*^9, 
   3.781437258706896*^9, 3.7814380118468294`*^9, 3.7822144655377026`*^9, 
   3.8167091292572536`*^9, 3.8169697451123905`*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"80a93319-563b-46d7-a76d-6ccf08771903"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"x1", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"Minimize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"y1", "-", "b"}], ")"}], "^", "2"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"y2", "-", 
            RowBox[{"wb", " ", "b"}], "-", "g"}], ")"}], "^", "2"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "kg"}], "<=", "g", "<=", "kg"}], ",", 
          RowBox[{"kg", ">", "00"}], ",", 
          RowBox[{"wb", ">", "0"}], ",", 
          RowBox[{"y1", "!=", "0"}], ",", 
          RowBox[{"y2", "!=", "0"}]}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "b"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"kg", ">", "00"}], ",", 
      RowBox[{"wb", ">", "0"}], ",", 
      RowBox[{"y1", "!=", "0"}], ",", 
      RowBox[{"y2", "!=", "0"}], ",", 
      RowBox[{
       RowBox[{"wb", " ", "y1"}], "!=", "y2"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.774363716934618*^9, 3.7743637417848577`*^9}, {
   3.7743639043891354`*^9, 3.774363934743183*^9}, {3.7743640251706753`*^9, 
   3.774364035773904*^9}, {3.774364075863634*^9, 3.774364084750033*^9}, 
   3.774364666342682*^9, {3.7743647009432354`*^9, 3.774364701309239*^9}, {
   3.7743672922427416`*^9, 3.7743672939214587`*^9}, {3.774367365448202*^9, 
   3.7743673663993177`*^9}, {3.777639385956984*^9, 3.777639391939811*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"d99009ef-d922-4ab5-a9d9-5c8e018b5621"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"kg", "+", 
              RowBox[{"wb", " ", "y1"}], "-", "y2"}], ")"}], "2"], 
           RowBox[{"1", "+", 
            SuperscriptBox["wb", "2"]}]], 
          RowBox[{
           RowBox[{"kg", "+", 
            RowBox[{"wb", " ", "y1"}]}], "<", "y2"}]},
         {
          FractionBox[
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"kg", "-", 
              RowBox[{"wb", " ", "y1"}], "+", "y2"}], ")"}], "2"], 
           RowBox[{"1", "+", 
            SuperscriptBox["wb", "2"]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"y1", ">", "0"}], "&&", 
             RowBox[{
              RowBox[{"kg", "+", "y2"}], "<", 
              RowBox[{"wb", " ", "y1"}]}]}], ")"}], "||", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"y1", "<", "0"}], "&&", 
             RowBox[{
              RowBox[{"kg", "+", "y2"}], "\[LessEqual]", 
              RowBox[{"wb", " ", "y1"}]}]}], ")"}]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}},
        Selectable->True]}
     },
     GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False,
    StripWrapperBoxes->True], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"g", "\[Rule]", 
      TagBox[GridBox[{
         {"\[Piecewise]", GridBox[{
            {
             RowBox[{"-", "kg"}], 
             RowBox[{
              RowBox[{"kg", "+", "y2"}], "\[LessEqual]", 
              RowBox[{"wb", " ", "y1"}]}]},
            {
             RowBox[{
              RowBox[{
               RowBox[{"-", "wb"}], " ", "y1"}], "+", "y2"}], 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"y1", "<", "0"}], "&&", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"kg", "+", 
                    RowBox[{"wb", " ", "y1"}]}], "\[GreaterEqual]", "y2"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], "<", "y2"}], "&&", 
                    RowBox[{"y2", "<", "0"}]}], ")"}], "||", 
                    RowBox[{"y2", ">", "0"}]}], ")"}]}], ")"}], "||", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], ">", "y2"}], "&&", 
                    RowBox[{
                    RowBox[{"kg", "+", "y2"}], ">", 
                    RowBox[{"wb", " ", "y1"}]}], "&&", 
                    RowBox[{"y2", "<", "0"}]}], ")"}]}], ")"}]}], ")"}], "||", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"y1", ">", "0"}], "&&", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"y2", ">", "0"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"kg", "+", 
                    RowBox[{"wb", " ", "y1"}]}], "\[GreaterEqual]", "y2"}], "&&", 
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], "<", "y2"}]}], ")"}], "||", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], ">", "y2"}], "&&", 
                    RowBox[{
                    RowBox[{"kg", "+", "y2"}], ">", 
                    RowBox[{"wb", " ", "y1"}]}]}], ")"}]}], ")"}]}], ")"}], "||", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"y2", "<", "0"}], "&&", 
                    RowBox[{
                    RowBox[{"kg", "+", "y2"}], ">", 
                    RowBox[{"wb", " ", "y1"}]}]}], ")"}]}], ")"}]}], ")"}]}]},
            {"kg", 
             RowBox[{
              RowBox[{"kg", "+", 
               RowBox[{"wb", " ", "y1"}]}], "<", "y2"}]},
            {"Indeterminate", 
             TagBox["True",
              "PiecewiseDefault",
              AutoDelete->True]}
           },
           AllowedDimensions->{2, Automatic},
           Editable->True,
           GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
           GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}},
           Selectable->True]}
        },
        GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.35]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       "Piecewise",
       DeleteWithContents->True,
       Editable->False,
       SelectWithContents->True,
       Selectable->False,
       StripWrapperBoxes->True]}], ",", 
     RowBox[{"b", "\[Rule]", 
      TagBox[GridBox[{
         {"\[Piecewise]", GridBox[{
            {"y1", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"y1", "<", "0"}], "&&", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"kg", "+", 
                    RowBox[{"wb", " ", "y1"}]}], "\[GreaterEqual]", "y2"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], "<", "y2"}], "&&", 
                    RowBox[{"y2", "<", "0"}]}], ")"}], "||", 
                    RowBox[{"y2", ">", "0"}]}], ")"}]}], ")"}], "||", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], ">", "y2"}], "&&", 
                    RowBox[{
                    RowBox[{"kg", "+", "y2"}], ">", 
                    RowBox[{"wb", " ", "y1"}]}], "&&", 
                    RowBox[{"y2", "<", "0"}]}], ")"}]}], ")"}]}], ")"}], "||", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"y1", ">", "0"}], "&&", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"y2", ">", "0"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"kg", "+", 
                    RowBox[{"wb", " ", "y1"}]}], "\[GreaterEqual]", "y2"}], "&&", 
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], "<", "y2"}]}], ")"}], "||", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], ">", "y2"}], "&&", 
                    RowBox[{
                    RowBox[{"kg", "+", "y2"}], ">", 
                    RowBox[{"wb", " ", "y1"}]}]}], ")"}]}], ")"}]}], ")"}], "||", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"y2", "<", "0"}], "&&", 
                    RowBox[{
                    RowBox[{"kg", "+", "y2"}], ">", 
                    RowBox[{"wb", " ", "y1"}]}]}], ")"}]}], ")"}]}], ")"}]}]},
            {
             FractionBox[
              RowBox[{
               RowBox[{
                RowBox[{"-", "kg"}], " ", "wb"}], "+", "y1", "+", 
               RowBox[{"wb", " ", "y2"}]}], 
              RowBox[{"1", "+", 
               SuperscriptBox["wb", "2"]}]], 
             RowBox[{
              RowBox[{"kg", "+", 
               RowBox[{"wb", " ", "y1"}]}], "<", "y2"}]},
            {
             FractionBox[
              RowBox[{"y1", "+", 
               RowBox[{"wb", " ", 
                RowBox[{"(", 
                 RowBox[{"kg", "+", "y2"}], ")"}]}]}], 
              RowBox[{"1", "+", 
               SuperscriptBox["wb", "2"]}]], 
             RowBox[{
              RowBox[{"kg", "+", "y2"}], "\[LessEqual]", 
              RowBox[{"wb", " ", "y1"}]}]},
            {"Indeterminate", 
             TagBox["True",
              "PiecewiseDefault",
              AutoDelete->True]}
           },
           AllowedDimensions->{2, Automatic},
           Editable->True,
           GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
           GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}},
           Selectable->True]}
        },
        GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.35]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       "Piecewise",
       DeleteWithContents->True,
       Editable->False,
       SelectWithContents->True,
       Selectable->False,
       StripWrapperBoxes->True]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7743640368776946`*^9, 3.774364086608831*^9, 3.774364667769186*^9, 
   3.7743647036843553`*^9, 3.774367296324077*^9, 3.774367369179041*^9, 
   3.7743695510622177`*^9, 3.7775666233998933`*^9, 3.7775666536821904`*^9, 
   3.7775667169684563`*^9, 3.7775726103055887`*^9, 3.7775749613769436`*^9, 
   3.777636578525715*^9, {3.7776393960252132`*^9, 3.7776394127723384`*^9}, 
   3.781437262331766*^9, 3.7814380200670476`*^9, 3.8167091344860806`*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"5092f30a-c9ee-48d9-a492-09c047c6d06d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"bhat", "=", 
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {"y1", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y1", "<", "0"}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"kg", "+", 
                  RowBox[{"wb", " ", "y1"}]}], "\[GreaterEqual]", "y2"}], "&&", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], "<", "y2"}], "&&", 
                    RowBox[{"y2", "<", "0"}]}], ")"}], "||", 
                  RowBox[{"y2", ">", "0"}]}], ")"}]}], ")"}], "||", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"wb", " ", "y1"}], ">", "y2"}], "&&", 
                RowBox[{
                 RowBox[{"kg", "+", "y2"}], ">", 
                 RowBox[{"wb", " ", "y1"}]}], "&&", 
                RowBox[{"y2", "<", "0"}]}], ")"}]}], ")"}]}], ")"}], "||", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y1", ">", "0"}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"y2", ">", "0"}], "&&", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"kg", "+", 
                    RowBox[{"wb", " ", "y1"}]}], "\[GreaterEqual]", "y2"}], "&&", 
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], "<", "y2"}]}], ")"}], "||", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"wb", " ", "y1"}], ">", "y2"}], "&&", 
                    RowBox[{
                    RowBox[{"kg", "+", "y2"}], ">", 
                    RowBox[{"wb", " ", "y1"}]}]}], ")"}]}], ")"}]}], ")"}], "||", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"y2", "<", "0"}], "&&", 
                RowBox[{
                 RowBox[{"kg", "+", "y2"}], ">", 
                 RowBox[{"wb", " ", "y1"}]}]}], ")"}]}], ")"}]}], ")"}]}]},
        {
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "kg"}], " ", "wb"}], "+", "y1", "+", 
           RowBox[{"wb", " ", "y2"}]}], 
          RowBox[{"1", "+", 
           SuperscriptBox["wb", "2"]}]], 
         RowBox[{
          RowBox[{"kg", "+", 
           RowBox[{"wb", " ", "y1"}]}], "<", "y2"}]},
        {
         FractionBox[
          RowBox[{"y1", "+", 
           RowBox[{"wb", " ", 
            RowBox[{"(", 
             RowBox[{"kg", "+", "y2"}], ")"}]}]}], 
          RowBox[{"1", "+", 
           SuperscriptBox["wb", "2"]}]], 
         RowBox[{
          RowBox[{"kg", "+", "y2"}], "\[LessEqual]", 
          RowBox[{"wb", " ", "y1"}]}]},
        {"Indeterminate", 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}},
       Selectable->True]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False,
   StripWrapperBoxes->True]}]], "Input",
 CellChangeTimes->{{3.774367413899248*^9, 3.7743674159544234`*^9}, {
   3.7743694347089653`*^9, 3.774369455336864*^9}, 3.777639465918539*^9},
 CellLabel->"In[7]:=",ExpressionUUID->"32468bd9-1d52-4e63-907d-117dde05c155"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {"y1", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"y1", "<", "0"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"kg", "+", 
                 RowBox[{"wb", " ", "y1"}]}], "\[GreaterEqual]", "y2"}], "&&", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"wb", " ", "y1"}], "<", "y2"}], "&&", 
                   RowBox[{"y2", "<", "0"}]}], ")"}], "||", 
                 RowBox[{"y2", ">", "0"}]}], ")"}]}], ")"}], "||", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"wb", " ", "y1"}], ">", "y2"}], "&&", 
               RowBox[{
                RowBox[{"kg", "+", "y2"}], ">", 
                RowBox[{"wb", " ", "y1"}]}], "&&", 
               RowBox[{"y2", "<", "0"}]}], ")"}]}], ")"}]}], ")"}], "||", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"y1", ">", "0"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"y2", ">", "0"}], "&&", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"kg", "+", 
                    RowBox[{"wb", " ", "y1"}]}], "\[GreaterEqual]", "y2"}], "&&", 
                   RowBox[{
                    RowBox[{"wb", " ", "y1"}], "<", "y2"}]}], ")"}], "||", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"wb", " ", "y1"}], ">", "y2"}], "&&", 
                   RowBox[{
                    RowBox[{"kg", "+", "y2"}], ">", 
                    RowBox[{"wb", " ", "y1"}]}]}], ")"}]}], ")"}]}], ")"}], "||", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"y2", "<", "0"}], "&&", 
               RowBox[{
                RowBox[{"kg", "+", "y2"}], ">", 
                RowBox[{"wb", " ", "y1"}]}]}], ")"}]}], ")"}]}], ")"}]}]},
       {
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "kg"}], " ", "wb"}], "+", "y1", "+", 
          RowBox[{"wb", " ", "y2"}]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["wb", "2"]}]], 
        RowBox[{
         RowBox[{"kg", "+", 
          RowBox[{"wb", " ", "y1"}]}], "<", "y2"}]},
       {
        FractionBox[
         RowBox[{"y1", "+", 
          RowBox[{"wb", " ", 
           RowBox[{"(", 
            RowBox[{"kg", "+", "y2"}], ")"}]}]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["wb", "2"]}]], 
        RowBox[{
         RowBox[{"kg", "+", "y2"}], "\[LessEqual]", 
         RowBox[{"wb", " ", "y1"}]}]},
       {"Indeterminate", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}},
      Selectable->True]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False,
  StripWrapperBoxes->True]], "Output",
 CellChangeTimes->{
  3.7743690877539735`*^9, {3.7743694365768995`*^9, 3.7743694557953253`*^9}, 
   3.7743702128823357`*^9, 3.7743717758520455`*^9, 3.774371876337479*^9, 
   3.77445771639119*^9, 3.774469718791998*^9, 3.7744698480351353`*^9, 
   3.7745269128435125`*^9, 3.7775666259958253`*^9, {3.777566690562007*^9, 
   3.777566717468334*^9}, 3.7775726105086813`*^9, 3.7775733635659227`*^9, 
   3.77757496215801*^9, 3.7776365790255365`*^9, 3.781437304216037*^9, 
   3.7814380204121284`*^9, 3.782214467650053*^9, 3.816709135747077*^9, 
   3.8169697485433774`*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"1e7b2ddd-2390-470b-8e9e-03839bceba9c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"iemp", "=", "5"}], ";", 
  RowBox[{"kmax", "=", "5.5"}], ";", 
  RowBox[{"omfac", "=", "4"}], ";", 
  RowBox[{"fzind", "=", "5"}], ";", " ", 
  RowBox[{"(*", " ", "Lottery", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Kdel", "=."}]}]], "Input",
 CellChangeTimes->{{3.816709294884155*^9, 3.8167093239252863`*^9}, {
  3.816969882093438*^9, 3.8169699017597733`*^9}, {3.8169706288741517`*^9, 
  3.8169706310361633`*^9}},ExpressionUUID->"745ceb9c-b6b4-4718-aace-\
016ad6ad4832"],

Cell[BoxData[
 RowBox[{
  RowBox[{"iemp", "=", "2"}], ";", 
  RowBox[{"kmax", "=", "0.15"}], ";", 
  RowBox[{"omfac", "=", "4"}], ";", 
  RowBox[{"fzind", "=", "5"}], ";", " ", 
  RowBox[{"(*", " ", "Crimes", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Kdel", "=."}]}]], "Input",
 CellChangeTimes->{{3.7743679651758533`*^9, 3.774367969894477*^9}, {
  3.777578626727832*^9, 3.7775786288614545`*^9}, {3.8167092770931916`*^9, 
  3.8167092865051017`*^9}, {3.8167093462791944`*^9, 3.816709365365836*^9}, {
  3.8169698129528546`*^9, 3.816969814384074*^9}, {3.8169705868490734`*^9, 
  3.8169705916360655`*^9}},
 CellLabel->
  "In[242]:=",ExpressionUUID->"2d68e2c8-fb95-4903-9bde-9c3100eeb4c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"iemp", "=", "1"}], ";", 
  RowBox[{"kmax", "=", ".35"}], ";", 
  RowBox[{"omfac", "=", "4"}], ";", 
  RowBox[{"fzind", "=", "4"}], ";", " ", 
  RowBox[{"Kdel", "=."}], ";", 
  RowBox[{"(*", "Roses", "*)"}]}]], "Input",
 CellChangeTimes->{{3.8167093723505774`*^9, 3.8167093799055347`*^9}, {
   3.8169698186603165`*^9, 3.8169698285027866`*^9}, {3.816969904246364*^9, 
   3.8169699106194267`*^9}, 3.8169702636070833`*^9, 3.816970391674095*^9, {
   3.8169704894099836`*^9, 3.8169704898022594`*^9}, {3.8169705271748*^9, 
   3.8169705332501774`*^9}},ExpressionUUID->"d1e25160-3ac7-4e6e-acca-\
6c7cca25c18b"],

Cell[CellGroupData[{

Cell[BoxData["iemp"], "Input",
 CellChangeTimes->{{3.816969978404934*^9, 3.8169699807481756`*^9}},
 CellLabel->"In[84]:=",ExpressionUUID->"268b46ae-c5cb-4662-b0d4-9b273e8ba1db"],

Cell[BoxData["5"], "Output",
 CellChangeTimes->{3.816969981441129*^9, 3.8169702673720646`*^9},
 CellLabel->"Out[84]=",ExpressionUUID->"c6bf5b44-4f59-4e67-94a8-0f2eb768110c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"emptab", "=", 
   RowBox[{
   "Import", "[", "\"\<c:/dropbox/mystuff/sparsity/revision/emptab.csv\>\"", 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"bs", "=", 
  RowBox[{"emptab", "[", 
   RowBox[{"[", 
    RowBox[{"6", ",", "iemp"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"bl", "=", 
  RowBox[{"emptab", "[", 
   RowBox[{"[", 
    RowBox[{"5", ",", "iemp"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Om11", "=", 
  RowBox[{"emptab", "[", 
   RowBox[{"[", 
    RowBox[{"10", ",", "iemp"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Om12", "=", 
  RowBox[{"emptab", "[", 
   RowBox[{"[", 
    RowBox[{"11", ",", "iemp"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Om22", "=", 
  RowBox[{"emptab", "[", 
   RowBox[{"[", 
    RowBox[{"12", ",", "iemp"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Kdel", "=", 
  RowBox[{"kappa", " ", 
   RowBox[{"Sqrt", "[", 
    RowBox[{"emptab", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "iemp"}], "]"}], "]"}], "]"}], 
   RowBox[{"Sqrt", "[", 
    RowBox[{
     RowBox[{"emptab", "[", 
      RowBox[{"[", 
       RowBox[{"4", ",", "iemp"}], "]"}], "]"}], "/", 
     RowBox[{"emptab", "[", 
      RowBox[{"[", 
       RowBox[{"9", ",", "iemp"}], "]"}], "]"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Omr", "=", 
  RowBox[{"Om12", "/", 
   RowBox[{"Sqrt", "[", 
    RowBox[{"Om11", "*", "Om22"}], "]"}]}]}], "\n", 
 RowBox[{"omsd", "=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    RowBox[{"Om11", "*", "Om22"}], "-", 
    RowBox[{"Om12", "^", "2"}]}], "]"}]}], "\n", 
 RowBox[{"kg", "=", 
  RowBox[{"Kdel", "*", 
   RowBox[{
    RowBox[{"Sqrt", "[", "Om11", "]"}], "/", 
    "omsd"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"wb", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Om11", "-", "Om12"}], ")"}], "/", "omsd"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"kg", ",", "wb"}], "}"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"y1", "=", 
  RowBox[{"bl", "/", 
   RowBox[{"Sqrt", "[", "Om11", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"y2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"wb", " ", "/", 
        RowBox[{"Sqrt", "[", "Om11", "]"}]}], "-", 
       RowBox[{
        RowBox[{"Sqrt", "[", "Om11", "]"}], "/", "omsd"}]}], ")"}], " ", 
     "bl"}], " ", "+", 
    RowBox[{
     RowBox[{
      RowBox[{"Sqrt", "[", "Om11", "]"}], "/", "omsd"}], " ", "bs"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"ysign", "=", "1"}], "\[IndentingNewLine]", 
 RowBox[{"Omi", "=", 
  RowBox[{"Inverse", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Om11", ",", "Om12"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Om12", ",", "Om22"}], "}"}]}], "}"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"{", 
    RowBox[{"wb", ",", "kg", ",", "ysign", ",", "y1", ",", "y2"}], "}"}], 
   "]"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.7743681242631087`*^9, 3.774368146111625*^9}, {
   3.7743681814009237`*^9, 3.774368258041643*^9}, {3.7743684376618805`*^9, 
   3.7743685161980753`*^9}, {3.774368598623523*^9, 3.7743686028310595`*^9}, 
   3.774368640712762*^9, 3.7743687041830177`*^9, {3.774368746862663*^9, 
   3.774369000840945*^9}, {3.774369482316179*^9, 3.7743694960516605`*^9}, {
   3.774371739722481*^9, 3.7743717398484507`*^9}, 3.774371868171674*^9, {
   3.774457722065549*^9, 3.7744577221615486`*^9}, {3.7745284616230717`*^9, 
   3.7745284623183594`*^9}, {3.7775667250158477`*^9, 3.7775667285934505`*^9}, 
   3.777568753343133*^9, 3.777569037572446*^9, {3.7775727784619045`*^9, 
   3.7775727785711937`*^9}, {3.7775733161318274`*^9, 
   3.7775733163323097`*^9}, {3.7775733691375475`*^9, 3.777573369547188*^9}, {
   3.7775734065782843`*^9, 3.7775734067625713`*^9}, 3.777573460631276*^9, {
   3.7775738028976736`*^9, 3.777573809621539*^9}, 3.777573904046383*^9, 
   3.7775739419225736`*^9, 3.7775740616733756`*^9, {3.7775748700061455`*^9, 
   3.7775748935031524`*^9}, {3.7775751407541766`*^9, 3.777575140879178*^9}, {
   3.777576102267558*^9, 3.7775761066900945`*^9}, {3.7775770015245*^9, 
   3.777577002846805*^9}, {3.7775786313372097`*^9, 3.7775786323216305`*^9}, {
   3.7775791650800695`*^9, 3.7775791663302107`*^9}, {3.7776359956568117`*^9, 
   3.7776360392387934`*^9}, {3.7776360865529137`*^9, 3.7776361518625164`*^9}, 
   3.7776361897183*^9, {3.777636297709329*^9, 3.777636326241768*^9}, 
   3.777636718549237*^9, {3.7776367638201513`*^9, 3.7776368023540545`*^9}, {
   3.777637690093341*^9, 3.7776377244761558`*^9}, {3.7776377763970184`*^9, 
   3.777637779901645*^9}, {3.7776379542750597`*^9, 3.777637954430646*^9}, {
   3.777639138265063*^9, 3.777639139151288*^9}, {3.7814373266837797`*^9, 
   3.7814373268184195`*^9}, {3.781438933851613*^9, 3.781438948149887*^9}, 
   3.7814390722291126`*^9, 3.781439916776425*^9, 3.781441246489461*^9, {
   3.7815224840606008`*^9, 3.781522512512521*^9}, {3.781522616259551*^9, 
   3.7815226215443807`*^9}, {3.781522771940233*^9, 3.7815228099615746`*^9}, {
   3.781522860460537*^9, 3.7815228614987597`*^9}, 3.781524807206822*^9, 
   3.7815254084094067`*^9, 3.782214482180217*^9, {3.816709230230401*^9, 
   3.8167092307577453`*^9}, {3.816709265128355*^9, 3.816709274595997*^9}, 
   3.816969754790519*^9, 3.8169699591722217`*^9, {3.8169701919077663`*^9, 
   3.816970204326124*^9}, {3.8169703778893766`*^9, 3.8169703786734543`*^9}, 
   3.8169704160191526`*^9},
 CellLabel->
  "In[243]:=",ExpressionUUID->"bd89a553-9c87-42d4-8ef5-027f3d36348e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"372", ",", "576", ",", "576", ",", "576", ",", "496"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"112", ",", "20", ",", "20", ",", "20", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"123", ",", "284", ",", "284", ",", "284", ",", "25"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
    "0.652195747`", ",", "0.996059917`", ",", "0.986900777`", ",", 
     "0.994395098`", ",", "0.762650306`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.241897211`", ",", "0.013518003`", ",", 
     RowBox[{"-", "0.194978235`"}], ",", "2.342625285`", ",", 
     RowBox[{"-", "0.049314915`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.544456345`", ",", 
     RowBox[{"-", "0.152097444`"}], ",", 
     RowBox[{"-", "0.108376262`"}], ",", 
     RowBox[{"-", "0.20386472`"}], ",", 
     RowBox[{"-", "0.052232677`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "81.22626497`", ",", "2.781405915`", ",", "1.18845601`", ",", 
     "36.86844353`", ",", "89615.63648`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "99.74868494`", ",", "2.834253019`", ",", "1.232577027`", ",", 
     "36.94682796`", ",", "92864.81076`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "62.48439953`", ",", "2.284427416`", ",", "3.756446279`", ",", 
     "1.886017084`", ",", "1.190936025`*^6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.019066846`", ",", "0.45233364`", ",", "0.045603779`", ",", 
     "4.011997718`", ",", "0.001444088`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.005047525`", ",", 
     RowBox[{"-", "0.002622607`"}], ",", "0.001749953`", ",", 
     RowBox[{"-", "0.000731984`"}], ",", "0.00021241`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.009843326`", ",", "0.001110476`", ",", "0.000471097`", ",", 
     "0.004359847`", ",", "0.000104864`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.8169706606212244`*^9},
 CellLabel->
  "Out[243]=",ExpressionUUID->"c3d33049-202c-4640-a648-2ce8044daab3"],

Cell[BoxData[
 RowBox[{"-", "0.152097444`"}]], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.816970660631181*^9},
 CellLabel->
  "Out[244]=",ExpressionUUID->"902a7181-7c29-40dd-a635-b8fade1d4769"],

Cell[BoxData["0.013518003`"], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.816970660639146*^9},
 CellLabel->
  "Out[245]=",ExpressionUUID->"fde1b8d8-79b6-479d-afd0-6bf2ae4564da"],

Cell[BoxData["0.45233364`"], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.816970660646115*^9},
 CellLabel->
  "Out[246]=",ExpressionUUID->"94513750-5b8d-4e31-8135-765676c94f57"],

Cell[BoxData[
 RowBox[{"-", "0.002622607`"}]], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.8169706606560717`*^9},
 CellLabel->
  "Out[247]=",ExpressionUUID->"306f2c92-d7c7-4b60-967f-51e1fc990595"],

Cell[BoxData["0.001110476`"], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.8169706606680193`*^9},
 CellLabel->
  "Out[248]=",ExpressionUUID->"6e1ccbad-112d-4869-9f25-5916942c5317"],

Cell[BoxData[
 RowBox[{"15.847665350743831`", " ", "kappa"}]], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.816970660674988*^9},
 CellLabel->
  "Out[249]=",ExpressionUUID->"0f0cc9c7-1936-478f-850c-9aceb841142e"],

Cell[BoxData[
 RowBox[{"-", "0.11701706039601718`"}]], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.8169706606869354`*^9},
 CellLabel->
  "Out[250]=",ExpressionUUID->"2f5421b3-5656-4c11-80fe-5280790ebe4e"],

Cell[BoxData["0.022258202616927337`"], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.816970660690918*^9},
 CellLabel->
  "Out[251]=",ExpressionUUID->"993da9a5-a51c-492c-9462-8b781763db7b"],

Cell[BoxData[
 RowBox[{"478.85568085404833`", " ", "kappa"}]], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.81697066070187*^9},
 CellLabel->
  "Out[252]=",ExpressionUUID->"9bdd624c-c8c9-46ed-85cf-fb3afcfe8d0b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"478.85568085404833`", " ", "kappa"}], ",", 
   "20.439936450843803`"}], "}"}]], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.816970660706848*^9},
 CellLabel->
  "Out[254]=",ExpressionUUID->"814b16ac-1cc6-4904-a0a9-b8f8707b97fc"],

Cell[BoxData["0.020099400073483247`"], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.8169706607128215`*^9},
 CellLabel->
  "Out[255]=",ExpressionUUID->"3bda289b-9058-4119-ab9d-180b14514806"],

Cell[BoxData[
 RowBox[{"-", "4.593433314803125`"}]], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.8169706607227774`*^9},
 CellLabel->
  "Out[256]=",ExpressionUUID->"be3a3ccb-bf25-4d70-ac50-bd8701468353"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.816970660731738*^9},
 CellLabel->
  "Out[257]=",ExpressionUUID->"393bed63-a279-4905-a0ad-383b0688c119"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2.2414496819606122`", ",", "5.293623298529348`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5.293623298529348`", ",", "913.0166644917011`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.8169706607397037`*^9},
 CellLabel->
  "Out[258]=",ExpressionUUID->"90399d78-fb33-49d1-90af-7025bbd21741"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"20.439936450843803`", ",", 
   RowBox[{"478.85568085404833`", " ", "kappa"}], ",", "1", ",", 
   "0.020099400073483247`", ",", 
   RowBox[{"-", "4.593433314803125`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7743681481434417`*^9, 3.774368175576493*^9}, {
   3.7743682189867496`*^9, 3.7743682254782743`*^9}, {3.7743684836862783`*^9, 
   3.7743684936337743`*^9}, {3.774368992196599*^9, 3.774369001492945*^9}, 
   3.7743694966844325`*^9, 3.774370047877764*^9, 3.774371740436451*^9, 
   3.7743718685916705`*^9, 3.774457722908629*^9, 3.7744697254953794`*^9, 
   3.7745269145201235`*^9, 3.7745284635365453`*^9, 3.77756666759883*^9, 
   3.7775667291404085`*^9, 3.7775687536865253`*^9, 3.7775690385223503`*^9, 
   3.7775723254693413`*^9, 3.777572428480862*^9, 3.7775726142045584`*^9, 
   3.777572779401431*^9, 3.7775733168720603`*^9, 3.7775733709575567`*^9, 
   3.777573407309074*^9, 3.777573461021809*^9, 3.7775738121847363`*^9, 
   3.777573909668846*^9, 3.7775739430482864`*^9, 3.777574064289603*^9, 
   3.7775748992667494`*^9, 3.7775749657247915`*^9, 3.7775751414861603`*^9, 
   3.777576107267809*^9, 3.7775770045993657`*^9, 3.777578290647583*^9, 
   3.7775786330290623`*^9, 3.7775791692935066`*^9, 3.777636326811829*^9, 
   3.7776365863108788`*^9, 3.7776367196089587`*^9, {3.7776367748180437`*^9, 
   3.7776368027873077`*^9}, 3.777637691877846*^9, 3.7776377253471575`*^9, 
   3.7776377827011857`*^9, 3.777637955043007*^9, 3.7776391400180225`*^9, 
   3.781437270667468*^9, 3.781437327378927*^9, 3.781438026271432*^9, 
   3.7814389556580925`*^9, 3.781439076951457*^9, 3.7814399187722116`*^9, 
   3.7814412481769266`*^9, {3.7815228013336167`*^9, 3.781522829206112*^9}, 
   3.7815228623853645`*^9, 3.781524808154311*^9, 3.781525424148346*^9, 
   3.782214483461771*^9, 3.8167091610311365`*^9, 3.8169699172757187`*^9, 
   3.816969959628217*^9, 3.8169702070951595`*^9, 3.816970270450056*^9, {
   3.8169703964819994`*^9, 3.816970417691726*^9}, 3.816970492796622*^9, 
   3.816970543282656*^9, 3.8169706001188283`*^9, 3.8169706607506557`*^9},
 CellLabel->
  "Out[259]=",ExpressionUUID->"c6d6f665-2b60-4cbc-849e-30650d3f7daf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"pdata", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"cvx", "[", "j", "]"}], "=", 
           RowBox[{"getcv", "[", 
            RowBox[{"j", ",", "kg", ",", "wb"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], ";", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", "kappa", "}"}], ",", 
          RowBox[{"Flatten", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"FindRoot", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"getLRr", "[", 
                  RowBox[{
                   RowBox[{"y1", "-", "b"}], ",", 
                   RowBox[{"y2", "-", 
                    RowBox[{"wb", " ", "b"}]}], ",", "kg", ",", "wb"}], "]"}],
                  "\[Equal]", 
                 RowBox[{"cvx", "[", "j", "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"b", ",", 
                  RowBox[{"bhat", "+", 
                   RowBox[{"2", " ", "ix"}]}]}], "}"}]}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", "3"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"ix", ",", 
               RowBox[{"-", "1"}], ",", "1", ",", "2"}], "}"}]}], "]"}], 
           "]"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"kappa", ",", "0", ",", "kmax", ",", 
         RowBox[{"kmax", "/", "50"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xx", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"pdata", "[", 
          RowBox[{"[", 
           RowBox[{"j", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"Sqrt", "[", "Om11", "]"}], 
          RowBox[{"pdata", "[", 
           RowBox[{"[", 
            RowBox[{"j", ",", "i"}], "]"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "2", ",", 
         RowBox[{
          RowBox[{"Dimensions", "[", "pdata", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", 
         RowBox[{
          RowBox[{"Dimensions", "[", "pdata", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xx", "=", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"pdata", "[", 
             RowBox[{"[", 
              RowBox[{"j", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"0.5", 
             RowBox[{"Sqrt", "[", "Om11", "]"}], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"pdata", "[", 
                RowBox[{"[", 
                 RowBox[{"j", ",", "4"}], "]"}], "]"}], "+", 
               RowBox[{"pdata", "[", 
                RowBox[{"[", 
                 RowBox[{"j", ",", "5"}], "]"}], "]"}]}], ")"}]}]}], "}"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", 
            RowBox[{
             RowBox[{"Dimensions", "[", "pdata", "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], "}"}], ",", 
       "xx"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"f", "=", 
    RowBox[{"Interpolation", "[", 
     RowBox[{"xx", "[", 
      RowBox[{"[", "fzind", "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"kstar", "=", 
    RowBox[{
     RowBox[{"FindRoot", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"f", "[", "x", "]"}], "\[Equal]", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "\[IndentingNewLine]", 
         RowBox[{"kmax", "/", "4"}]}], "}"}]}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xx", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"xx", ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"kstar", ",", 
            RowBox[{"bl", "-", 
             RowBox[{"0.8", " ", "omfac", " ", 
              RowBox[{"Sqrt", "[", "Om11", "]"}]}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"kstar", ",", 
            RowBox[{"bl", "+", 
             RowBox[{".98", " ", "omfac", " ", 
              RowBox[{"Sqrt", "[", "Om11", "]"}]}]}]}], "}"}]}], "}"}], 
        "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"style", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Black"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteDashing", "[", 
          RowBox[{"{", 
           RowBox[{".6", ",", "2"}], "}"}], "]"}], ",", 
         RowBox[{"AbsoluteThickness", "[", ".8", "]"}], ",", "Black"}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "0.8", "]"}], ",", "Black"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteDashing", "[", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", ".6", ",", "2"}], "}"}], "]"}], ",", 
         RowBox[{"AbsoluteThickness", "[", ".8", "]"}], ",", "Black"}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteDashing", "[", 
          RowBox[{"{", 
           RowBox[{"8", ",", "2"}], "}"}], "]"}], ",", 
         RowBox[{"AbsoluteThickness", "[", ".8", "]"}], ",", "Black"}], 
        "}"}]}], "\[IndentingNewLine]", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"stylex", "=", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"style", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "}"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"style", "[", 
              RowBox[{"[", 
               RowBox[{"j", "+", "1"}], "]"}], "]"}], ",", 
             RowBox[{"style", "[", 
              RowBox[{"[", 
               RowBox[{"j", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", "4"}], "}"}]}], "]"}], ",", "1"}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"p", "=", 
    RowBox[{"ListPlot", "[", 
     RowBox[{"xx", ",", 
      RowBox[{"Joined", "->", "True"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", "stylex"}], ",", 
      RowBox[{"LabelStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Cmr10\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "12"}]}], "}"}]}], ",", 
      RowBox[{"AxesStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"AbsoluteThickness", "[", ".8", "]"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"AbsoluteThickness", "[", ".8", "]"}], "}"}]}], "}"}]}], 
      ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"bl", "-", 
          RowBox[{"omfac", " ", 
           RowBox[{"Sqrt", "[", "Om11", "]"}]}]}], ",", 
         RowBox[{"bl", "+", 
          RowBox[{"omfac", " ", 
           RowBox[{"Sqrt", "[", "Om11", "]"}]}]}]}], "}"}]}]}], 
     "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.77437008047792*^9, 3.7743703752221084`*^9}, {
   3.774370405584813*^9, 3.774370419302476*^9}, {3.7743704499800158`*^9, 
   3.7743705028514214`*^9}, {3.774370554641017*^9, 3.774370620987212*^9}, {
   3.7743715082019987`*^9, 3.7743715283629255`*^9}, {3.7743715839874067`*^9, 
   3.774371667874858*^9}, 3.774371699385671*^9, {3.7743717860013933`*^9, 
   3.7743718181780243`*^9}, {3.774456253250846*^9, 3.7744563752787285`*^9}, {
   3.7744564493289504`*^9, 3.774456491818314*^9}, {3.774456523654153*^9, 
   3.774456584196559*^9}, {3.7744566944380083`*^9, 3.7744567410145435`*^9}, {
   3.774456849314615*^9, 3.7744568569434605`*^9}, {3.774456927716626*^9, 
   3.7744571321909094`*^9}, {3.7744571669358244`*^9, 
   3.7744571847889867`*^9}, {3.7744572333008327`*^9, 3.774457459397308*^9}, {
   3.7744574923450775`*^9, 3.7744575396552563`*^9}, {3.774457580684765*^9, 
   3.7744575855323396`*^9}, {3.7744576436836624`*^9, 
   3.7744576626599607`*^9}, {3.774457743746828*^9, 3.7744577778447075`*^9}, {
   3.7744578645080614`*^9, 3.77445786474209*^9}, {3.774458035500946*^9, 
   3.774458169987397*^9}, {3.7744582067490015`*^9, 3.7744582111288133`*^9}, {
   3.7744582829114923`*^9, 3.774458482817387*^9}, {3.77446833290809*^9, 
   3.774468624820567*^9}, {3.774468681014677*^9, 3.7744686946467543`*^9}, {
   3.7744687511896944`*^9, 3.774468776783787*^9}, {3.774526923087289*^9, 
   3.7745269233852673`*^9}, {3.774526954916053*^9, 3.7745269854209757`*^9}, {
   3.7745270163879647`*^9, 3.774527019597522*^9}, {3.7745270595998945`*^9, 
   3.7745270636359625`*^9}, {3.7745284869572906`*^9, 
   3.7745284958270226`*^9}, {3.7745285339823627`*^9, 3.77452855311471*^9}, {
   3.774528605974845*^9, 3.7745286071462526`*^9}, {3.7746333841921673`*^9, 
   3.774633384686489*^9}, {3.774633430230241*^9, 3.7746334517894335`*^9}, {
   3.774633980542282*^9, 3.77463398137586*^9}, {3.7775667441097555`*^9, 
   3.77756674435982*^9}, 3.777572334064473*^9, {3.7775723849926133`*^9, 
   3.7775723868778653`*^9}, {3.7775726212530546`*^9, 
   3.7775726248947906`*^9}, {3.7775727899503884`*^9, 3.777572793325038*^9}, {
   3.777572829482501*^9, 3.777572830183613*^9}, {3.777573029826413*^9, 
   3.777573033015111*^9}, {3.7775730638955107`*^9, 3.7775730822980604`*^9}, {
   3.777573279440253*^9, 3.7775732795028358`*^9}, 3.777573386440262*^9, {
   3.777573417816727*^9, 3.7775734444056187`*^9}, 3.7775735033484592`*^9, {
   3.777573548278391*^9, 3.7775735991564875`*^9}, {3.7775736720740175`*^9, 
   3.7775736723760967`*^9}, {3.777573760004207*^9, 3.777573780752555*^9}, {
   3.7775739651320734`*^9, 3.7775739866121206`*^9}, 3.7775749754684277`*^9, 
   3.7775751233151336`*^9, {3.7775751718149405`*^9, 3.777575205090315*^9}, {
   3.7775757126391015`*^9, 3.777575739079316*^9}, {3.777575780615308*^9, 
   3.7775757967638245`*^9}, {3.777575839752024*^9, 3.7775759130159235`*^9}, 
   3.777575981344122*^9, {3.7775760467509184`*^9, 3.777576048050289*^9}, {
   3.777576151639823*^9, 3.777576156936764*^9}, {3.7775762101845655`*^9, 
   3.7775762124248495`*^9}, 3.7775786021942973`*^9, {3.777578648581264*^9, 
   3.777578650533946*^9}, 3.7775790013663607`*^9, {3.7775791803928757`*^9, 
   3.777579180986476*^9}, {3.777636375349739*^9, 3.7776363955031743`*^9}, {
   3.7776378256718864`*^9, 3.777637828995778*^9}, {3.777637863207218*^9, 
   3.777637888753727*^9}, {3.7776379288936195`*^9, 3.7776379340711007`*^9}, {
   3.7776380282727866`*^9, 3.77763804539795*^9}, {3.781437281536525*^9, 
   3.781437282808096*^9}, {3.7814373679590483`*^9, 3.7814374029770174`*^9}, 
   3.7814374520710096`*^9, {3.7814379648549747`*^9, 3.7814379650095267`*^9}, {
   3.7814380346472006`*^9, 3.781438113451067*^9}, {3.781438178126905*^9, 
   3.7814382712084765`*^9}, {3.781438311815318*^9, 3.7814384022935534`*^9}, {
   3.7814384369914603`*^9, 3.781438438559353*^9}, {3.7814385342485228`*^9, 
   3.781438624074587*^9}, {3.781438674685787*^9, 3.781438706365588*^9}, {
   3.7814387391373363`*^9, 3.7814387428094816`*^9}, {3.7814389686825237`*^9, 
   3.7814389696668916`*^9}, {3.7814391090945425`*^9, 
   3.7814391928020763`*^9}, {3.7814392240199594`*^9, 
   3.7814392573607826`*^9}, {3.781439337065467*^9, 3.7814394077396264`*^9}, 
   3.781439718651235*^9, {3.781441279432602*^9, 3.7814412797846537`*^9}, {
   3.7815228785581484`*^9, 3.7815229901935997`*^9}, {3.7815242676536393`*^9, 
   3.78152426934312*^9}, {3.7815248161050425`*^9, 3.781524833502532*^9}, {
   3.7815254325857906`*^9, 3.781525481352381*^9}, {3.7815255157404304`*^9, 
   3.7815255327579274`*^9}, {3.781525566249335*^9, 3.781525566593448*^9}, {
   3.7822145002149396`*^9, 3.782214503410423*^9}, 3.816709258015339*^9, {
   3.816709306434519*^9, 3.8167093349130335`*^9}, {3.8169702330986147`*^9, 
   3.816970234930093*^9}, {3.8169705657919416`*^9, 3.8169705675153694`*^9}, {
   3.816970635954556*^9, 3.8169706420362644`*^9}},
 CellLabel->
  "In[260]:=",ExpressionUUID->"65f8f8be-4de0-4a0d-94a4-e22b83d33f79"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["InterpolatingFunction",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{{{}, {}, 
                TagBox[{
                  Directive[
                   Opacity[1.], 
                   RGBColor[0.368417, 0.506779, 0.709798], 
                   AbsoluteThickness[1]], 
                  LineBox[CompressedData["
1:eJwVz30w2wccBvCMzstWBIuoFnUpXVZGWI/Fy9Nq6a1sanSjNj1GW1MzW9uN
XWe36gUtjZeupel00rGGEAmJ0IgE05M6ap22iQrzduotiGDV2c8f33vuc/fc
Pfd1SUz/ONmIRCIFELeVKxX6hvuDrkHsjtCwS1ea5S2q0yNUsyT4F57782ok
Xy6/18fp0J6D/Jdj2c9RKP+x5eyBUONs2BSZVEtqyjBYof1pITMHSvtruzWp
Avh1Uqk2w3kQRHmLko+2wuxa/9sOk4UYyHxktSlVYsBxu9+GezF6AjJ/DmY+
QECk45iXuhQSTnXEvtu9eP5kPiwm9ga6XUL5tIhHSOxj9X1pWQ4/1b++HKPH
cHYYJX99nYOR/czz6pxBrCqqn7VYVeDd+B+6wlaf4sRcefya9g46/Z+F2XI0
OE4Lrt/uUgkvUdYXl8jDUFp/WGB3kYukWOoYI24EsjpLz46Bu8iRHPBOqxpF
9HmBZ4p1Fc5MD224qv9BvL5Jti21GjuZi7lqt3EY377FK+P/AUum3++8zyaw
87/xPXve5MHH02mRVzMJhcVEYmRiDVqum2VolqdgdKRr87vKWmiCmKMnXKch
9jN/p/QVH5HupTdU6S9gEu0hunewHkk2B+dZ3BksWW4jNUCAXNhy0/tn4XCM
Nmc6KwDL6dSpGco8yFXCPM3VBnSapf7NP7wAPF2epfsLYekzM90fokNTAln4
waQQYg+vSe6EDuubHLfJyyKk3NFLzbMWcSFLk/DKuxHkh2/tcnZYgsI8P7zo
cSN67ENu/lq3hCidbZnhmyaoJyz0u7EMJ1FE7aCTGOvLAkqGehmS/Jdf+cjF
GP5e+IKVokdeUOzaG2kS6Bx36IdeWwHddC/jpFUzpoYjP80rXAF5b78qp64Z
ykXnzgZjAxi0fR6ucVKUm96keQYZ4PyeITB4Q4rWzflxMQw44vItRc1rAY8R
Tm0MNECcrPro0CetQAzjEJ/wUluJL91AWDsWV0f4jN5iKo97H+wHjIUmwrVB
ayGnQ2SQclllcsK+IzITu3EZUtqYTAXhl5/vLwS7Dauu7vkSwgW6XV0TXnJw
7eqMhIRjToqVJlo5iq13/LXlxmJK0cbhdvgvcXKlhGmkXPvG0nasDJDudhCu
j4syps+0o7dkdv0h4UrFYMiQvwJs0pXYHsJCimgmvESB3tfpI72EkykXg92m
FVh90l3ZSTjbeVMX+L4Slcd/m23e+peqNrJlKzFemqDd2o92SDvrNqpEd1mG
jYiwaY7Mw8enA3Oqggtb/f8BFtPfAw==
                   "]]}, 
                 Annotation[#, "Charting`Private`Tag$99507#1"]& ]}}, {}}, {
             DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
              AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
              GridLines -> {None, None}, DisplayFunction -> Identity, 
              PlotRangePadding -> {{
                 Scaled[0.1], 
                 Scaled[0.1]}, {
                 Scaled[0.1], 
                 Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
              All, DisplayFunction -> Identity, AspectRatio -> 1, 
              Axes -> {False, False}, AxesLabel -> {None, None}, 
              AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
              Frame -> {{True, True}, {True, True}}, 
              FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
              Directive[
                Opacity[0.5], 
                Thickness[Tiny], 
                RGBColor[0.368417, 0.506779, 0.709798]], 
              FrameTicks -> {{None, None}, {None, None}}, 
              GridLines -> {None, None}, GridLinesStyle -> Directive[
                GrayLevel[0.5, 0.4]], ImageSize -> 
              Dynamic[{
                Automatic, 3.5 CurrentValue["FontCapHeight"]/
                 AbsoluteCurrentValue[Magnification]}], 
              Method -> {
               "DefaultBoundaryStyle" -> Automatic, 
                "DefaultGraphicsInteraction" -> {
                 "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                  "Effects" -> {
                   "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                "DefaultMeshStyle" -> AbsolutePointSize[6], 
                "ScalingFunctions" -> None, 
                "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
              PlotRange -> {{0., 0.15}, {-0.09587879741481076, 
               1.3905552809446664`}}, PlotRangeClipping -> True, 
              PlotRangePadding -> {{
                 Scaled[0.1], 
                 Scaled[0.1]}, {
                 Scaled[0.1], 
                 Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "0.15`"}], "}"}], "}"}], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"scalar\"", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{{{}, {}, 
                TagBox[{
                  Directive[
                   Opacity[1.], 
                   RGBColor[0.368417, 0.506779, 0.709798], 
                   AbsoluteThickness[1]], 
                  LineBox[CompressedData["
1:eJwVz30w2wccBvCMzstWBIuoFnUpXVZGWI/Fy9Nq6a1sanSjNj1GW1MzW9uN
XWe36gUtjZeupel00rGGEAmJ0IgE05M6ap22iQrzduotiGDV2c8f33vuc/fc
Pfd1SUz/ONmIRCIFELeVKxX6hvuDrkHsjtCwS1ea5S2q0yNUsyT4F57782ok
Xy6/18fp0J6D/Jdj2c9RKP+x5eyBUONs2BSZVEtqyjBYof1pITMHSvtruzWp
Avh1Uqk2w3kQRHmLko+2wuxa/9sOk4UYyHxktSlVYsBxu9+GezF6AjJ/DmY+
QECk45iXuhQSTnXEvtu9eP5kPiwm9ga6XUL5tIhHSOxj9X1pWQ4/1b++HKPH
cHYYJX99nYOR/czz6pxBrCqqn7VYVeDd+B+6wlaf4sRcefya9g46/Z+F2XI0
OE4Lrt/uUgkvUdYXl8jDUFp/WGB3kYukWOoYI24EsjpLz46Bu8iRHPBOqxpF
9HmBZ4p1Fc5MD224qv9BvL5Jti21GjuZi7lqt3EY377FK+P/AUum3++8zyaw
87/xPXve5MHH02mRVzMJhcVEYmRiDVqum2VolqdgdKRr87vKWmiCmKMnXKch
9jN/p/QVH5HupTdU6S9gEu0hunewHkk2B+dZ3BksWW4jNUCAXNhy0/tn4XCM
Nmc6KwDL6dSpGco8yFXCPM3VBnSapf7NP7wAPF2epfsLYekzM90fokNTAln4
waQQYg+vSe6EDuubHLfJyyKk3NFLzbMWcSFLk/DKuxHkh2/tcnZYgsI8P7zo
cSN67ENu/lq3hCidbZnhmyaoJyz0u7EMJ1FE7aCTGOvLAkqGehmS/Jdf+cjF
GP5e+IKVokdeUOzaG2kS6Bx36IdeWwHddC/jpFUzpoYjP80rXAF5b78qp64Z
ykXnzgZjAxi0fR6ucVKUm96keQYZ4PyeITB4Q4rWzflxMQw44vItRc1rAY8R
Tm0MNECcrPro0CetQAzjEJ/wUluJL91AWDsWV0f4jN5iKo97H+wHjIUmwrVB
ayGnQ2SQclllcsK+IzITu3EZUtqYTAXhl5/vLwS7Dauu7vkSwgW6XV0TXnJw
7eqMhIRjToqVJlo5iq13/LXlxmJK0cbhdvgvcXKlhGmkXPvG0nasDJDudhCu
j4syps+0o7dkdv0h4UrFYMiQvwJs0pXYHsJCimgmvESB3tfpI72EkykXg92m
FVh90l3ZSTjbeVMX+L4Slcd/m23e+peqNrJlKzFemqDd2o92SDvrNqpEd1mG
jYiwaY7Mw8enA3Oqggtb/f8BFtPfAw==
                   "]]}, 
                 Annotation[#, "Charting`Private`Tag$99507#1"]& ]}}, {}}, {
             DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
              AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
              GridLines -> {None, None}, DisplayFunction -> Identity, 
              PlotRangePadding -> {{
                 Scaled[0.1], 
                 Scaled[0.1]}, {
                 Scaled[0.1], 
                 Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
              All, DisplayFunction -> Identity, AspectRatio -> 1, 
              Axes -> {False, False}, AxesLabel -> {None, None}, 
              AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
              Frame -> {{True, True}, {True, True}}, 
              FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
              Directive[
                Opacity[0.5], 
                Thickness[Tiny], 
                RGBColor[0.368417, 0.506779, 0.709798]], 
              FrameTicks -> {{None, None}, {None, None}}, 
              GridLines -> {None, None}, GridLinesStyle -> Directive[
                GrayLevel[0.5, 0.4]], ImageSize -> 
              Dynamic[{
                Automatic, 3.5 CurrentValue["FontCapHeight"]/
                 AbsoluteCurrentValue[Magnification]}], 
              Method -> {
               "DefaultBoundaryStyle" -> Automatic, 
                "DefaultGraphicsInteraction" -> {
                 "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                  "Effects" -> {
                   "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                "DefaultMeshStyle" -> AbsolutePointSize[6], 
                "ScalingFunctions" -> None, 
                "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
              PlotRange -> {{0., 0.15}, {-0.09587879741481076, 
               1.3905552809446664`}}, PlotRangeClipping -> True, 
              PlotRangePadding -> {{
                 Scaled[0.1], 
                 Scaled[0.1]}, {
                 Scaled[0.1], 
                 Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "0.15`"}], "}"}], "}"}], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"scalar\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["3", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"Hermite\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["False", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel"],
    DynamicModuleValues:>{}], "]"}],
  InterpolatingFunction[{{0., 0.15}}, {
   5, 7, 0, {51}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, CompressedData["
1:eJxTTMoPSmViYGBgBGJjBgT4VZe1p2Ryhj2ErrC3ue/fOz2vCcrvsN8h1/o6
cEcfVHySvbT+XRW2xqlQ+Rn2N899D368dDZU3Tx7H/NOx4SnC6DqF9lrt4sB
lSyG6ltqz3V9cYEt13Ko/hX2r9QMOdbIrIKas9r+ZNm++VL6a6HmrbMPARp+
RGED1NwN9i7dOc9/r9wINX+TvTEYbIbas9le+fZPoMlboPZttRduPnBqoes2
qL3b7ZnACrdD7d9h/+mSb5JAxE6oO3bZP6wSWef+cBfUPbvtLyqBDYS6a6/9
QZBpn/dC3bfPfkNRxsS3Nfuh7jxgHwB0lVDzAah7D9h7gA08CHX3QXsH07hd
njyHoO4/ZA9WduEQ1B+H7QGwwMcG
   "], {Developer`PackedArrayForm, {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 
    13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 
    31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 
    49, 50, 51}, CompressedData["
1:eJxTTMoPSmVkYGAwBuLCCW+/Nnfv2M9z+KBQwMkV+7umrRUX2qK9P/KHBFvk
nBX2uldjKr6t22Fv32k0+2j3IfsXt4rWVO87YX87jldS6c05e/++dR/fdFyy
j2k1mN40/ar9m8+Z/DILb9jfnvwjcd2y2/ZxttdW3Fh+zz6oO+ph0KUH9pdc
n+++6ffIPqy62vHoycf2O3bZNk5xfmo/4YStbvGeZ/azAlYfTDZ5Yf9YuC0l
bPVL+7nqvRpmiq/t402i/72Z+sbeJSfxdBznO/uekG2r06rf2x9e9/fA69IP
9muiN7yw1v1oP3NboHzd44/2hRniRjUzPtnbT3esfer92V54iq+k1d/P9gue
L3VfsvqLvVV0RU5U6Ff79ZkdPBe/fLU/o2zy/bztN/tpbseSDgDpap6LiRuA
9OXwA7ZrgfTD+VO9NwHpxGSFI/uAdP2M7vcgdbo/GIS3AmnTAyoLNwLpsmVV
d0H8QxdPyhwE0k2TzL+eAdKiPIffngTSLlrbeM4B6bXbD0eBzNG6sSlmC5Bm
PrpsDsh8uaC+sh1AGgDwENh4
    "]}, {Automatic}],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{{3.774370135370944*^9, 3.7743702002197256`*^9}, {
   3.7743702505035233`*^9, 3.7743702777906656`*^9}, {3.7743703385948753`*^9, 
   3.7743703762801075`*^9}, 3.7743704207546983`*^9, {3.7743704528932447`*^9, 
   3.774370472602809*^9}, 3.774370506926458*^9, {3.7743705806376767`*^9, 
   3.7743705965085917`*^9}, {3.774371500655333*^9, 3.774371533323244*^9}, {
   3.774371657138429*^9, 3.7743716764683404`*^9}, 3.7743717101946154`*^9, 
   3.774371759814841*^9, {3.7743717905694647`*^9, 3.774371821762388*^9}, 
   3.7743718847401023`*^9, {3.7744564970632772`*^9, 3.7744565250915813`*^9}, {
   3.774456561751676*^9, 3.7744565858159685`*^9}, {3.7744566975748715`*^9, 
   3.7744567449092817`*^9}, {3.774457115884381*^9, 3.7744571339922943`*^9}, {
   3.7744571691425333`*^9, 3.7744571869788485`*^9}, {3.7744572366584854`*^9, 
   3.774457253984155*^9}, 3.7744573678083224`*^9, {3.7744574049927144`*^9, 
   3.7744574633579874`*^9}, {3.774457511453393*^9, 3.7744575417221017`*^9}, 
   3.774457588075962*^9, {3.774457648627548*^9, 3.7744576682273674`*^9}, {
   3.774457739748784*^9, 3.774457783237306*^9}, 3.774457870345039*^9, {
   3.774458091304367*^9, 3.7744581099343777`*^9}, 3.7744581745845537`*^9, 
   3.774458212674711*^9, 3.7744582849944863`*^9, 3.774458379526481*^9, {
   3.7744584231466274`*^9, 3.7744584603488455`*^9}, {3.7744685467252426`*^9, 
   3.7744686253985353`*^9}, 3.774468695638485*^9, 3.774468777978194*^9, 
   3.7745269240282927`*^9, {3.7745269603075495`*^9, 3.774526986669656*^9}, 
   3.774527065164096*^9, {3.77452847258191*^9, 3.77452849664015*^9}, {
   3.7745285361988688`*^9, 3.774528554054303*^9}, 3.7745286080692644`*^9, {
   3.774633363771573*^9, 3.7746333856302247`*^9}, {3.7746334337042527`*^9, 
   3.77463345843076*^9}, 3.7746339865260305`*^9, 3.7775666770808573`*^9, 
   3.777566745014581*^9, 3.777572334596345*^9, 3.777572388036867*^9, 
   3.77757262540259*^9, 3.7775727937309527`*^9, 3.7775728306594467`*^9, 
   3.7775730335745254`*^9, 3.7775730832339983`*^9, 3.7775732803826804`*^9, 
   3.7775733236211195`*^9, 3.7775733867787223`*^9, {3.7775734184785023`*^9, 
   3.777573503966888*^9}, 3.7775736001547036`*^9, 3.777573672927069*^9, 
   3.7775737625805454`*^9, 3.77757383351505*^9, 3.7775739184923363`*^9, {
   3.777573952235876*^9, 3.7775739877787113`*^9}, 3.7775740896412888`*^9, 
   3.7775749805324283`*^9, 3.7775751258475494`*^9, {3.7775751761785593`*^9, 
   3.7775752055449934`*^9}, {3.7775758963331614`*^9, 3.777575915375946*^9}, 
   3.7775759824656706`*^9, 3.7775761146893888`*^9, 3.7775761574835095`*^9, 
   3.77757621318773*^9, 3.777578603300482*^9, {3.7775786400954556`*^9, 
   3.777578651061685*^9}, 3.7775790025006075`*^9, 3.777579182670437*^9, 
   3.7776363470485277`*^9, 3.7776363968955326`*^9, 3.7776366048624616`*^9, 
   3.77763672905415*^9, 3.777637800937849*^9, 3.7776378310018096`*^9, 
   3.7776378918116693`*^9, {3.777637934911852*^9, 3.7776379612484083`*^9}, 
   3.7776380457728405`*^9, 3.777639151792759*^9, {3.7814372837485814`*^9, 
   3.7814373350011797`*^9}, {3.7814373687868347`*^9, 3.7814374036851234`*^9}, 
   3.7814374525838337`*^9, 3.7814379658193617`*^9, {3.781438035007213*^9, 
   3.7814380554309015`*^9}, {3.7814381110414753`*^9, 3.781438117349634*^9}, 
   3.7814382722078032`*^9, 3.781438445513135*^9, 3.7814385473470864`*^9, 
   3.781438626511097*^9, 3.7814386751346207`*^9, 3.781438706769661*^9, 
   3.7814387434797134`*^9, 3.7814389701465807`*^9, 3.7814391099163065`*^9, 
   3.7814391403276005`*^9, 3.7814391945663595`*^9, 3.781439228177843*^9, 
   3.7814392590363016`*^9, 3.7814393376868067`*^9, {3.7814393678578215`*^9, 
   3.7814394088336678`*^9}, 3.781439719638568*^9, 3.7814399304510183`*^9, {
   3.7814412583060045`*^9, 3.7814412809345427`*^9}, {3.781522907114753*^9, 
   3.7815229368442554`*^9}, {3.7815229677496405`*^9, 3.7815229914213142`*^9}, 
   3.781524270184866*^9, {3.781524819106003*^9, 3.781524833941332*^9}, {
   3.781525433884287*^9, 3.781525482407532*^9}, 3.781525516096447*^9, 
   3.78152556721978*^9, 3.782214505800999*^9, 3.8167092011625433`*^9, {
   3.816970219102013*^9, 3.8169702406967673`*^9}, 3.8169704414715977`*^9, 
   3.816970503314483*^9, {3.8169705529385395`*^9, 3.8169705725795717`*^9}, 
   3.816970610828066*^9, 3.816970671364937*^9},
 CellLabel->
  "Out[263]=",ExpressionUUID->"07114913-061a-406a-b686-edacaafa4912"],

Cell[BoxData["0.00601314409755304`"], "Output",
 CellChangeTimes->{{3.774370135370944*^9, 3.7743702002197256`*^9}, {
   3.7743702505035233`*^9, 3.7743702777906656`*^9}, {3.7743703385948753`*^9, 
   3.7743703762801075`*^9}, 3.7743704207546983`*^9, {3.7743704528932447`*^9, 
   3.774370472602809*^9}, 3.774370506926458*^9, {3.7743705806376767`*^9, 
   3.7743705965085917`*^9}, {3.774371500655333*^9, 3.774371533323244*^9}, {
   3.774371657138429*^9, 3.7743716764683404`*^9}, 3.7743717101946154`*^9, 
   3.774371759814841*^9, {3.7743717905694647`*^9, 3.774371821762388*^9}, 
   3.7743718847401023`*^9, {3.7744564970632772`*^9, 3.7744565250915813`*^9}, {
   3.774456561751676*^9, 3.7744565858159685`*^9}, {3.7744566975748715`*^9, 
   3.7744567449092817`*^9}, {3.774457115884381*^9, 3.7744571339922943`*^9}, {
   3.7744571691425333`*^9, 3.7744571869788485`*^9}, {3.7744572366584854`*^9, 
   3.774457253984155*^9}, 3.7744573678083224`*^9, {3.7744574049927144`*^9, 
   3.7744574633579874`*^9}, {3.774457511453393*^9, 3.7744575417221017`*^9}, 
   3.774457588075962*^9, {3.774457648627548*^9, 3.7744576682273674`*^9}, {
   3.774457739748784*^9, 3.774457783237306*^9}, 3.774457870345039*^9, {
   3.774458091304367*^9, 3.7744581099343777`*^9}, 3.7744581745845537`*^9, 
   3.774458212674711*^9, 3.7744582849944863`*^9, 3.774458379526481*^9, {
   3.7744584231466274`*^9, 3.7744584603488455`*^9}, {3.7744685467252426`*^9, 
   3.7744686253985353`*^9}, 3.774468695638485*^9, 3.774468777978194*^9, 
   3.7745269240282927`*^9, {3.7745269603075495`*^9, 3.774526986669656*^9}, 
   3.774527065164096*^9, {3.77452847258191*^9, 3.77452849664015*^9}, {
   3.7745285361988688`*^9, 3.774528554054303*^9}, 3.7745286080692644`*^9, {
   3.774633363771573*^9, 3.7746333856302247`*^9}, {3.7746334337042527`*^9, 
   3.77463345843076*^9}, 3.7746339865260305`*^9, 3.7775666770808573`*^9, 
   3.777566745014581*^9, 3.777572334596345*^9, 3.777572388036867*^9, 
   3.77757262540259*^9, 3.7775727937309527`*^9, 3.7775728306594467`*^9, 
   3.7775730335745254`*^9, 3.7775730832339983`*^9, 3.7775732803826804`*^9, 
   3.7775733236211195`*^9, 3.7775733867787223`*^9, {3.7775734184785023`*^9, 
   3.777573503966888*^9}, 3.7775736001547036`*^9, 3.777573672927069*^9, 
   3.7775737625805454`*^9, 3.77757383351505*^9, 3.7775739184923363`*^9, {
   3.777573952235876*^9, 3.7775739877787113`*^9}, 3.7775740896412888`*^9, 
   3.7775749805324283`*^9, 3.7775751258475494`*^9, {3.7775751761785593`*^9, 
   3.7775752055449934`*^9}, {3.7775758963331614`*^9, 3.777575915375946*^9}, 
   3.7775759824656706`*^9, 3.7775761146893888`*^9, 3.7775761574835095`*^9, 
   3.77757621318773*^9, 3.777578603300482*^9, {3.7775786400954556`*^9, 
   3.777578651061685*^9}, 3.7775790025006075`*^9, 3.777579182670437*^9, 
   3.7776363470485277`*^9, 3.7776363968955326`*^9, 3.7776366048624616`*^9, 
   3.77763672905415*^9, 3.777637800937849*^9, 3.7776378310018096`*^9, 
   3.7776378918116693`*^9, {3.777637934911852*^9, 3.7776379612484083`*^9}, 
   3.7776380457728405`*^9, 3.777639151792759*^9, {3.7814372837485814`*^9, 
   3.7814373350011797`*^9}, {3.7814373687868347`*^9, 3.7814374036851234`*^9}, 
   3.7814374525838337`*^9, 3.7814379658193617`*^9, {3.781438035007213*^9, 
   3.7814380554309015`*^9}, {3.7814381110414753`*^9, 3.781438117349634*^9}, 
   3.7814382722078032`*^9, 3.781438445513135*^9, 3.7814385473470864`*^9, 
   3.781438626511097*^9, 3.7814386751346207`*^9, 3.781438706769661*^9, 
   3.7814387434797134`*^9, 3.7814389701465807`*^9, 3.7814391099163065`*^9, 
   3.7814391403276005`*^9, 3.7814391945663595`*^9, 3.781439228177843*^9, 
   3.7814392590363016`*^9, 3.7814393376868067`*^9, {3.7814393678578215`*^9, 
   3.7814394088336678`*^9}, 3.781439719638568*^9, 3.7814399304510183`*^9, {
   3.7814412583060045`*^9, 3.7814412809345427`*^9}, {3.781522907114753*^9, 
   3.7815229368442554`*^9}, {3.7815229677496405`*^9, 3.7815229914213142`*^9}, 
   3.781524270184866*^9, {3.781524819106003*^9, 3.781524833941332*^9}, {
   3.781525433884287*^9, 3.781525482407532*^9}, 3.781525516096447*^9, 
   3.78152556721978*^9, 3.782214505800999*^9, 3.8167092011625433`*^9, {
   3.816970219102013*^9, 3.8169702406967673`*^9}, 3.8169704414715977`*^9, 
   3.816970503314483*^9, {3.8169705529385395`*^9, 3.8169705725795717`*^9}, 
   3.816970610828066*^9, 3.8169706713858438`*^9},
 CellLabel->
  "Out[264]=",ExpressionUUID->"cc00b8bd-d7ab-4f26-8191-d682cb006afe"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[1.5], 
      LineBox[CompressedData["
1:eJxTTMoPSmViYGAwBmIQDQPVFVc4Dnsf3v+rLmtPyeQM+8NhWZrrHWD8Cnsv
B2uDJ6aH99vc9++dntdkz6gh2JqjDZPvsG8/81YkQPHw/h1yra8Dd/TZS2jO
fr9AHKZ+kv0O9u/TbPgO75fWv6vC1jjVnnOFm8FPFpj+Gfabp69UWfL70P6b
574HP1462z6DYXqnxKdDUPPm2UetvJCs9OLQfh/zTseEpwvsS9wuy2y5ewhq
/iL7J9+n1cy6dGi/drsY0IjF9gahuQlLjx2C2rfUfooS46pNOw/t57q+uMCW
a7n9N7sT2bNWH4Lav8J+560t0zznHNr/Ss2QY43MKntlr8DFvd0w96y2z9+y
r1W48tD+k2X75kvpr7W3+XK3OCEF5r519gybjjcf8jm0PwTo+CMKG+yD87Pm
6hnC3LvB3pOrfsNH/kP7Xbpznv9eudH+6FONgO9PD0Ldv8m+Z/kGncVrDu43
BoPN9v8+yvqk+B+E+mez/ZKC8O2S0fv3K9/+CXTxFvtXy4y6T23eCfXfVvsz
rJlzdCW37BduPnBqoes2+4qFP/RXy6yF+ne7/U277mMq5ov2M4EN3G7f4pF3
fU5ZH9T/O+z3C6cven6tyP7TJd8kgYid9rtrwpYFr++2h4THLjj/YZXIOveH
CD4kfHbD+ReVwA6E8yHhtRfOPwhy3WcEHxJ+++D8DUUZE9/W7IfzIeF5AM4P
AIaWUDOCDwlfBN8D7MCDcD4kvBF8B9O4XZ48h+B8SPgj+GDjLiD4kPg4DOcD
AMS3oBE=
       "]]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}], LineBox[CompressedData["
1:eJw1kX0s1HEcx41CqvXgqVBRZpyVcVFKfbRpebqVWFOZJJquC0tTGTVuHi5L
T0q6pDxzueHEdXX3dR5qWHLGTtnRhW4n5/Ecjj/6uvv23b777bXv7/f+vj+v
n0N0wtlYQwMDAyrea8//K+tuGWfE6RvS3qN/vvUsDgLMGhAnX0L4DsgLKUbW
Rf3IZ+T0w4L4DDjQfVvhWCEl5zngnyTtTuP+RPzdmX9D+Hmgqu+U7W+Wkfef
gqKodnYx8heydZM5Gqc/B+caV9N1v+Xk+5dw0YvGZ8eOoh89i6Gj5WwQMcIm
k5VjJO8NlBzN41AZf1DwIdaJqPG34MFQm1ybUpD8EjDKsQilJCiRa7YVjiiF
F/yI9RbTE+S+cpCWTtKzb0wiM2lp4jGzSrA4KKZzlSpyfxWECa4v7omZRhNO
7qbv7Wogq61AyYqfIX04wOi7xAymzKLOZFGxjVstbHlVabZhfJb040JtUOaQ
V/EcCsPl2+3rIJnqG9kTPk/61oHDwoxWtk2N/HIZipXqehj2GL4Q3qUm/RuA
qfWzdMxYQFTd4sGRpFS2u7eGzMODwftLLMa0Bu0bWsaNG+G4yknEL1sk832A
qUQebTJ8CZkzW7renWwCdUGaumfjMpm3GVzoYyGbhcvIUBfYDME56V+dGVoy
Px9SHph4+e9YQXN9tOit4R+hvanb+wtaIT4EEFj1SE2JXEXyFAvuKbkAvhsw
gwbbV4mfT1BtfY79GrNkr64gGF2J6IjHrPclhJWd/SwaZvFau3kh2OUOWAZi
1vsTQeopGicOc93NuCeqVAS8mF6Xx5j1Plsgy8RHgDCfwba2M1tAXt9YqMGs
99sCJQ7eVbs6VpG/rqAYNPTKtAV8rvcthvPm5p0SzL6ekYKATa3gWaGh52PW
+2+FywPCwCjMurjeVjCW2Vw9jFn/P9og2speYov5H0LXuoE=
       "]]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}], LineBox[CompressedData["
1:eJw1kQsslWEcxrFlJxErcySXwhq6mHNc1pYelpKNyrWmzVBtssTMJJcmRpmD
YkIst9wK47gd13NcanPNIem4C3PLSY5z3KvP8fZu3749+973eX//33fa29/p
gZyMjAyTevbf/9e4kNZjP83mbj/zbQpK8UFS3xeWjegtySFY5ln401Xe4NLk
zYS0x1FwuNdvuPu5EgffX8Jr8Lxft3wLONoxy46cRNQoKQ506n0i+5MRHJiY
e82qGyeNx/Xln6fC1MORU1bWT86no1DOfZjZNAhB34bzTEEmLt914Bt0fyN9
75Dn7HxROCyAvUWctedcDloZnInimTHSnwf5aP2avJ+TOPtCjarIR6F/Av1Q
6DS5rwC6brFpnrs/oDCcH2CpUATvxMOzBeGz5P5ihE0UxT3cmcPSGRNaqeYH
qOsrH5sPmSc8H6F5jjFjKl5AZ3BLtoZxGbg2Wmp8/yXCVw63Io5r1uIyXCj4
jlMVqB22bEzxXiG8FVBa1/g7OiKETfyj+Z2SSkQxBqrMDFcJPxs57NnelNlV
MKWrClcM+n/FZP8m81QhK72pnea+Br3RLYq4GvElRrJ0VRGZrwZtYr5CUa8I
x6N5XblXa2G1YOtbHrtO5q1DQk3zUR2IISctrAMrR12yIBGT+TkYYnf8kZRJ
sDbg4K1ypx4C5dRxxv0N4qMB3+2tL0Sc2MR0qGq57XQD7DR9he97N4mfRoxb
aocERW6BrysFxJP5cFamyTbx1YxkVfOkjKlttO7TiZrRJYisS2XtEH8taHea
ah5j7qIi0Of1SjgXHrI+Rlz+LvHJw1OvIVoEcw+3KFvHonn4euTGQhWVD/zy
kBo2IBmh8nUpYCsWO6x62FQ+8N0Ke79SehKVrcw8GuwU22Ag86rekcoH/tvg
Ynw7Q4vK0rr+NmyZV1eLGXvkf7TDNaBeR0Dlf3rUnn8=
       "]]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      LineBox[CompressedData["
1:eJw1kXtIk1EYxjezKJs2dAnVWKXhHdS8TEV9yxQtvKRd6I+sUDS7zKLygpRk
S7bQrNlNlLy0ZtZSbFM3Z/PMuX+0mpuFFypslhial+aGK406376vA4fDj3Pe
533e5+zMupCR40Cj0ULwJs7/S+0jc9elD6LfpWdfX7mXB1kcV+9ybwPFxfDw
gK2Vt/s9ip5Iu/0o/wYwEj9IlmNHqHshDNPXyp1TxpGSUz6brqwCJS9Uzc/8
RL2vhoCCIF4JbwJtC/y8a13ZA+iR5nLKY0xUfQ3Q3QIqkrSTaFy/fOirpA4m
tdl338V/o/TqQZz6OLJBN4WSubf2nppqBJ+5HAiOm6b0n0BTbVd1pPo78he4
YwkxzISJRJKwGaqfBNij00y5dBY5jYovxjg9A2PtyaLq7XNU/xbY7FOT3C2a
RzNewetfsl+AMfzyXzZ9kfIjhTNHErSFykU0UNjbsDWwFWiCqLT+/J+UvzZI
vR7R+cbTjA5j87od7eAYLvSKGzVTftuho9hglAqXUHzF+emV569AkT3lG8y1
UP5l0DzmW8kyWVCIfcnBf0yxwiqzUvPIoe1p9FGT3oo8P/7CjjsgTX2Nb8VM
ztcJNoU+aOOQFbnxNYNNCV3gx0l564iZnFcBVXUu990xO9gFFXCcNTIRipmc
XwmCun0xnpjNwylZzGPdMD5Q2+KKmcxDBeIfAaw1mE0lrLZEkwqEMq7bEu5P
5tMDX/54LSxgNnrYDcJ8wuqqBTOZlxryNwgK6Li+j3C3pIbKWHMjoUfm1wtR
9ad1y/h9+6U80dxVBHG5FRlEPZmnBm4mm6psmA/itFz5GhgqCtIT9WS+GrgT
Ud+8CXOS3WAfeMh8GxiYybz7IN3A7mVi3hN2QrWfoQVVph+D8EPmrwVu6RYX
or9dzqAF5jnnVCJf8j/6wd9m8V7B/A9E9LP0
       "]]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      LineBox[CompressedData["
1:eJw1kQ0slHEcx02blV2rUUmZvK0aM+Ulm7p9s0hNCkl52RWq0ayiMnPSMEUX
k/eikHB1XOftXOftuTuaK1OuKbqpdBPlJO+qaf3vnqf/9t+zz/7P8/1/ft/H
OvJS4DlDAwMDF7J1z/8rLndqIZ0n6fqdcqH9an40WAqZib+Sz3AibhfVm5k0
O3Tt+3Qsu/hiGkKWNxuFlPFBn2fCcTA8cVEogcQyYzJAkgNkOZf28OSg38/D
xIf4Om5nL7Y6jdgZpRZCzVlrbqPtZ74vwbEc4Yw2U4Xh/qXjmupShGfsKk4r
HmTyHkI7F7POonIIR9yzPM+MVUCdvxwhrFEz+Y/AYb/jD9V+hMOtTSSiCoG8
0NFA1WfmvmqovMfbho9+gfH7qsts41oEc7mePUoNcz8fEik7teDAGL5v3726
zuIpcnvZjlfavzI+Atz3F8iiXCegTOgs3+JUD43pzbPBgm+MnxAPdmTv3GM9
iSAi320lwmnXsL/aQi3jK4JXbMQrzpof8OLFjv950oA7QWLBee40498IhXCF
mrz2Ey761YS6MNHEXscZZp4m3BMHbEvRzMBW/YsYNyMu2sw5uWSWma8FKPa8
PuY7B9N06mWltximBX7mHitzzLytqBiv9nksmIehPrAVHmGJsaEnFpj5JXgW
k8kamF/ArMovcv2p5+izdV16zV5k+pCi6OCLSIrwaNIGoc+oFFzWQISIMN1P
G96epNj1hAds9IIYLS/0bSRM99WBiCir7k7CMp3dXAdulPCmdXl0f51wXDYw
bSEsio++O5XcBTfKrrKBMN0nhYSapBHduT9pyySdgnxAaSEjTPdLIS3PfaGP
8CG9oAwbWYopJWG6bxm87MWsfsL73TjSwyw56lsVoTofun857Icaw5sJ6+Pe
yLGqp6ZM50//DwUsA3MSJIT/AfOonbA=
       "]]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwBmIQDQOBe3b9qr96Yv+vuqw9JZMz7Gt/ub9+dOYclF9h
vytjk2pOyaX9Nvf9e6fnNdnftva6k915FSrfYf+05ur/mYtu7N8h1/o6cEef
vaDnhw6hnbeh6ifZhxttrp108t5+af27KmyNU+1ZOD+UHX/5AKp/hr3AOUZR
9+xH+2+e+x78eOls+74Pr84nv3wMNW+evaOPwQ6LlKf7fcw7HROeLrCPe6KY
9fX2M6j5i+wXbK7SWxbwYr92uxjQiMX2LyQZBZceegm1b6l9WoHmnWqj1/u5
ri8usOVabi/10zj07/w3UPtX2D+5erFhKde7/a/UDDnWyKyyF3t/5NqCwvdQ
96y2n9r4VvZI5of9J8v2zZfSX2t/Qal81kmxj1D3rbN3kLe9zrTn4/4QoOOP
KGywn1LzXCJV7RPUvRvslc6raccD+S7dOc9/r9xoP/eI/MIwIB/i/k32wl+e
PQkC8o3BYLP9pmss2SB5iH822z9ZeaLKD8hXvv0T6OIt9n0MdivDgXyI/7ba
/5aUFy0A8oWbD5xa6LrN3m3+48lRQD7Ev9vta+UNNgcC+UxgA7fb14gEcYDs
g/h/h72X18bV/kD+p0u+SQIRO+3rmJ3UQOZDwmOXPV9HQ0U6kP+wSmSd+8Nd
9k7Lj+8GmQ8Jn932yQvuhQQA+ReVwA60d7wu2RkM5EPCa6/97jRL3mQg/yDI
dZ/32nfrdrBnAfmQ8Ntnb/1pRmgckL+hKGPi25r99tFTvLkjgHxIeB6wv6x1
ZzMoPAKAoSXUfMB+QxnP00h4+B6wV+J6XxAD5HuAHXjQfvKX5tVh8PA+aF/A
Zb0sFsh3MI3b5clzyP7ZoQ1BofDwP2TfUDFzIyg8wMZdOGT/cUeRbAQ8Pg7b
v9T68yUFyAcA5TinSg==
       "]]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}], LineBox[CompressedData["
1:eJw1kX0s1HEcx48/mkljHpKnhszD7JKnWaI3E3GTUOlptbquTc0zV4nZ5Dzt
oqVuUlvoXE9kijgn7iFjWg/YmeSp48o6uXFMYarv3e/Xd/vtt9d+v9/78/q8
fy7s9MSLxgwGw59c+vv/E31pgmnG65KuF1x+k3MnGf6eubaazmaar0HJ0d76
nFsqDZk+XFGddgO6uv2RtUwhqOdlCMjKDxF6tUO8s3g+QVwJ7R6+m+K4HNT7
VdjkRuTdreyHg8+k25ZCAbz4QYu94g/09/eAqemNNc0Qxj7+OjIreoB975dm
i5aVdN5D3K/+FMNdHUVsUHn4uW91MJFuSFJWvtD5j1BRkto2sjAJ79LtJEII
T+7vYGXmV3qeCBGqmjrBvAqmo8KMUNMnKPfOzI/izNLzn2KTo4keGVdD4+5r
0uT4HI9likaPxO+0TyNuFhW3O/XPYeBKT629zwuwUzddq4J/0H7N6Ps75J7Q
pMFRIt/r3AKLwvEoG8eftG8L/rDizQvLF3CAnzK38ewlBo9Fhm9d0dL+r6Cu
8fbIYC7C33BaESbwY7KmFul9WpEnSFx14S9h1/gaMW5DwimeaNFHR+/3Gtps
8QWmQAerItm7+sh27F3Ln7ElTO3bgYzcASNzwsaGwA6kp80n6ZnaX4zQBta6
GWHd8CG2xYlOZJ4Zz7EmTPUhgdGMXb8bYdV16+aDKgkCjc6b7iBM9dOFpPWr
wm2Eh1wNggjwbR21IEz11Y1m2fBpZ8Jyvd1yNwpKXZI8CFP99WB3rF+DA+GW
rOTbC/lSxGnVJ20IU33K0MfjGut94klblkUyCAdF/vr9qH5lsOGUSe0IRxsE
5SiJc1q3Ikz1LQebo1yxJxwWeFYSY6bAmCOr3pIw1b8C2cN+DL2vIW5QAbWl
WYp+PvU/3mKCJ4hwJfwPpmCXcw==
       "]]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{8, 2}], 
      LineBox[{{0.00601314409755304, -2.1386661140308822`}, {
       0.00601314409755304, 2.6499435463628314`}}]}}, {
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[1.5]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{8, 2}]}}, {
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[1.5]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{
       8, 2}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}}, {
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[1.5]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.007333333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{
       8, 2}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  AxesStyle->{{
     AbsoluteThickness[0.8]}, {
     AbsoluteThickness[0.8]}},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  LabelStyle->{FontFamily -> "Cmr10", FontSize -> 12},
  Method->{
   "OptimizePlotMarkers" -> True, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.15}, {-2.676712143288603, 2.7037481492886033`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.774370135370944*^9, 3.7743702002197256`*^9}, {
   3.7743702505035233`*^9, 3.7743702777906656`*^9}, {3.7743703385948753`*^9, 
   3.7743703762801075`*^9}, 3.7743704207546983`*^9, {3.7743704528932447`*^9, 
   3.774370472602809*^9}, 3.774370506926458*^9, {3.7743705806376767`*^9, 
   3.7743705965085917`*^9}, {3.774371500655333*^9, 3.774371533323244*^9}, {
   3.774371657138429*^9, 3.7743716764683404`*^9}, 3.7743717101946154`*^9, 
   3.774371759814841*^9, {3.7743717905694647`*^9, 3.774371821762388*^9}, 
   3.7743718847401023`*^9, {3.7744564970632772`*^9, 3.7744565250915813`*^9}, {
   3.774456561751676*^9, 3.7744565858159685`*^9}, {3.7744566975748715`*^9, 
   3.7744567449092817`*^9}, {3.774457115884381*^9, 3.7744571339922943`*^9}, {
   3.7744571691425333`*^9, 3.7744571869788485`*^9}, {3.7744572366584854`*^9, 
   3.774457253984155*^9}, 3.7744573678083224`*^9, {3.7744574049927144`*^9, 
   3.7744574633579874`*^9}, {3.774457511453393*^9, 3.7744575417221017`*^9}, 
   3.774457588075962*^9, {3.774457648627548*^9, 3.7744576682273674`*^9}, {
   3.774457739748784*^9, 3.774457783237306*^9}, 3.774457870345039*^9, {
   3.774458091304367*^9, 3.7744581099343777`*^9}, 3.7744581745845537`*^9, 
   3.774458212674711*^9, 3.7744582849944863`*^9, 3.774458379526481*^9, {
   3.7744584231466274`*^9, 3.7744584603488455`*^9}, {3.7744685467252426`*^9, 
   3.7744686253985353`*^9}, 3.774468695638485*^9, 3.774468777978194*^9, 
   3.7745269240282927`*^9, {3.7745269603075495`*^9, 3.774526986669656*^9}, 
   3.774527065164096*^9, {3.77452847258191*^9, 3.77452849664015*^9}, {
   3.7745285361988688`*^9, 3.774528554054303*^9}, 3.7745286080692644`*^9, {
   3.774633363771573*^9, 3.7746333856302247`*^9}, {3.7746334337042527`*^9, 
   3.77463345843076*^9}, 3.7746339865260305`*^9, 3.7775666770808573`*^9, 
   3.777566745014581*^9, 3.777572334596345*^9, 3.777572388036867*^9, 
   3.77757262540259*^9, 3.7775727937309527`*^9, 3.7775728306594467`*^9, 
   3.7775730335745254`*^9, 3.7775730832339983`*^9, 3.7775732803826804`*^9, 
   3.7775733236211195`*^9, 3.7775733867787223`*^9, {3.7775734184785023`*^9, 
   3.777573503966888*^9}, 3.7775736001547036`*^9, 3.777573672927069*^9, 
   3.7775737625805454`*^9, 3.77757383351505*^9, 3.7775739184923363`*^9, {
   3.777573952235876*^9, 3.7775739877787113`*^9}, 3.7775740896412888`*^9, 
   3.7775749805324283`*^9, 3.7775751258475494`*^9, {3.7775751761785593`*^9, 
   3.7775752055449934`*^9}, {3.7775758963331614`*^9, 3.777575915375946*^9}, 
   3.7775759824656706`*^9, 3.7775761146893888`*^9, 3.7775761574835095`*^9, 
   3.77757621318773*^9, 3.777578603300482*^9, {3.7775786400954556`*^9, 
   3.777578651061685*^9}, 3.7775790025006075`*^9, 3.777579182670437*^9, 
   3.7776363470485277`*^9, 3.7776363968955326`*^9, 3.7776366048624616`*^9, 
   3.77763672905415*^9, 3.777637800937849*^9, 3.7776378310018096`*^9, 
   3.7776378918116693`*^9, {3.777637934911852*^9, 3.7776379612484083`*^9}, 
   3.7776380457728405`*^9, 3.777639151792759*^9, {3.7814372837485814`*^9, 
   3.7814373350011797`*^9}, {3.7814373687868347`*^9, 3.7814374036851234`*^9}, 
   3.7814374525838337`*^9, 3.7814379658193617`*^9, {3.781438035007213*^9, 
   3.7814380554309015`*^9}, {3.7814381110414753`*^9, 3.781438117349634*^9}, 
   3.7814382722078032`*^9, 3.781438445513135*^9, 3.7814385473470864`*^9, 
   3.781438626511097*^9, 3.7814386751346207`*^9, 3.781438706769661*^9, 
   3.7814387434797134`*^9, 3.7814389701465807`*^9, 3.7814391099163065`*^9, 
   3.7814391403276005`*^9, 3.7814391945663595`*^9, 3.781439228177843*^9, 
   3.7814392590363016`*^9, 3.7814393376868067`*^9, {3.7814393678578215`*^9, 
   3.7814394088336678`*^9}, 3.781439719638568*^9, 3.7814399304510183`*^9, {
   3.7814412583060045`*^9, 3.7814412809345427`*^9}, {3.781522907114753*^9, 
   3.7815229368442554`*^9}, {3.7815229677496405`*^9, 3.7815229914213142`*^9}, 
   3.781524270184866*^9, {3.781524819106003*^9, 3.781524833941332*^9}, {
   3.781525433884287*^9, 3.781525482407532*^9}, 3.781525516096447*^9, 
   3.78152556721978*^9, 3.782214505800999*^9, 3.8167092011625433`*^9, {
   3.816970219102013*^9, 3.8169702406967673`*^9}, 3.8169704414715977`*^9, 
   3.816970503314483*^9, {3.8169705529385395`*^9, 3.8169705725795717`*^9}, 
   3.816970610828066*^9, 3.816970671572628*^9},
 CellLabel->
  "Out[268]=",ExpressionUUID->"f3608ea9-185e-4bb9-a093-422af2cfaa56"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<c:/dropbox/mystuff/sparsity/revision/Lottery.pdf\>\"", ",", "p"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7815230107007875`*^9, 3.7815230362394676`*^9}, {
  3.781523089845154*^9, 3.7815231098476667`*^9}, {3.7815248610369124`*^9, 
  3.7815248620422134`*^9}, {3.781525596859517*^9, 3.781525597663333*^9}},
 CellLabel->
  "In[637]:=",ExpressionUUID->"009a8c7f-c845-4cbe-aeee-b0876a556136"],

Cell[BoxData["\<\"c:/dropbox/mystuff/sparsity/revision/Lottery.pdf\"\>"], \
"Output",
 CellChangeTimes->{3.7815231116188993`*^9, 3.781524285049095*^9, 
  3.7815248639730253`*^9, 3.781525598929971*^9},
 CellLabel->
  "Out[637]=",ExpressionUUID->"babbd020-e8e4-4ca8-820a-e8b4a0fadd9a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
    "\"\<c:/dropbox/mystuff/sparsity/revision/lassota3.txt\>\"", ",", 
     "\"\<Table\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gdata", "=", 
   RowBox[{"GroupBy", "[", 
    RowBox[{"data", ",", "First"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tab", "=", 
  RowBox[{"{", 
   RowBox[{"0", ",", 
    RowBox[{"-", "2.33"}], ",", "2.33", ",", 
    RowBox[{"-", "1.96"}], ",", "1.96", ",", 
    RowBox[{"-", "1.645"}], ",", "1.645"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"i0", "=", "1"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pdata", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"gt", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"gdata", "[", 
         RowBox[{"[", "i0", "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"gt", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], "==", "j"}], ",", 
        RowBox[{
         RowBox[{"i0", "=", 
          RowBox[{"i0", "+", "1"}]}], ";", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Prepend", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Max", "[", 
                RowBox[{
                 RowBox[{"gt", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "+", 
                 RowBox[{
                  RowBox[{"tab", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], 
                  RowBox[{"gt", "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Length", "[", "tab", "]"}]}], "}"}]}], "]"}], ",", 
             RowBox[{
              RowBox[{"gt", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", "0.5"}]}], "]"}], 
           ",", 
           RowBox[{"Prepend", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Max", "[", 
                RowBox[{
                 RowBox[{"gt", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "+", 
                 RowBox[{
                  RowBox[{"tab", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], 
                  RowBox[{"gt", "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Length", "[", "tab", "]"}]}], "}"}]}], "]"}], ",", 
             RowBox[{
              RowBox[{"gt", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}], "+", "0.5"}]}], 
            "]"}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"Prepend", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{"\"\<aa\>\"", ",", 
             RowBox[{"{", "7", "}"}]}], "]"}], ",", "j"}], "]"}], "}"}]}], 
       "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "0", ",", "123"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pdata", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"pdata", ",", "1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"pdata", "[", 
         RowBox[{"[", 
          RowBox[{"j", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"pdata", "[", 
         RowBox[{"[", 
          RowBox[{"j", ",", "i"}], "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "2", ",", 
        RowBox[{
         RowBox[{"Dimensions", "[", "pdata", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", 
        RowBox[{"Length", "[", "pdata", "]"}]}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"style", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Black"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{".6", ",", "2"}], "}"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", ".8", "]"}], ",", "Black"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "0.8", "]"}], ",", "Black"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"2", ",", "2", ",", ".6", ",", "2"}], "}"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", ".8", "]"}], ",", "Black"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"8", ",", "2"}], "}"}], "]"}], ",", 
       RowBox[{"AbsoluteThickness", "[", ".8", "]"}], ",", "Black"}], "}"}]}],
     "\[IndentingNewLine]", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stylex", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"style", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "}"}], ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"style", "[", 
            RowBox[{"[", 
             RowBox[{"j", "+", "1"}], "]"}], "]"}], ",", 
           RowBox[{"style", "[", 
            RowBox[{"[", 
             RowBox[{"j", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", "4"}], "}"}]}], "]"}], ",", "1"}], 
      "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p1", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"xx", ",", 
     RowBox[{"Joined", "->", "True"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "stylex"}], ",", 
     RowBox[{"LabelStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontFamily", "\[Rule]", "\"\<Cmr10\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "12"}]}], "}"}]}], ",", 
     RowBox[{"AxesStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"AbsoluteThickness", "[", ".8", "]"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"AbsoluteThickness", "[", ".8", "]"}], "}"}]}], "}"}]}]}], 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"i0", "=", "1"}], "\[IndentingNewLine]", 
 RowBox[{"xdata", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"gt", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"gdata", "[", 
        RowBox[{"[", "i0", "]"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"gt", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], "==", "j"}], ",", 
       RowBox[{
        RowBox[{"i0", "=", 
         RowBox[{"i0", "+", "1"}]}], ";", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Min", "[", 
            RowBox[{"gt", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", 
           RowBox[{"Max", "[", 
            RowBox[{"gt", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"-", "i0"}], "+", "1"}], ",", 
          RowBox[{"i0", "-", "1"}]}], "]"}]}], ",", "0"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "0", ",", "123"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pdata", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"i0", "=", 
      RowBox[{"xdata", "[", 
       RowBox[{"[", 
        RowBox[{"j", "+", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", "i0", "]"}], ">", "0"}], ",", 
       RowBox[{"gt", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{"gdata", "[", 
          RowBox[{"[", 
           RowBox[{"Abs", "[", "i0", "]"}], "]"}], "]"}], "]"}]}]}], "]"}], 
     ";", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i0", "<", "0"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"xdata", "[", 
           RowBox[{"[", 
            RowBox[{"j", "+", "2"}], "]"}], "]"}], ">", "0"}], ",", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"pdata", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Prepend", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{"\"\<aa\>\"", ",", 
                 RowBox[{"{", "7", "}"}]}], "]"}], ",", "j"}], "]"}], ",", 
             RowBox[{"Prepend", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Min", "[", 
                  RowBox[{
                   RowBox[{"gt", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                   RowBox[{
                    RowBox[{"tab", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"gt", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", 
                   RowBox[{"Length", "[", "tab", "]"}]}], "}"}]}], "]"}], ",", 
               RowBox[{
                RowBox[{"gt", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", "1"}], "]"}], "]"}], "+", "0.5"}]}], 
              "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"xdata", "[", 
             RowBox[{"[", "j", "]"}], "]"}], ">", "0"}], ",", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"pdata", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Prepend", "[", 
                RowBox[{
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"Min", "[", 
                    RowBox[{
                    RowBox[{"gt", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "+", 
                    RowBox[{
                    RowBox[{"tab", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                    RowBox[{"gt", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}]}], "]"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"Length", "[", "tab", "]"}]}], "}"}]}], "]"}], 
                 ",", 
                 RowBox[{
                  RowBox[{"gt", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", "0.5"}]}], 
                "]"}], ",", 
               RowBox[{"Prepend", "[", 
                RowBox[{
                 RowBox[{"Table", "[", 
                  RowBox[{"\"\<aa\>\"", ",", 
                   RowBox[{"{", "7", "}"}]}], "]"}], ",", "j"}], "]"}]}], 
              "}"}]}], "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"pdata", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Prepend", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Min", "[", 
                RowBox[{
                 RowBox[{"gt", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "+", 
                 RowBox[{
                  RowBox[{"tab", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], 
                  RowBox[{"gt", "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Length", "[", "tab", "]"}]}], "}"}]}], "]"}], ",", 
             RowBox[{
              RowBox[{"gt", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", "0.5"}]}], "]"}], 
           ",", 
           RowBox[{"Prepend", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Min", "[", 
                RowBox[{
                 RowBox[{"gt", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "+", 
                 RowBox[{
                  RowBox[{"tab", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], 
                  RowBox[{"gt", "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Length", "[", "tab", "]"}]}], "}"}]}], "]"}], ",", 
             RowBox[{
              RowBox[{"gt", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}], "+", "0.5"}]}], 
            "]"}]}], "}"}]}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "2", ",", "122"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pdata", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"pdata", ",", "1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xx", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"pdata", "[", 
        RowBox[{"[", 
         RowBox[{"j", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"pdata", "[", 
        RowBox[{"[", 
         RowBox[{"j", ",", "i"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "2", ",", 
       RowBox[{
        RowBox[{"Dimensions", "[", "pdata", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", 
       RowBox[{"Length", "[", "pdata", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"p2", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{"xx", ",", 
    RowBox[{"Joined", "->", "True"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", "stylex"}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "\[Rule]", "\"\<Cmr10\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "12"}]}], "}"}]}], ",", 
    RowBox[{"AxesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"AbsoluteThickness", "[", ".8", "]"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"AbsoluteThickness", "[", ".8", "]"}], "}"}]}], "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"p", "=", 
  RowBox[{"Show", "[", 
   RowBox[{"p1", ",", "p2"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.78240755512928*^9, 3.7824076556184683`*^9}, {
   3.7824077019804487`*^9, 3.782407873166521*^9}, {3.7824079751546993`*^9, 
   3.7824080795554247`*^9}, {3.782408134963209*^9, 3.782408157314417*^9}, {
   3.7824082128289146`*^9, 3.7824082404261236`*^9}, {3.782408295357149*^9, 
   3.7824083178519745`*^9}, {3.7824084521956296`*^9, 3.782408521161117*^9}, {
   3.782408661311211*^9, 3.7824086754174767`*^9}, 3.782410369054948*^9},
 CellLabel->
  "In[765]:=",ExpressionUUID->"65b498f2-369b-451c-89e6-d2dd05ab5e69"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", "2.33`"}], ",", "2.33`", ",", 
   RowBox[{"-", "1.96`"}], ",", "1.96`", ",", 
   RowBox[{"-", "1.645`"}], ",", "1.645`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.782407656863139*^9, {3.7824077028720636`*^9, 3.7824077098992653`*^9}, {
   3.7824077453155527`*^9, 3.782407843500877*^9}, 3.78240787539855*^9, {
   3.782408069793538*^9, 3.7824080802754993`*^9}, {3.7824081364372644`*^9, 
   3.782408161831334*^9}, 3.782408240891882*^9, {3.782408300923259*^9, 
   3.7824083199324107`*^9}, 3.782408523950655*^9, 3.7824103701988883`*^9},
 CellLabel->
  "Out[767]=",ExpressionUUID->"eddbde4b-7f08-4ba8-995c-85cb7134c009"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.782407656863139*^9, {3.7824077028720636`*^9, 3.7824077098992653`*^9}, {
   3.7824077453155527`*^9, 3.782407843500877*^9}, 3.78240787539855*^9, {
   3.782408069793538*^9, 3.7824080802754993`*^9}, {3.7824081364372644`*^9, 
   3.782408161831334*^9}, 3.782408240891882*^9, {3.782408300923259*^9, 
   3.7824083199324107`*^9}, 3.782408523950655*^9, 3.782410370203874*^9},
 CellLabel->
  "Out[768]=",ExpressionUUID->"c8205f10-d389-4c61-a1ac-97d059248fc8"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[1.5], 
      LineBox[{{-0.5, 0.5444563446607}, {0.5, 0.5444563446607}}], 
      LineBox[CompressedData["
1:eJxl0mtIU2Ecx/GzaaQ0FkULXLaQUStbmcsznSt3ajMd6ciIVqK5i0IU1ExI
llgWDN+UjrYW5FpkVFO7QPZiw5ITpZiZBluthDIhetFtVtANpAuevy/6PfDw
8IEv/Hngn+U4uL1OzDCM4+/9986cHwZu1/S+s6LXhhmncv+72vn9UkYKWQKO
LvoUO/V4QvBCsO2mx/n1AXkx+ENHY9wUIcvB9j19UXUhWQH+pU5j/DnkLHBx
+5FydgVZCXaG3pwet5OXgyvLd7Mnk2QVeG59c3RenLwKPBFUpt+uJa8G+973
mK/mkdeAn7TLlkhc5BzwaHdVc6JecMs68MBQ7YKAl5wLDuQeagqXkTXg6+fH
ehO0Dy3rwZ07xlntC+rzwKXeqnMiJfUs2GaetIYUZC04EOwa/rmWnA8+Ho3c
kuaTC8BTfV8q5RqyDjz6O1NXc4xcCL7gapj/1kvWg/2tlstnxJOCN4D3Dw17
njVSvxGceXibrHeAXASWbZWIIrM2gIuU96xJXjDHgRssnoprZB6taitjPz6k
fhN4pN/FqBTCf3j0t3R9j1QumNsMHmNtJyJNNA99Pzvm7k7QPCNY616W0mak
Hl1Q53nnU1NvAn8uuZPm91CPdqbGq0diwr5yxWDd4I3nTx8J5tHSpQemQ2Hq
t4DFV1pXdvioRxutyuRFC/Ul4L2mo2Gmhnr03X57wrGT+lKwJmPQ7Z16JfRo
/ZxAsIJ/KfTmWf8BqaLbAw==
       "]], LineBox[CompressedData["
1:eJxl0l1IU2Ecx/GhK4vCciBhpT1GReioBaYEotsuRm1lbquVJu0URiWtaN5U
q9BIxNlGORz0ohxkRS9gIOioKBZ51cBCc61c4zBqo6RQGER20Yv9/938DhwO
H/jBl/PwlB4+ZTuSo1KppD/v3+/8ozfrpfEu43D8Q+28I+jp8Ltk7fepf9Zb
wIe+uV4Y88gRdMRav9W8hvc7wVMrTwZ/5vAe/ePRUGWgnfe7wHZnQUwpStAe
3a2b8/m/8L4OnBvYdEet5j26U51d0lFB1u8GP9MuSyfKeI+eNhx7qisni3rw
zXDwcbcgS+i4mM0szyfL6GZT45mQhqygX622u2JR+l9hBX+qEg1iMffQDxeu
q0vdoL2Mnpz4qGgM3EO3jcnVM0/4f23ggtbBFble7qEdPd7nmfV0H2W0wZNd
oBSTFXRmcnAkfZws7ODs9Wu+shayhG7piuZ5LNxDm6Lp8yk/nYeC3twWurLW
y+e9B3xuzuZ28H2W0C+DjrGrFj5vtF92Jntc3EMPfB6v0A6/p95esO/saMeD
CFlCv544mD+q4R46saGm17MoTj30/aW6kdPFZOEAO29Vu8OdZAld3irMRXVk
Ge1O9203ydxDNx31bCu5xL194P7KvlljiHvojVUDq9pLuYdOeX5dTFrfUA+t
TTSduNtLFvvBB2r6L1wufEs9tPdexvxVilEPXTIUuF1oJivoxmTzzI4tZNHw
378Bp/vrug==
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh0eWT/xEn9y1R7MV4jC4E8zF1nb/RjKT8Dk
/7vnfbZ0F5S/AJPvzfro0LFJUP4DTH4A40Gn/k6YfdEY/C+Py9kyE2D2YfL3
PDJjcyyF2YfJD2Xm9GMIvga1D5P/4LPqvOYbMPtiMPjmHBcj+bfD7MPkLy/k
F1N+CbMPk1/mrqo+iRlmHybfzObASmY9KF8hFoO/RufknZurLkHtw+Q39SxO
eb8Uyl+Ayb+1TmlZhj+U/wCTP/FSvEPpEihfIQ6Dz7FxxaOk1TD7MPm87uc9
evth9mHyhQKmPaj5dg5qH4IPADpkzLs=
       "]]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}], 
      LineBox[{{-0.5, 0.267564259557784}, {0.5, 0.267564259557784}}], 
      LineBox[CompressedData["
1:eJxt0m9IE3EYwPFtZn/Wgmy16pqGOVnTjTWzpft72Vq2YdpWYCIZK0GC/hAk
JQlHCWZ7IWtFpnDINBYVllRU7MWutZZFCYtGZEsWxPqzArsXMSujYr+nFz0d
HMcHvtxzd88Vew66WkUCgcDz+/xzzR1Zq9i8zR4MPrTmPIv+1/0tBm/BBbAE
ufFklzixGrwIuYzTFeo/xYhlyJEPV76Gr4Ep5LJntinj2APiIuQDzp/p5nPg
YmSPz3L3cwpcgnzW5h1ZkASXIicv6oTLpWAlcnrunvGsBKxC7g+qnaH6KHE5
sqX6NqvhwRpkV0V3ZqYX7qdF3ltUEHd1EjNrkJuFw+3TLFiHfLkutdB/gsxj
KpCb9h/JfJlD9smsRVY3MYzWSfbFVCKLY/wOQRz6dch3OmaU4hhYj7y4o1QT
ioLXI89W1S9pmwBXIT/ZKntacx3etxpZTg1Qbgf0BmT9PGrpzZdgI3I0MNIt
9TwmNiHLV/QNvOgcIzYjD97KvL2vgN6CzJYECtvmg63Ix89fvdEgepQzTSO3
h1X5x7xkHofNx5alWnqJ6Q3IMu3O9PcGMo/DPmRsFE7KiekaZDbqH1rVQ74X
h334/VCPww3PuxHZ4Likzs8j/xOHnY2zu6cSZJ+0DXm8fLB2lxnmYX+kIgrp
jwjpNyFPUK1V02+Iuf/YFz7jPgW9Hfmo6N3213XQYwc8/L7Et3uk34z83NTF
+dPEHHYlY0oqV0Jfi9znm1SMnuZIjy0ZzePtr0Kk3/LXvwDXX8/n
       "]], LineBox[CompressedData["
1:eJxt0m9IE3Ecx/HbsL8QBg2ZlXpbw8IEJ8qKDHdgD9ZcOtfKXFFHGBVqGmQ1
mLJKHYsSYU+WljOrGbVAwjRtuduTgsgaYZni4Ir1xwdGgUhFZKXfX08+HhzH
Cz7wvh/8NIdrbUeUHMeJf99/3/lHMAv5GRM1a7c9Ms5bQlvztoy1aocXLBSD
KxX26hUr2R59c93Ss8+yyIIFbJkpPjA9NER7tCtan+9uDdN+F1hnyX0YTiFL
6N6NH4RzRtYrAYfiv2bGEux/0XpTKJDtYL1S8O3kkVX9D9gePRq9czHNReat
4NXX3o64Z+m8ItpVVVfuOUXuQn9/Ym4fqCDLaOmoOadWQebLwDqVqns2dZB6
6LY2g++HY4B66E2dd7uUWx9TDx0KxjTVV+m+8Dbwsczt3jXttBfRJbGTTbaA
RD20iosa0nLJMrq/cOeL3ntkfjf4a0qGNnCZLKJ/HvrY920/66FNy2PKVGYZ
fX/cHskuYD07uDD+PtGQxHpov89RlJMcoR76RPipJqRmPfRkjV8xeoP19oDl
d9LxW52shw4GyzxVpij10Lx6cMmZaT/10PqX8fSp0g7q7QWrP386f9B4nXpo
zunytjjrqYeWKoef/9bWUQ/NOeJJy5qt1CsHC3nOuegc7cVFrNkcvqJrjCz0
0PKEfcra4qUeWixYr2scv0C9fWD96470S5nd1EPLr/reTPb46Lxod1bDl+Yd
Huot4qImQ2LDaepV/PcfZTjS8g==
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh0aNu70l3qYux/MV4jC4DtMuhtUwl0M4Sdg
4X9cXRYj0QDhL8DkHwjeei9JaxKE/wCT/+Cxt/kvtylQ+6Ix+AaVkkIim6ZD
7cPkK3R2T/mYB+UvwOQzTPnOkykZaA+xD5M/4dji7nveE6D2xWDwF1hcPdr/
ajLUPix8j61le7mg6hdg8h8IbT/wYclMqH8x+QZnYg9PfTsDal8sBn+DSV/V
nF9QfgImP8A958iGm9Og9mHyVxw7dPRGyQKofZj8B8yP3iZ5QPkKcZh8H+7l
HkoLofZh8mdksobumr0Jah8mn4GnWmDXrm1Q+xB8AFZE3N0=
       "]]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}], 
      LineBox[{{-0.5, 0.821348429763616}, {0.5, 0.821348429763616}}], 
      LineBox[CompressedData["
1:eJxl0mtI01EYx/E1VzlYKivzhtskxZZbuebUv85dbDPDApWs0ciY4QgRlBVF
o2GMgtgLK2+IL9QQVOy2giiE1mLZZbhaIQsqyNpGOYdEEaxeSIX/Zy/6HTgc
PvCF53A4BW1dze1cDofT9nf/O9dWQquxWHnGnJh2zTzd/17YKYmuiMkCcPjH
/qumFLIQfEjLfIjyyVvB567Nhw4KyLngkHTmYf7zJdYisGik/qnaTy4Ax2M7
Pv66Sd4G1gT0xW9j5CJwOCz4OTdD9ykGv7wVuRi4QpaCEzZT+VwjuQRsyF/9
lJegeXKw2qccFyTfYxdYdTz7hVPI+nwp2H/J2LsgIyvAMlHV/ZSkd4N5i4/j
d/VkJThLM9vSUUcuA6d1qcW+JrIKLCzzFc02kMvBU+/4/ied5Arwd9vnk47X
5EqwPDLGLUyQGXAm039dKltmXQX+1irJOVZCrgafsd45MdlJVoPTXbcLK4I0
rwYcXG1XqLjUa8C1m9y/B1PJWjDj1j/qNrHW6cCpcq/F3srai+6L9dm43dTr
wW8UDRvTp6lHZ6yXhKI3qK8Fn7a/N2/PpB7dYa5pch6hfg84497ZL3kM9ejx
oSy7xUK9AbxyobEnWE09etoxMfBsC/VGsLNn0HV4M/Xo4UpPtmsD9XVgvuOA
WLaOevSIxzoQf8X+B91esFJ19IE5ytqLdo82Lw6n0bx68Pyp3tJIgHp07uUW
z1cDzduX9B9x2tPz
       "]], LineBox[CompressedData["
1:eJxl1GtIU2Ecx/G5FSRdXEpvnI1FYpFvZJxKc7o5h5Baq6WtouIgma2cYXad
UC7TxBv0QipJORCJGWXRBGVIU5FQYiPKQmSy0JkXZqlBKiSV/f+9+R04HD7w
h+/z8DycbXkXLflymUwm/nn/flcfQ6bBUe/9UVw8rV+1B+18P6+Y1U7+syEL
LBSNNYS1fKV5dHa9eeJ7F9mQDbY8Gp9uesbz6MGw2IS+bzx/AOzdvV4ffp/W
40E31Pjzm2/zeg+CLcsu5ZUqnkc7S1eu6Z/yvBk8UJ0bG+fiefTLqcgNz91k
zSHw0uMRyd1DFtHnohS/br0hS+iKkLLC/pYcQH/22e621nDvMFjs8N/5EuQe
uknoVpW3cw+tFH21kY3cQ7d1ne3Mm+SeBWyarWzxfOIe2qgu0kStcA+tSzZ1
Ptg8RT30vsqYckcqWXMEnPgxvL83gyyiC+fuNd4UyBJaGNDqYq7TfQyge/f7
TlpLyZoc8K706KU9ZWQRbTXNBNtsZAl96VVoqKCAe+h4b6Gwt3aCerngLWk5
8fKHZBH9RP3a6NBxD606rfRHpHEPnaBOss8beb9HwaNbN1X3lPB+0UmOjSlx
2/m80a22NVmyMr5v6PbFxY6RG3zfrOBEU7M9nf8HIvp8XbR58BT30Fd3nkju
nxmjHjr1wrsSY8Y49Y6B1zldbtVCkHroBbn2zIs+soS+3D1cpwiRA+gPQz93
yNfyeR//79+qK+40
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh2mfDVO/cH4zB7MV4jC4O/6tHPqIk4oPwGT
f/X1cp4vylD+Akz+y/XXb0qqQPkPMPn5CdUix7Vh9kVj8Pet51j+UxZmHyaf
1f72pB0GMPsw+d3tTTOLvWD2YfJFhJonPYqC2ReDwf+z8f/15DCYfZj8N9JH
GSszYfZh8nkZtNfuvACzD5M/Q+t2eMFXmH2xGPygeXMPrCt6DLUPk7/n3bFX
e2Kg/AWYfJfbdUbbwqD8B5j8859s83+vgPIV4jD411Ilc9v3wuzD5Dt8yZ/M
8vgJ1D5Mfmdn1KapQY+g9iH4APE+26k=
       "]]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      LineBox[{{-0.5, 0.31153424732090806`}, {0.5, 0.31153424732090806`}}], 
      LineBox[CompressedData["
1:eJxl0l9IU2EYx/FD6EUUc86sFmabTaxcuGnNWdOzaqmLqJw1YjWVhRcOJUpm
bGYtshZ20R8YzFwQZLR1EQy0pBWNQt3arCxJIRiSgWmQU8KiRlb4Pl30O3A4
fODL+7y875Fajhvql3AcZ/nz/v0uPt/5A+kdwYjwJb/oFO3/djS91zhSycvB
3equqMg9xCwCq2/deHa4lrwSLDONW20byGvAIkkv5y+NMWeDHy2omp1pZCm4
kT/mWrWXvB7MZZhlMyZyLnguq0r+MR5lzgP7Pk9+44bJG8HtQf9Ys4CcDxaM
//KNusibwe88QZttHe2nAHxdUpBfLWR2KsCK/UVn6lVkJdhxKBFyK9k8ZyF4
34TkcWcHuw9nEdhqb71cHaf1toAbH/S2RCvZ/+LcCr44n2iIaMgq8AdLy6mM
cnIx+H5YUXvCTFaDs0uaBnIv0X5KwJ/iVQG5iPpt4HtC98K0m7wdfM17195/
9jWzBuydOh0WCV8xl4KPelpv3zFQXwZO6pOhZAWZB3M9sqeZ59l6Wi24RuN/
PqRnDqET5ps98wbqd4DflBXajefYvBA68+HS6bVWZu1O8I+Ts+KAjp1XCD2X
NdrOc9TvAscm+D1tMXZfIXSdSXq1rpNZqwMLvroHi5fRPHTf8BVxyooXrN8N
NtaMvXX9jLAevdqbY5vpZtaWg7m+2GRXA/VoXV7ayMF06ivAhviIpy2VerQq
kCPmjoRZXwn+4ptSDjwZZD1abp+9YNzUz3r9P/8GryTUpw==
       "]], LineBox[CompressedData["
1:eJxl0l1IU2Ecx/GjjKCtmvMiNhDacAUxPEixXrEdbFjpnG6rudVFD9EyI5hD
ZmUz1F6EpMIRVF7EURCid1dnGWKztQyJIIwyB43DiBwEJeFFRNCL/Z9ufoMx
PvDj+Z7nMMuBsDdULAgC+/P9+7v4kWql0vxgTd2XjGPRE+iSiVKl6+Lzf5bq
wK1vmpLfFp7RHu2aSq3ep6XzJBc4oY9kG6f5Hv1Jt3VGTPF9PVi2Kc3iOH9e
9GhLm0H28b0bfPzJmhlpkO/R5+/0jhTl+b4BPF+dtGWu8T06NxrZNtxNNjei
u8MOQw2Zoa0fQ4XepWQZHasuMym/6H2p6Ju75uIrM2SzB7yi2L1zXTuZofMG
u0m8kqYeOvEh53Ftp/+Dih44+WD5FmGSel6wUT2cUE7TnqHf6y6lolUvqIdu
95+YXJ+j81S0EFnlte6nvdkH3rC5UnU4yQxtDjQYHpXwHnroq037qof30OmO
BX/rIX7f3eDseHDTsJ3M0Gfk6VNdY/Q+ZLSmrbA2IPEe2u8Y2vuug/f2gKti
YbuFm6Hrb78+qCnn90Vbz8XLtT0PqYc2Ot0VY3qFen5wWcGtzr9NUg8d2NgZ
dfbfpx5abQ7Hr3eSVfT37OXQ4/571GsCsymPmO6jPUPfmH1qOhK7RT20VKSJ
XhDpPBVtNFZarL671AuAl+34PLvExe+LPir86KsIJqiH/qk/Jr8c4PdFX9XN
1bac5b3gf/8GWfTNxg==
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh06GD4Zm9qusgfzFaIw+By1q9SYz62E8BMw
+ScKbk36ar4Cwl+AyZ/x60So1JHFEP4DTH7BgwthrFcXQe2LxuA38DEFrzVY
CLUPk9+xe+fBlHQofwEmP2C5w/SQ82ug9mHyZ0zfJvnt6RKofTEYfIHaBWs2
mkLdm4DJb7h75lmF2FKofZj8H78q7ynqQd3zAJOvsPjhde2NUL5CLAb/QYve
oQtZs6D2YfIPSB1bvU1jDtQ+TP6EoIN1765OgtqHyWcQezr50o/JUPviMPgf
5jXPvTobqj4Bk//g08/jl1707YfYh8m3sLyQMWPSIgj/AYIPAAZz1/k=
       "]]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      LineBox[{{-0.5, 0.777378442000492}, {0.5, 0.777378442000492}}], 
      LineBox[CompressedData["
1:eJxl01tIE1Acx/Ep0WQugxmWsc2NGqKbrm1qui5bc1tbWtHAzBhJkzIqL4sc
mRWj7AJhDAoWQtAsRvaw2HxQCluIEWJFF6GHIMUhFBIEZSkTu+B+e+h34HD4
wBfO4Q9H6WlzHckUCASev/vfubzmTRrNuubFC59Ny15h/t/u2cGhiW5YTA7Y
hUrnMVhCdgkn9bIWOI/cdDneWdgKrye78250jhTDcrK4xZgYUMNK8vF46IQ2
F95AvtfwakxeA6vI8pW24ve/4EKyzHepa3wSLiIvlSxI1oZgNTlgONkYdcEl
5N7+8HBpep5a8sPpQGwE8/RvIi/8+BBdvAjryJXSiuxqP6wnX8kMzmfhvX4D
2eFLukJpl5HnYtn1bwbgcrK8zl4nisAV5NN3OwZbX8KbyfqlWPS89EvKleTb
RbusagtcRZ6+OmMznIWN5DV3Mhr3nYO3kKfMYz2O5/BWctt+X8MDNbyNLFIk
DuR64O1kjbc35G2GTeSNs8Lwx/6UzWby690K/Uwk5Wfsd6PeYWkc/Q6y9pBj
tC+Jnu2p9B7O+Y3eQp7KsT61HkXPXvXCqCt/hL6a3K3S+YNd6NkjbsP1vUH0
VvInyc2Cg9fQs+dWt9eP70FvI9+PDCW+16JnZ/lUiiYTejs588yt0rIq9OxT
PQWPa0Xod5InxE5LSIae3S7Jf9uXvs9B/hmp+SrPQM/+Fs5PPulI/SezM+0/
atHQKQ==
       "]], LineBox[CompressedData["
1:eJxl0lFIU2EYxvExh4JGQW3SQuu4ZpFdREYSTnBQF2Wam9apYehpaM3GaASu
WCJBaZgQMdnFJHNZbJVihqJkQRLEiVzNEjdQg5nZInAORGJQUNn7dvMcOBx+
8MD/fPDlWS9UNSgVCoX05/37XXuMZcY5y7xT1/2tdM3j6HiG92lP59d/Nh4F
t6aimvRM8jjaURezD+XwvhyciHyoO7ee92jFj4Wrspn3FWC7Wl/i/c57dK7Y
3R6Y5v0xcMNCvXN4lvdovdbTo/rJ+0qw8k7erF0Vpz16eGrCIWeSBRNYHx07
n7GBLKHDwejSQBbZj369f1Ph6EZyDF1f5nszOUP/K5jB1tF1cudu7qGLXkXk
7FXa+9G2HEeoNEmOobuW9z2bN/B5q8BZBnWfZhf30FI4YL4p8nnRD/JFdfVZ
Pi86mNrRm+vhXjU40NHq3eLjHto6dOlgxQ3uoWvDNcV7EovUQ7ecibvakmTh
OFjVUaJfWiFL6EeJewODc2Q/+t21xanmT9xDhywFd13Z3DsBbumyHdiu4x76
4Uj+trQm7qE3RyZMxZe5h955qM3kvsI9EXz6ZaGY6uce2hhyPk8a+L6hXalK
l+c23zd0v1Z3X9nO9/0k+OKvj31vPWQJfUub7h5r5B76veFJcLX2M/XQj2eO
FLgGycIpsHta6k0r/0I9dHOjzSdryH701snre18UkWNov2OkZuUwWbD8929q
MPLi
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh1uSS/97uzwxB7MV4jC4B/rX1m12g3KT8Dk
666ec902HMpfgMlfVNoq2xoG5T/A5Ht+Dn5rFwOzLxqDz3PY3TDOF2YfJp/F
XXrXqTiYfZj8Bz+msHC3wezD5Kd1ddmodMHsi8HkM7Dbb2mG2YfJP794Ufvu
6TD7MPnHlttybvgAsw+Tz6Lk9OaD0FOofbEY/NYd28Oarz+E2ofJXxPtun7l
ESh/ASbfbYmO0c4dUP4DTP7DlQdWr2N5BLUvDoMvMGWPaYsYlJ+Ayb+h936y
AfdjqH2Y/DnaN76lL3kAtQ/BBwC9ds+/
       "]]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}], 
      LineBox[{{-0.5, 0.348968155821946}, {0.5, 0.348968155821946}}], 
      LineBox[CompressedData["
1:eJxl0mtIU3EYx/GxWgaFkaMER9kaYjF2amtuNm3naDU3JDnYhehCNCymwTJM
jCibmSaT0bwU3RmKtIiCwjf2ok52MQtz1mxlbNEodetFFCFChhX+H1/0O/Dn
8IEv/+fAc9TOw6UH5DKZzPn3/HvPPJO8MTjATfUO8TOeK/zveSlnhZ4H5IVg
57IuoaqRnAb2B4N1DW7yUrBoseurtpMzwIa7buFGLMS8HBwue97c3k9Wg0/t
9GV7PpE1YEdQHhC/k7PAlXxK6/wwORuc+jSS1T87bzV4wf6mYf4gWQvWXhi9
VdNC1oFV16/ld46Q14CHG8v5Nvoez1qw6SOnqU2Q9eBfxvS+FUfIBrBJVW17
5GX78KwDu8ZGAx15ZCPYHJUds3wh54C5pt8VfTGyCTz5ZEr8NkY2gyu6J87v
+EnOBf+wm7lBHXk9+DEfUE5/JVvA40FlUXLVa+Y8cHmywdcpvmHOB2tFTWbm
Nuo3gN8qThYb0qm3gs+4FP6CVDIP3ldaWK3zsfsEAezquVjSW88sob2exc/a
vNQXgBMutze0i82T0G71lTK5jVkoBDcP5QYUMpqH5s7V3Q5FaN5G8OdxMRxx
sH1I6BNdu++06JmFTWDvlpWH0mifEnp65KZfvoj978Jm8P1L7aePzmGW0MnK
wIvEvUHW28B7uh3RvceZJXRU+c6qyqC+CFxs/aB3L6EefXWiRtNa/4r1dnA8
52FtPDbAenQofvl9x9aXrHfM+g+XCt4v
       "]], LineBox[CompressedData["
1:eJxl0mFIE3EYx/GRUItCkkaSpF2ByNBIcHthWB2Z1pZpmzM1RS5jZRRblOnM
eqt1kIhJW0axvRGzF2XTxpbVNXJ4uSysRSXNMwVDl6ZhEJFU8vx78zs4jg88
8P0/f25Ltd1sXaFSqYS/77/v8sMb+SPjR6Ma7dDuZUvoG7aJHllD5g+AKzMf
Fk7bZZpHV8WO6W9eIfMF4MT9ewoaTGwePWXr9PzgX9D8QbCo3zqbc4YsoW9/
7HPa1Wy+EGz1vHcPmNg8+rWy19LnZPNF4Nb88sqfpWwendWcOhjJJXOHwNEn
FUkn48kC+qlzlXwnQvfhRo9qM30Tw2QFPZ9sjyY2kTkTOOVesPZUGVlAByJ5
tlcNg9RDR9MNm49/pfMq6Df13nCtl/4XzgzWd+t0UzvIAvpd0YOM52Nh6qGl
3lBHzlWygnbFzSZMJrykXjFY9i6MnvhF8wI6f6yjxBhiPfTngU0Z+yQ6r4Lu
mnFcXuhk+1rAp3uLV6Y3sn3RjtVfFqviyG70kjh3cegS66HFkaB46xzrlYDj
P+Vd89WxHromuKH1QwrbFx3btr3Hb5Goh55ra9sZu07mDoOH+3+vuV//jHro
2PdkQ0vzY+qhHe1pLZN3yQpayvZ3hVVkrhRcs9TYbg6QBbTGY+hWr31EPbRr
5jw/nhqgHvqb9qyxetFPvTKwz2VVj4ToPgT0hTrddJrM9kWv00Z2vc3tpx66
aV60bVxP5+XK//sPyk/4xg==
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh2Ybp7xKRXdaQ/mK0Rh8MMcF/0ofLYDwk/A
5HdNLT2xSBHKX4DJVxCcePmU5jYI/wEm/8nUV4c792+F2heNwQ9Zln1pw5ct
UPsw+T7L71jySkLVL8DkNwhGyb8v2AW1D5P/44H2PqcLUPcoxGDwj+zk9Ixm
hfITMPksz/bf8X0P5S/A5P+Y0sbWHAN1zwNMPssm1eCT62D+jcXgP7JKUZHq
3gi1D5N/xs3fsuEplL8Akx/i1RShUbQeah8mX84268ZJnQ1Q++Iw+AHXzh7n
uABVn4DJdwj/sPV2wkKofZj8D2F1M7pcGqH2IfgAS+HLxw==
       "]]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}], 
      LineBox[{{-0.5, 0.7399445334994541}, {0.5, 0.7399445334994541}}], 
      LineBox[CompressedData["
1:eJxl1F1IU3EYx/HDnLlCoaKt2XQxNO2FMKfLl9l2dJWZ2wLLoFoEMq2B5YWK
ibKEZRNDmRRIZBGS2AvCRggyYa0wydG60S21okz3EpO8GSjuwhLPs4t+Bw6H
D3z5P8//5shqGqpqeQzD1Px7N79bz5q67tsDl10WUm+Zz/7vAs3rYX8WORks
uPc478IO8m6w+Ipj0J5CFoEnzNPK+3HvA39MvJs65wlyloJt6xnOqbhl4G2L
b4qaR8kZYNXZxTL5b/IB8OBI9bK1k/bJBnf09mVlN5APgS/XX5M+zCUfAZuf
jTVGIjTvKPi9e7LdyaM+B2wMDX/vSeLccQx8+JJ3wy8h54LF/cG94j1kOfjt
iHFCryLngf/8rAsYleR8cNQxtlZ7nqwAv/ysWZ/VkY+D7f6Z5ZiJXAAe8DV3
Nr4gF4KvT09JdV5yEdj5wxR2CcKci8Ge5KuxiylkJTiaOm+ZM5BLwO5wQvuT
DzTvBFhn+sX3bpBV4PCCsPgcn85Tg7XpC9FyJWeWBctZV1uLmrMbvd1gs9r0
1JeCMytejQd6qUcrLAcz0/qoLwPP8p7n31rl7uNGr/QEBuo11GvApYklPi1D
89A7Yy2C6l3UnwSnm0JfnwqpRy+J7ggrP3H7sKfAhlZjv8RD+6JnmMnupXHq
T4MjhQpHwij1aG3Vzf2SLurLwb6mpLShR9SjRe8sejOdx54BOytF819uU4+2
anOCN+h/w1bE/RfC8ei1
       "]], LineBox[CompressedData["
1:eJxl0m9IE3Ecx/FrlZB50p9HCa3lipKSoKgHiXhUA52tlmurFdYliiHVYuKj
CnxgMTSOymFmaWeEiYH9ZTEsWT2pMGYLgkGi17ZMrNnWIEetrOz77cnn4Dhe
8IH3/Y5bWeWqqNEJgiD/uf8+Zy/JLGUfSGafzP1YMusA2jQiu8WNH/5ZKgeb
qwIbSm/HaI/udUzXRh+TpZ3gt57K7Z39vEeX6MsUe5L3FnAi5OkInaH3CaBj
/pxe91F+313gvrp0cauL92jbq4jvssL73eC8d2ll1Mt7tF47VF7UQTZYwbHn
M/XJa2QZPbH1TkNPO1lFx4uU5k9dZA1tsz9qsNZxbw9Yf/7LqfkPuIeWLl5y
nzjNPfSoZ4nTf5Z76JZE/YKlw9yrADeVdpvLBriHln9V+r7FuYdeHNw2duE7
99Bz7JvuH189Tj0bWBf3tlnXkWV0e6jaPbGMrKKDV8buve6i/1FDm0znJmtU
smEv+LA4eLflBllGH/OOLPI3k1V08IlxZoXCPbSwOf/NjnCUenawWZdSf0bI
MnqL0dknLuQe+sjBr2stKdpr6KnaoR7fNPcc4PWFxa6hAj4vuv9hpnFNJ/fQ
0VTY93KSz4teJVXfnBfh770PHPKJ19OfuYfOmuvMEgLcQ7sGE4588T310FNt
ucaMg2zYDy4MN/0Yjkaohx7I67a8uEVW0Zkc//KrT8kauqCx9dl4kGxw/vdv
RKEFcQ==
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh0OLfBamHHwkT2YrxCFwc9+/z937zEoPwGT
H2S5aSrzeSh/ASZf/XF+Ru9ZKP8BJn/KOmeueRdh9kVj8LXytd5cgrknAZN/
yfd3nPwlmH2YfNWDslmPWB5D7cPkHyxPcKv+B7MvBoP/78L6D8nfYPZh8p+V
lEdZckPNW4DJv14ScowxAmYfJv9ba3S9VgWUrxCLwQ9YajOjrPIB1D5M/orF
lbH2mVD+Aky+adcsBbcIKP8BJv9tVxDrnXlQvkIcBn/xZe2wpHUw+zD5Mx0L
eusrH0Ltw+RHxV7qjsi5B7UPwQcAyC3WFQ==
       "]]}}, {
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[1.5]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}]}}, {
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[1.5]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{
       2, 2, 0.6, 
        2}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}}, {
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[1.5]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
      AbsoluteDashing[{
       2, 2, 0.6, 
        2}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  AxesStyle->{{
     AbsoluteThickness[0.8]}, {
     AbsoluteThickness[0.8]}},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  LabelStyle->{FontFamily -> "Cmr10", FontSize -> 12},
  Method->{
   "OptimizePlotMarkers" -> True, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-0.5, 123.5}, {-0.088786725066754, 0.864855688298265}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.782407656863139*^9, {3.7824077028720636`*^9, 3.7824077098992653`*^9}, {
   3.7824077453155527`*^9, 3.782407843500877*^9}, 3.78240787539855*^9, {
   3.782408069793538*^9, 3.7824080802754993`*^9}, {3.7824081364372644`*^9, 
   3.782408161831334*^9}, 3.782408240891882*^9, {3.782408300923259*^9, 
   3.7824083199324107`*^9}, 3.782408523950655*^9, 3.782410370404337*^9},
 CellLabel->
  "Out[774]=",ExpressionUUID->"bc10346d-2f3f-4410-8ac4-76f032a0bd65"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.782407656863139*^9, {3.7824077028720636`*^9, 3.7824077098992653`*^9}, {
   3.7824077453155527`*^9, 3.782407843500877*^9}, 3.78240787539855*^9, {
   3.782408069793538*^9, 3.7824080802754993`*^9}, {3.7824081364372644`*^9, 
   3.782408161831334*^9}, 3.782408240891882*^9, {3.782408300923259*^9, 
   3.7824083199324107`*^9}, 3.782408523950655*^9, 3.782410370411319*^9},
 CellLabel->
  "Out[775]=",ExpressionUUID->"e3c42641-0979-4750-9d3a-788554e4f79e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1"}], ",", "0", ",", 
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "3"}], ",", 
   RowBox[{"-", "4"}], ",", 
   RowBox[{"-", "5"}], ",", 
   RowBox[{"-", "6"}], ",", 
   RowBox[{"-", "7"}], ",", 
   RowBox[{"-", "8"}], ",", 
   RowBox[{"-", "9"}], ",", 
   RowBox[{"-", "10"}], ",", 
   RowBox[{"-", "11"}], ",", 
   RowBox[{"-", "12"}], ",", 
   RowBox[{"-", "13"}], ",", 
   RowBox[{"-", "14"}], ",", 
   RowBox[{"-", "15"}], ",", 
   RowBox[{"-", "16"}], ",", "17", ",", 
   RowBox[{"-", "18"}], ",", 
   RowBox[{"-", "19"}], ",", 
   RowBox[{"-", "20"}], ",", 
   RowBox[{"-", "21"}], ",", 
   RowBox[{"-", "22"}], ",", 
   RowBox[{"-", "23"}], ",", "24", ",", 
   RowBox[{"-", "25"}], ",", 
   RowBox[{"-", "26"}], ",", 
   RowBox[{"-", "27"}], ",", 
   RowBox[{"-", "28"}], ",", 
   RowBox[{"-", "29"}], ",", 
   RowBox[{"-", "30"}], ",", 
   RowBox[{"-", "31"}], ",", "32", ",", "33", ",", 
   RowBox[{"-", "34"}], ",", 
   RowBox[{"-", "35"}], ",", "36", ",", "37", ",", "38", ",", "39", ",", "40",
    ",", "41", ",", "42", ",", 
   RowBox[{"-", "43"}], ",", 
   RowBox[{"-", "44"}], ",", "45", ",", "46", ",", 
   RowBox[{"-", "47"}], ",", "48", ",", "49", ",", 
   RowBox[{"-", "50"}], ",", "0", ",", "0", ",", 
   RowBox[{"-", "51"}], ",", 
   RowBox[{"-", "52"}], ",", 
   RowBox[{"-", "53"}], ",", 
   RowBox[{"-", "54"}], ",", 
   RowBox[{"-", "55"}], ",", 
   RowBox[{"-", "56"}], ",", 
   RowBox[{"-", "57"}], ",", 
   RowBox[{"-", "58"}], ",", "59", ",", "60", ",", 
   RowBox[{"-", "61"}], ",", 
   RowBox[{"-", "62"}], ",", 
   RowBox[{"-", "63"}], ",", 
   RowBox[{"-", "64"}], ",", 
   RowBox[{"-", "65"}], ",", 
   RowBox[{"-", "66"}], ",", 
   RowBox[{"-", "67"}], ",", 
   RowBox[{"-", "68"}], ",", 
   RowBox[{"-", "69"}], ",", 
   RowBox[{"-", "70"}], ",", 
   RowBox[{"-", "71"}], ",", 
   RowBox[{"-", "72"}], ",", 
   RowBox[{"-", "73"}], ",", 
   RowBox[{"-", "74"}], ",", 
   RowBox[{"-", "75"}], ",", 
   RowBox[{"-", "76"}], ",", 
   RowBox[{"-", "77"}], ",", 
   RowBox[{"-", "78"}], ",", 
   RowBox[{"-", "79"}], ",", 
   RowBox[{"-", "80"}], ",", 
   RowBox[{"-", "81"}], ",", 
   RowBox[{"-", "82"}], ",", 
   RowBox[{"-", "83"}], ",", "84", ",", 
   RowBox[{"-", "85"}], ",", "86", ",", "87", ",", 
   RowBox[{"-", "88"}], ",", 
   RowBox[{"-", "89"}], ",", 
   RowBox[{"-", "90"}], ",", 
   RowBox[{"-", "91"}], ",", 
   RowBox[{"-", "92"}], ",", 
   RowBox[{"-", "93"}], ",", 
   RowBox[{"-", "94"}], ",", 
   RowBox[{"-", "95"}], ",", 
   RowBox[{"-", "96"}], ",", 
   RowBox[{"-", "97"}], ",", 
   RowBox[{"-", "98"}], ",", "0", ",", "0", ",", "0", ",", 
   RowBox[{"-", "99"}], ",", 
   RowBox[{"-", "100"}], ",", "101", ",", 
   RowBox[{"-", "102"}], ",", 
   RowBox[{"-", "103"}], ",", 
   RowBox[{"-", "104"}], ",", "105", ",", "106", ",", 
   RowBox[{"-", "107"}], ",", 
   RowBox[{"-", "108"}], ",", 
   RowBox[{"-", "109"}], ",", 
   RowBox[{"-", "110"}], ",", 
   RowBox[{"-", "111"}], ",", 
   RowBox[{"-", "112"}], ",", 
   RowBox[{"-", "113"}], ",", 
   RowBox[{"-", "114"}], ",", 
   RowBox[{"-", "115"}], ",", 
   RowBox[{"-", "116"}], ",", 
   RowBox[{"-", "117"}], ",", 
   RowBox[{"-", "118"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.782407656863139*^9, {3.7824077028720636`*^9, 3.7824077098992653`*^9}, {
   3.7824077453155527`*^9, 3.782407843500877*^9}, 3.78240787539855*^9, {
   3.782408069793538*^9, 3.7824080802754993`*^9}, {3.7824081364372644`*^9, 
   3.782408161831334*^9}, 3.782408240891882*^9, {3.782408300923259*^9, 
   3.7824083199324107`*^9}, 3.782408523950655*^9, 3.782410370424285*^9},
 CellLabel->
  "Out[776]=",ExpressionUUID->"90ef2398-463e-48ac-a202-31e46009d0f2"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[1.5],
       LineBox[{{16.5, 0.4913233494032}, {16.5, 0.4900202991654}, {17.5, 
       0.4900202991654}, {17.5, 0.4890538411644}}], 
      LineBox[{{23.5, 0.5057343443158}, {23.5, 0.5021456384647}, {24.5, 
       0.5021456384647}, {24.5, 0.5061160827953}}], 
      LineBox[{{31.5, 0.5241355915517}, {31.5, 0.5153157047558}, {32.5, 
       0.5153157047558}, {32.5, 0.510617792648}, {33.5, 0.510617792648}, {
       33.5, 0.5246492424962}}], 
      LineBox[{{35.5, 0.5349307068445}, {35.5, 0.5151222752566}, {36.5, 
       0.5151222752566}, {36.5, 0.5076297775378}, {37.5, 0.5076297775378}, {
       37.5, 0.4945776451298}, {38.5, 0.4945776451298}, {38.5, 
       0.4929791794736}, {39.5, 0.4929791794736}, {39.5, 0.4907446178952}, {
       40.5, 0.4907446178952}, {40.5, 0.4939576256322}, {41.5, 
       0.4939576256322}, {41.5, 0.4721077703455}, {42.5, 0.4721077703455}, {
       42.5, 0.4968161216776}}], 
      LineBox[{{44.5, 0.4946668124107}, {44.5, 0.4911944178924}, {45.5, 
       0.4911944178924}, {45.5, 0.4859062387127}, {46.5, 0.4859062387127}}], 
      LineBox[{{47.5, 0.4901734967653}, {47.5, 0.4779417630367}, {48.5, 
       0.4779417630367}, {48.5, 0.4567355202808}, {49.5, 0.4567355202808}, {
       49.5, 0.464863207737}}], 
      LineBox[{{49.5, 0.464863207737}, {50.5, 0.464863207737}, {49.5, 
       0.464863207737}, {50.5, 0.464863207737}}], 
      LineBox[{{60.5, 0.4361912142274}, {60.5, 0.4362172051235}, {61.5, 
       0.4362172051235}, {61.5, 0.4375460358412}, {62.5, 0.4375460358412}, {
       62.5, 0.4401161429093}}], 
      LineBox[{{85.5, 0.4180096441577}, {85.5, 0.3760103313598}, {86.5, 
       0.3760103313598}}], 
      LineBox[{{87.5, 0.3755177457284}, {87.5, 0.3742729979572}, {88.5, 
       0.3742729979572}, {88.5, 0.3767453513734}, {89.5, 0.3767453513734}, {
       89.5, 0.3797667716879}}], 
      LineBox[{{99.5, 0.3467583510969}, {100.5, 0.3467583510969}, {99.5, 
       0.3467583510969}, {100.5, 0.3467583510969}, {99.5, 0.3467583510969}, {
       100.5, 0.3467583510969}}], 
      LineBox[{{105.5, 0.3420132818436}, {105.5, 0.3377337011246}, {106.5, 
       0.3377337011246}, {106.5, 0.33708352119}}], 
      LineBox[{{109.5, 0.3340094149749}, {109.5, 0.3339935602594}, {110.5, 
       0.3339935602594}, {110.5, 0.3346004824318}, {111.5, 0.3346004824318}, {
       111.5, 0.3413399738709}}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{0.6, 2}], 
      LineBox[{{16.5, 0.16788706978171597`}, {16.5, 0.162068150101721}, {17.5,
        0.162068150101721}, {17.5, 0.16023481678040002`}}], 
      LineBox[{{23.5, 0.18569125847257395`}, {23.5, 0.16621876112029893`}, {
       24.5, 0.16621876112029893`}, {24.5, 0.1694415570642519}}], 
      LineBox[{{31.5, 0.20347310492459497`}, {31.5, 0.19255730556751194`}, {
       32.5, 0.19255730556751194`}, {32.5, 0.18288843160649804`}, {33.5, 
       0.18288843160649804`}, {33.5, 0.19187544290758002`}}], 
      LineBox[{{35.5, 0.20559643504599795`}, {35.5, 0.18478181716027403`}, {
       36.5, 0.18478181716027403`}, {36.5, 0.17756082759589098`}, {37.5, 
       0.17756082759589098`}, {37.5, 0.16176714943335502`}, {38.5, 
       0.16176714943335502`}, {38.5, 0.15740247232270999`}, {39.5, 
       0.15740247232270999`}, {39.5, 0.14601370444496103`}, {40.5, 
       0.14601370444496103`}, {40.5, 0.14707694497625906`}, {41.5, 
       0.14707694497625906`}, {41.5, 0.11991877873331097`}, {42.5, 
       0.11991877873331097`}, {42.5, 0.14752116445216396`}}], 
      LineBox[{{44.5, 0.14478535333104398`}, {44.5, 0.14287521173653694`}, {
       45.5, 0.14287521173653694`}, {45.5, 0.13693487628420703`}, {46.5, 
       0.13693487628420703`}}], 
      LineBox[{{47.5, 0.13984915638181994`}, {47.5, 0.125805376574053}, {48.5,
        0.125805376574053}, {48.5, 0.10068106042939201`}, {49.5, 
       0.10068106042939201`}, {49.5, 0.10881465347819502`}}], 
      LineBox[{{49.5, 0.10881465347819502`}, {50.5, 0.10881465347819502`}, {
       49.5, 0.10881465347819502`}, {50.5, 0.10881465347819502`}}], 
      LineBox[{{60.5, 0.10643775781969}, {60.5, 0.10577702668038097`}, {61.5, 
       0.10577702668038097`}, {61.5, 0.10773586401319701`}, {62.5, 
       0.10773586401319701`}, {62.5, 0.10824144207896202`}}], 
      LineBox[{{85.5, 0.12984149612181195`}, {85.5, 0.025888145598451984`}, {
       86.5, 0.025888145598451984`}}], 
      LineBox[{{87.5, 0.024343356823259055`}, {87.5, 0.023048578613796}, {
       88.5, 0.023048578613796}, {88.5, 0.025497406593175953`}, {89.5, 
       0.025497406593175953`}, {89.5, 0.005242848906872988}}], 
      LineBox[{{99.5, 0.00540532251058401}, {100.5, 0.00540532251058401}, {
       99.5, 0.00540532251058401}, {100.5, 0.00540532251058401}, {99.5, 
       0.00540532251058401}, {100.5, 0.00540532251058401}}], 
      LineBox[{{105.5, -0.004649595632007009}, {
       105.5, -0.016421430528431036`}, {106.5, -0.016421430528431036`}, {
       106.5, -0.01773981556228299}}], 
      LineBox[{{109.5, -0.023140252690035}, {109.5, -0.024234691464524005`}, {
       110.5, -0.024234691464524005`}, {110.5, -0.02575274751295703}, {
       111.5, -0.02575274751295703}, {111.5, -0.015914418480810044`}}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{0.6, 2}], 
      LineBox[{{16.5, 0.814759629024684}, {16.5, 0.817485667268796}, {17.5, 
       0.817485667268796}, {17.5, 0.8178728655484}}], 
      LineBox[{{23.5, 0.825777430159026}, {23.5, 0.8270890118849579}, {24.5, 
       0.8270890118849579}, {24.5, 0.842790608526348}}], 
      LineBox[{{31.5, 0.8447980781788049}, {31.5, 0.835248253944873}, {32.5, 
       0.835248253944873}, {32.5, 0.838347153689502}, {33.5, 
       0.838347153689502}, {33.5, 0.8574230420848201}}], 
      LineBox[{{35.5, 0.8642649786430019}, {35.5, 0.8454627333529261}, {36.5, 
       0.8454627333529261}, {36.5, 0.8376987274797091}, {37.5, 
       0.8376987274797091}, {37.5, 0.827388140826245}, {38.5, 
       0.827388140826245}, {38.5, 0.82855588662449}, {39.5, 
       0.82855588662449}, {39.5, 0.835475531345439}, {40.5, 
       0.835475531345439}, {40.5, 0.840838306288141}, {41.5, 
       0.840838306288141}, {41.5, 0.8242967619576891}, {42.5, 
       0.8242967619576891}, {42.5, 0.8461110789030359}}], 
      LineBox[{{44.5, 0.844548271490356}, {44.5, 0.839387597480432}, {45.5, 
       0.839387597480432}, {45.5, 0.8348776011411929}, {46.5, 
       0.8348776011411929}}], 
      LineBox[{{47.5, 0.84049783714878}, {47.5, 0.830078149499347}, {48.5, 
       0.830078149499347}, {48.5, 0.811685192358621}, {49.5, 
       0.811685192358621}, {49.5, 0.8209117619958051}}], 
      LineBox[{{49.5, 0.8209117619958051}, {50.5, 0.8209117619958051}, {49.5, 
       0.8209117619958051}, {50.5, 0.8209117619958051}}], 
      LineBox[{{60.5, 0.76594467063511}, {60.5, 0.766529872191066}, {61.5, 
       0.766529872191066}, {61.5, 0.767356207669203}, {62.5, 
       0.767356207669203}, {62.5, 0.771990843739638}}], 
      LineBox[{{85.5, 0.706177792193588}, {85.5, 0.711018168443222}, {86.5, 
       0.711018168443222}}], 
      LineBox[{{87.5, 0.726692134633541}, {87.5, 0.7254974173006039}, {88.5, 
       0.7254974173006039}, {88.5, 0.727993296153624}, {89.5, 
       0.727993296153624}, {89.5, 0.754290694468927}}], 
      LineBox[{{99.5, 0.688111379683216}, {100.5, 0.688111379683216}, {99.5, 
       0.688111379683216}, {100.5, 0.688111379683216}, {99.5, 
       0.688111379683216}, {100.5, 0.688111379683216}}], 
      LineBox[{{105.5, 0.688676159319207}, {105.5, 0.686870215741202}, {106.5,
        0.686870215741202}, {106.5, 0.691906857942283}}], 
      LineBox[{{109.5, 0.691159082639835}, {109.5, 0.6922218119833241}, {
       110.5, 0.6922218119833241}, {110.5, 0.694953712376557}, {111.5, 
       0.694953712376557}, {111.5, 0.69859436622261}}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       LineBox[{{16.5, 0.219248195730192}, {16.5, 0.214146388365052}, {17.5, 
       0.214146388365052}, {17.5, 0.21245071335640003`}}], 
      LineBox[{{23.5, 0.236513551074288}, {23.5, 0.21956337254408798`}, {24.5,
        0.21956337254408798`}, {24.5, 0.22290489376832395`}}], 
      LineBox[{{31.5, 0.25439375730743996`}, {31.5, 0.24511863566554398`}, {
       32.5, 0.24511863566554398`}, {32.5, 0.23493129151437603`}, {33.5, 
       0.23493129151437603`}, {33.5, 0.24471935099676}}], 
      LineBox[{{35.5, 0.25789415202687593`}, {35.5, 0.23723931479788807`}, {
       36.5, 0.23723931479788807`}, {36.5, 0.22997521020469203`}, {37.5, 
       0.22997521020469203`}, {37.5, 0.21461688480146002`}, {38.5, 
       0.21461688480146002`}, {38.5, 0.21069147732091997`}, {39.5, 
       0.21069147732091997`}, {39.5, 0.20075638168813204`}, {40.5, 
       0.20075638168813204`}, {40.5, 0.20216100156110806`}, {41.5, 
       0.20216100156110806`}, {41.5, 0.17584578598503203`}, {42.5, 
       0.17584578598503203`}, {42.5, 0.20298860401156799`}}], 
      LineBox[{{44.5, 0.200345928378028}, {44.5, 0.198293717466416}, {45.5, 
       0.198293717466416}, {45.5, 0.19235092954538402`}, {46.5, 
       0.19235092954538402`}}], 
      LineBox[{{47.5, 0.19548006021953995`}, {47.5, 0.181724030218336}, {48.5,
        0.181724030218336}, {48.5, 0.15722189740150405`}, {49.5, 
       0.15722189740150405`}, {49.5, 0.16535455265234}}], 
      LineBox[{{49.5, 0.16535455265234}, {50.5, 0.16535455265234}, {49.5, 
       0.16535455265234}, {50.5, 0.16535455265234}}], 
      LineBox[{{60.5, 0.15880204059687997`}, {60.5, 0.158250359737872}, {61.5,
        0.158250359737872}, {61.5, 0.160109153101764}, {62.5, 
       0.160109153101764}, {62.5, 0.160942574828844}}], 
      LineBox[{{85.5, 0.175602103320644}, {85.5, 0.08148694762922398}, {86.5, 
       0.08148694762922398}}], 
      LineBox[{{87.5, 0.08010924690690807}, {87.5, 0.078822413445152}, {88.5, 
       0.078822413445152}, {88.5, 0.08127497722351196}, {89.5, 
       0.08127497722351196}, {89.5, 0.06471660488497599}}], 
      LineBox[{{99.5, 0.059611597436308006`}, {100.5, 
       0.059611597436308006`}, {99.5, 0.059611597436308006`}, {100.5, 
       0.059611597436308006`}, {99.5, 0.059611597436308006`}, {100.5, 
       0.059611597436308006`}}], 
      LineBox[{{105.5, 0.05039987418171604}, {105.5, 0.03981779638642802}, {
       106.5, 0.03981779638642802}, {106.5, 0.03860552117520405}}], 
      LineBox[{{109.5, 0.033574501402680035`}, {109.5, 
       0.032651339925112044`}, {110.5, 0.032651339925112044`}, {110.5, 
       0.03147072677011603}, {111.5, 0.03147072677011603}, {111.5, 
       0.04081696571237997}}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       LineBox[{{16.5, 0.763398503076208}, {16.5, 0.765894209965748}, {17.5, 
       0.765894209965748}, {17.5, 0.7656569689724}}], 
      LineBox[{{23.5, 0.774955137557312}, {23.5, 0.7762151018632959}, {24.5, 
       0.7762151018632959}, {24.5, 0.7893272718222759}}], 
      LineBox[{{31.5, 0.79387742579596}, {31.5, 0.784443514374076}, {32.5, 
       0.784443514374076}, {32.5, 0.786304293781624}, {33.5, 
       0.786304293781624}, {33.5, 0.8045791339956401}}], 
      LineBox[{{35.5, 0.811967261662124}, {35.5, 0.793005235715312}, {36.5, 
       0.793005235715312}, {36.5, 0.785284344870908}, {37.5, 
       0.785284344870908}, {37.5, 0.77453840545814}, {38.5, 
       0.77453840545814}, {38.5, 0.77526688162628}, {39.5, 
       0.77526688162628}, {39.5, 0.780732854102268}, {40.5, 
       0.780732854102268}, {40.5, 0.785754249703292}, {41.5, 
       0.785754249703292}, {41.5, 0.768369754705968}, {42.5, 
       0.768369754705968}, {42.5, 0.790643639343632}}], 
      LineBox[{{44.5, 0.788987696443372}, {44.5, 0.784095118318384}, {45.5, 
       0.784095118318384}, {45.5, 0.779461547880016}, {46.5, 
       0.779461547880016}}], 
      LineBox[{{47.5, 0.78486693331106}, {47.5, 0.7741594958550639}, {48.5, 
       0.7741594958550639}, {48.5, 0.755751284821352}, {49.5, 
       0.755751284821352}, {49.5, 0.76437186282166}}], 
      LineBox[{{49.5, 0.76437186282166}, {50.5, 0.76437186282166}, {49.5, 
       0.76437186282166}, {50.5, 0.76437186282166}}], 
      LineBox[{{60.5, 0.71358038785792}, {60.5, 0.7141840505091279}, {61.5, 
       0.7141840505091279}, {61.5, 0.714982918580636}, {62.5, 
       0.714982918580636}, {62.5, 0.719289710989756}}], 
      LineBox[{{85.5, 0.660417184994756}, {85.5, 0.665284613457764}, {86.5, 
       0.665284613457764}}], 
      LineBox[{{87.5, 0.670926244549892}, {87.5, 0.669723582469248}, {88.5, 
       0.669723582469248}, {88.5, 0.672215725523288}, {89.5, 
       0.672215725523288}, {89.5, 0.694816938490824}}], 
      LineBox[{{99.5, 0.633905104757492}, {100.5, 0.633905104757492}, {99.5, 
       0.633905104757492}, {100.5, 0.633905104757492}, {99.5, 
       0.633905104757492}, {100.5, 0.633905104757492}}], 
      LineBox[{{105.5, 0.6336266895054841}, {105.5, 0.6317093151026241}, {
       106.5, 0.6317093151026241}, {106.5, 0.635561521204796}}], 
      LineBox[{{109.5, 0.63444432854712}, {109.5, 0.635335780593688}, {110.5, 
       0.635335780593688}, {110.5, 0.637730238093484}, {111.5, 
       0.637730238093484}, {111.5, 0.6418629820294199}}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{2, 2, 0.6, 2}], 
      LineBox[{{16.5, 0.262974559713354}, {16.5, 0.2584832668865365}, {17.5, 
       0.2584832668865365}, {17.5, 0.2569047874684}}], 
      LineBox[{{23.5, 0.279781178559531}, {23.5, 0.26497837956704345`}, {24.5,
        0.26497837956704345`}, {24.5, 0.2684209777190879}}], 
      LineBox[{{31.5, 0.2977451235252675}, {31.5, 0.2894405788261755}, {32.5, 
       0.2894405788261755}, {32.5, 0.279238050625137}, {33.5, 
       0.279238050625137}, {33.5, 0.28970808355917}}], 
      LineBox[{{35.5, 0.30241788405113695`}, {35.5, 0.2818990763001811}, {
       36.5, 0.2818990763001811}, {36.5, 0.2745982656689415}, {37.5, 
       0.2745982656689415}, {37.5, 0.2596105784256575}, {38.5, 
       0.2596105784256575}, {38.5, 0.25605914373831495`}, {39.5, 
       0.25605914373831495`}, {39.5, 0.24736163393569652`}, {40.5, 
       0.24736163393569652`}, {40.5, 0.24905688757253355`}, {41.5, 
       0.24905688757253355`}, {41.5, 0.22345931918582151`}, {42.5, 
       0.22345931918582151`}, {42.5, 0.25021088363646593`}}], 
      LineBox[{{44.5, 0.24764749902613598`}, {44.5, 0.24536704432059198`}, {
       45.5, 0.24536704432059198`}, {45.5, 0.23952946137584552`}, {46.5, 
       0.23952946137584552`}}], 
      LineBox[{{47.5, 0.24284150537867996`}, {47.5, 0.22933045156414447`}, {
       48.5, 0.22933045156414447`}, {48.5, 0.20535801536424803`}, {49.5, 
       0.20535801536424803`}, {49.5, 0.21348987221951754`}}], 
      LineBox[{{49.5, 0.21348987221951754`}, {50.5, 0.21348987221951754`}, {
       49.5, 0.21348987221951754`}, {50.5, 0.21348987221951754`}}], 
      LineBox[{{60.5, 0.20338244350178497`}, {60.5, 0.2029236027462765}, {
       61.5, 0.2029236027462765}, {61.5, 0.2046972235420305}, {62.5, 
       0.2046972235420305}, {62.5, 0.205809755413203}}], 
      LineBox[{{85.5, 0.21456045809802798`}, {85.5, 0.128821062871638}, {86.5,
        0.128821062871638}}], 
      LineBox[{{87.5, 0.12758561278893354`}, {87.5, 0.12630554309887398`}, {
       88.5, 0.12630554309887398`}, {88.5, 0.12876128735474396`}, {89.5, 
       0.12876128735474396`}, {89.5, 0.11534966740687452`}}], 
      LineBox[{{99.5, 0.10576018284604602`}, {100.5, 0.10576018284604602`}, {
       99.5, 0.10576018284604602`}, {100.5, 0.10576018284604602`}, {99.5, 
       0.10576018284604602`}, {100.5, 0.10576018284604602`}}], 
      LineBox[{{105.5, 0.0972663146988045}, {105.5, 0.08769713821934849}, {
       106.5, 0.08769713821934849}, {106.5, 0.08657519974901051}}], 
      LineBox[{{109.5, 0.08185868394107249}, {109.5, 0.081081339621694}, {
       110.5, 0.081081339621694}, {110.5, 0.08018800893002953}, {111.5, 
       0.08018800893002953}, {111.5, 0.08911530630928499}}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{2, 2, 0.6, 2}], 
      LineBox[{{16.5, 0.7196721390930461}, {16.5, 0.7215573314442636}, {17.5, 
       0.7215573314442636}, {17.5, 0.7212028948603999}}], 
      LineBox[{{23.5, 0.731687510072069}, {23.5, 0.7329035298178269}, {24.5, 
       0.7329035298178269}, {24.5, 0.743811187871512}}], 
      LineBox[{{31.5, 0.7505260595781325}, {31.5, 0.7411908306854245}, {32.5, 
       0.7411908306854245}, {32.5, 0.7419975346708629}, {33.5, 
       0.7419975346708629}, {33.5, 0.7595904014332301}}], 
      LineBox[{{35.5, 0.767443529637863}, {35.5, 0.748345474213019}, {36.5, 
       0.748345474213019}, {36.5, 0.7406612894066585}, {37.5, 
       0.7406612894066585}, {37.5, 0.7295447118339425}, {38.5, 
       0.7295447118339425}, {38.5, 0.729899215208885}, {39.5, 
       0.729899215208885}, {39.5, 0.7341276018547035}, {40.5, 
       0.7341276018547035}, {40.5, 0.7388583636918665}, {41.5, 
       0.7388583636918665}, {41.5, 0.7207562215051785}, {42.5, 
       0.7207562215051785}, {42.5, 0.743421359718734}}], 
      LineBox[{{44.5, 0.741686125795264}, {44.5, 0.737021791464208}, {45.5, 
       0.737021791464208}, {45.5, 0.7322830160495545}, {46.5, 
       0.7322830160495545}}], 
      LineBox[{{47.5, 0.73750548815192}, {47.5, 0.7265530745092555}, {48.5, 
       0.7265530745092555}, {48.5, 0.708113025197352}, {49.5, 
       0.708113025197352}, {49.5, 0.7162365432544825}}], 
      LineBox[{{49.5, 0.7162365432544825}, {50.5, 0.7162365432544825}, {49.5, 
       0.7162365432544825}, {50.5, 0.7162365432544825}}], 
      LineBox[{{60.5, 0.668999984953015}, {60.5, 0.6695108075007234}, {61.5, 
       0.6695108075007234}, {61.5, 0.6703948481403695}, {62.5, 
       0.6703948481403695}, {62.5, 0.674422530405397}}], 
      LineBox[{{85.5, 0.621458830217372}, {85.5, 0.623199599847962}, {86.5, 
       0.623199599847962}}], 
      LineBox[{{87.5, 0.6234498786678665}, {87.5, 0.622240452815526}, {88.5, 
       0.622240452815526}, {88.5, 0.624729415392056}, {89.5, 
       0.624729415392056}, {89.5, 0.6441838759689256}}], 
      LineBox[{{99.5, 0.587756519347754}, {100.5, 0.587756519347754}, {99.5, 
       0.587756519347754}, {100.5, 0.587756519347754}, {99.5, 
       0.587756519347754}, {100.5, 0.587756519347754}}], 
      LineBox[{{105.5, 0.5867602489883955}, {105.5, 0.584748007802213}, {
       106.5, 0.584748007802213}, {106.5, 0.5875918426309895}}], 
      LineBox[{{109.5, 0.5861601460087276}, {109.5, 0.5869057808971061}, {
       110.5, 0.5869057808971061}, {110.5, 0.5890129559335705}, {111.5, 
       0.5890129559335705}, {111.5, 0.593564641432515}}]}}, {
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
      1.5]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
      0.8]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
      0.8]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{2, 2, 0.6, 2}]}}, {
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
      1.5]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
      0.8]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
      0.8]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{
       2, 2, 0.6, 
        2}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}}, {
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
      1.5]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
      0.8]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
      0.8]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{2, 2, 0.6, 2}]}, 
     {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[0.8],
       AbsoluteDashing[{
       2, 2, 0.6, 
        2}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}}}, {{}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  AxesStyle->{{
     AbsoluteThickness[0.8]}, {
     AbsoluteThickness[0.8]}},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  LabelStyle->{FontFamily -> "Cmr10", FontSize -> 12},
  Method->{
   "OptimizePlotMarkers" -> True, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 111.5}, {-0.02575274751295703, 0.8642649786430019}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.782407656863139*^9, {3.7824077028720636`*^9, 3.7824077098992653`*^9}, {
   3.7824077453155527`*^9, 3.782407843500877*^9}, 3.78240787539855*^9, {
   3.782408069793538*^9, 3.7824080802754993`*^9}, {3.7824081364372644`*^9, 
   3.782408161831334*^9}, 3.782408240891882*^9, {3.782408300923259*^9, 
   3.7824083199324107`*^9}, 3.782408523950655*^9, 3.782410370613778*^9},
 CellLabel->
  "Out[781]=",ExpressionUUID->"4f180874-b83d-4dc0-b29d-20f4e4a9aa5d"],

Cell[BoxData[
 GraphicsBox[{{{}, {{{}, {}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[1.5], 
       LineBox[{{-0.5, 0.5444563446607}, {0.5, 0.5444563446607}}], 
       LineBox[CompressedData["
1:eJxl0mtIU2Ecx/GzaaQ0FkULXLaQUStbmcsznSt3ajMd6ciIVqK5i0IU1ExI
llgWDN+UjrYW5FpkVFO7QPZiw5ITpZiZBluthDIhetFtVtANpAuevy/6PfDw
8IEv/Hngn+U4uL1OzDCM4+/9986cHwZu1/S+s6LXhhmncv+72vn9UkYKWQKO
LvoUO/V4QvBCsO2mx/n1AXkx+ENHY9wUIcvB9j19UXUhWQH+pU5j/DnkLHBx
+5FydgVZCXaG3pwet5OXgyvLd7Mnk2QVeG59c3RenLwKPBFUpt+uJa8G+973
mK/mkdeAn7TLlkhc5BzwaHdVc6JecMs68MBQ7YKAl5wLDuQeagqXkTXg6+fH
ehO0Dy3rwZ07xlntC+rzwKXeqnMiJfUs2GaetIYUZC04EOwa/rmWnA8+Ho3c
kuaTC8BTfV8q5RqyDjz6O1NXc4xcCL7gapj/1kvWg/2tlstnxJOCN4D3Dw17
njVSvxGceXibrHeAXASWbZWIIrM2gIuU96xJXjDHgRssnoprZB6taitjPz6k
fhN4pN/FqBTCf3j0t3R9j1QumNsMHmNtJyJNNA99Pzvm7k7QPCNY616W0mak
Hl1Q53nnU1NvAn8uuZPm91CPdqbGq0diwr5yxWDd4I3nTx8J5tHSpQemQ2Hq
t4DFV1pXdvioRxutyuRFC/Ul4L2mo2Gmhnr03X57wrGT+lKwJmPQ7Z16JfRo
/ZxAsIJ/KfTmWf8BqaLbAw==
        "]], LineBox[CompressedData["
1:eJxl0l1IU2Ecx/GhK4vCciBhpT1GReioBaYEotsuRm1lbquVJu0URiWtaN5U
q9BIxNlGORz0ohxkRS9gIOioKBZ51cBCc61c4zBqo6RQGER20Yv9/938DhwO
H/jBl/PwlB4+ZTuSo1KppD/v3+/8ozfrpfEu43D8Q+28I+jp8Ltk7fepf9Zb
wIe+uV4Y88gRdMRav9W8hvc7wVMrTwZ/5vAe/ePRUGWgnfe7wHZnQUwpStAe
3a2b8/m/8L4OnBvYdEet5j26U51d0lFB1u8GP9MuSyfKeI+eNhx7qisni3rw
zXDwcbcgS+i4mM0szyfL6GZT45mQhqygX622u2JR+l9hBX+qEg1iMffQDxeu
q0vdoL2Mnpz4qGgM3EO3jcnVM0/4f23ggtbBFble7qEdPd7nmfV0H2W0wZNd
oBSTFXRmcnAkfZws7ODs9Wu+shayhG7piuZ5LNxDm6Lp8yk/nYeC3twWurLW
y+e9B3xuzuZ28H2W0C+DjrGrFj5vtF92Jntc3EMPfB6v0A6/p95esO/saMeD
CFlCv544mD+q4R46saGm17MoTj30/aW6kdPFZOEAO29Vu8OdZAld3irMRXVk
Ge1O9203ydxDNx31bCu5xL194P7KvlljiHvojVUDq9pLuYdOeX5dTFrfUA+t
TTSduNtLFvvBB2r6L1wufEs9tPdexvxVilEPXTIUuF1oJivoxmTzzI4tZNHw
378Bp/vrug==
        "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh0eWT/xEn9y1R7MV4jC4E8zF1nb/RjKT8Dk
/7vnfbZ0F5S/AJPvzfro0LFJUP4DTH4A40Gn/k6YfdEY/C+Py9kyE2D2YfL3
PDJjcyyF2YfJD2Xm9GMIvga1D5P/4LPqvOYbMPtiMPjmHBcj+bfD7MPkLy/k
F1N+CbMPk1/mrqo+iRlmHybfzObASmY9KF8hFoO/RufknZurLkHtw+Q39SxO
eb8Uyl+Ayb+1TmlZhj+U/wCTP/FSvEPpEihfIQ6Dz7FxxaOk1TD7MPm87uc9
evth9mHyhQKmPaj5dg5qH4IPADpkzLs=
        "]]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{0.6, 2}], 
       LineBox[{{-0.5, 0.267564259557784}, {0.5, 0.267564259557784}}], 
       LineBox[CompressedData["
1:eJxt0m9IE3EYwPFtZn/Wgmy16pqGOVnTjTWzpft72Vq2YdpWYCIZK0GC/hAk
JQlHCWZ7IWtFpnDINBYVllRU7MWutZZFCYtGZEsWxPqzArsXMSujYr+nFz0d
HMcHvtxzd88Vew66WkUCgcDz+/xzzR1Zq9i8zR4MPrTmPIv+1/0tBm/BBbAE
ufFklzixGrwIuYzTFeo/xYhlyJEPV76Gr4Ep5LJntinj2APiIuQDzp/p5nPg
YmSPz3L3cwpcgnzW5h1ZkASXIicv6oTLpWAlcnrunvGsBKxC7g+qnaH6KHE5
sqX6NqvhwRpkV0V3ZqYX7qdF3ltUEHd1EjNrkJuFw+3TLFiHfLkutdB/gsxj
KpCb9h/JfJlD9smsRVY3MYzWSfbFVCKLY/wOQRz6dch3OmaU4hhYj7y4o1QT
ioLXI89W1S9pmwBXIT/ZKntacx3etxpZTg1Qbgf0BmT9PGrpzZdgI3I0MNIt
9TwmNiHLV/QNvOgcIzYjD97KvL2vgN6CzJYECtvmg63Ix89fvdEgepQzTSO3
h1X5x7xkHofNx5alWnqJ6Q3IMu3O9PcGMo/DPmRsFE7KiekaZDbqH1rVQ74X
h334/VCPww3PuxHZ4Likzs8j/xOHnY2zu6cSZJ+0DXm8fLB2lxnmYX+kIgrp
jwjpNyFPUK1V02+Iuf/YFz7jPgW9Hfmo6N3213XQYwc8/L7Et3uk34z83NTF
+dPEHHYlY0oqV0Jfi9znm1SMnuZIjy0ZzePtr0Kk3/LXvwDXX8/n
        "]], LineBox[CompressedData["
1:eJxt0m9IE3Ecx/HbsL8QBg2ZlXpbw8IEJ8qKDHdgD9ZcOtfKXFFHGBVqGmQ1
mLJKHYsSYU+WljOrGbVAwjRtuduTgsgaYZni4Ir1xwdGgUhFZKXfX08+HhzH
Cz7wvh/8NIdrbUeUHMeJf99/3/lHMAv5GRM1a7c9Ms5bQlvztoy1aocXLBSD
KxX26hUr2R59c93Ss8+yyIIFbJkpPjA9NER7tCtan+9uDdN+F1hnyX0YTiFL
6N6NH4RzRtYrAYfiv2bGEux/0XpTKJDtYL1S8O3kkVX9D9gePRq9czHNReat
4NXX3o64Z+m8ItpVVVfuOUXuQn9/Ym4fqCDLaOmoOadWQebLwDqVqns2dZB6
6LY2g++HY4B66E2dd7uUWx9TDx0KxjTVV+m+8Dbwsczt3jXttBfRJbGTTbaA
RD20iosa0nLJMrq/cOeL3ntkfjf4a0qGNnCZLKJ/HvrY920/66FNy2PKVGYZ
fX/cHskuYD07uDD+PtGQxHpov89RlJMcoR76RPipJqRmPfRkjV8xeoP19oDl
d9LxW52shw4GyzxVpij10Lx6cMmZaT/10PqX8fSp0g7q7QWrP386f9B4nXpo
zunytjjrqYeWKoef/9bWUQ/NOeJJy5qt1CsHC3nOuegc7cVFrNkcvqJrjCz0
0PKEfcra4qUeWixYr2scv0C9fWD96470S5nd1EPLr/reTPb46Lxod1bDl+Yd
Huot4qImQ2LDaepV/PcfZTjS8g==
        "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh0aNu70l3qYux/MV4jC4DtMuhtUwl0M4Sdg
4X9cXRYj0QDhL8DkHwjeei9JaxKE/wCT/+Cxt/kvtylQ+6Ix+AaVkkIim6ZD
7cPkK3R2T/mYB+UvwOQzTPnOkykZaA+xD5M/4dji7nveE6D2xWDwF1hcPdr/
ajLUPix8j61le7mg6hdg8h8IbT/wYclMqH8x+QZnYg9PfTsDal8sBn+DSV/V
nF9QfgImP8A958iGm9Og9mHyVxw7dPRGyQKofZj8B8yP3iZ5QPkKcZh8H+7l
HkoLofZh8mdksobumr0Jah8mn4GnWmDXrm1Q+xB8AFZE3N0=
        "]]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{0.6, 2}], 
       LineBox[{{-0.5, 0.821348429763616}, {0.5, 0.821348429763616}}], 
       LineBox[CompressedData["
1:eJxl0mtI01EYx/E1VzlYKivzhtskxZZbuebUv85dbDPDApWs0ciY4QgRlBVF
o2GMgtgLK2+IL9QQVOy2giiE1mLZZbhaIQsqyNpGOYdEEaxeSIX/Zy/6HTgc
PvCF53A4BW1dze1cDofT9nf/O9dWQquxWHnGnJh2zTzd/17YKYmuiMkCcPjH
/qumFLIQfEjLfIjyyVvB567Nhw4KyLngkHTmYf7zJdYisGik/qnaTy4Ax2M7
Pv66Sd4G1gT0xW9j5CJwOCz4OTdD9ykGv7wVuRi4QpaCEzZT+VwjuQRsyF/9
lJegeXKw2qccFyTfYxdYdTz7hVPI+nwp2H/J2LsgIyvAMlHV/ZSkd4N5i4/j
d/VkJThLM9vSUUcuA6d1qcW+JrIKLCzzFc02kMvBU+/4/ied5Arwd9vnk47X
5EqwPDLGLUyQGXAm039dKltmXQX+1irJOVZCrgafsd45MdlJVoPTXbcLK4I0
rwYcXG1XqLjUa8C1m9y/B1PJWjDj1j/qNrHW6cCpcq/F3srai+6L9dm43dTr
wW8UDRvTp6lHZ6yXhKI3qK8Fn7a/N2/PpB7dYa5pch6hfg84497ZL3kM9ejx
oSy7xUK9AbxyobEnWE09etoxMfBsC/VGsLNn0HV4M/Xo4UpPtmsD9XVgvuOA
WLaOevSIxzoQf8X+B91esFJ19IE5ytqLdo82Lw6n0bx68Pyp3tJIgHp07uUW
z1cDzduX9B9x2tPz
        "]], LineBox[CompressedData["
1:eJxl1GtIU2Ecx/G5FSRdXEpvnI1FYpFvZJxKc7o5h5Baq6WtouIgma2cYXad
UC7TxBv0QipJORCJGWXRBGVIU5FQYiPKQmSy0JkXZqlBKiSV/f+9+R04HD7w
h+/z8DycbXkXLflymUwm/nn/flcfQ6bBUe/9UVw8rV+1B+18P6+Y1U7+syEL
LBSNNYS1fKV5dHa9eeJ7F9mQDbY8Gp9uesbz6MGw2IS+bzx/AOzdvV4ffp/W
40E31Pjzm2/zeg+CLcsu5ZUqnkc7S1eu6Z/yvBk8UJ0bG+fiefTLqcgNz91k
zSHw0uMRyd1DFtHnohS/br0hS+iKkLLC/pYcQH/22e621nDvMFjs8N/5EuQe
uknoVpW3cw+tFH21kY3cQ7d1ne3Mm+SeBWyarWzxfOIe2qgu0kStcA+tSzZ1
Ptg8RT30vsqYckcqWXMEnPgxvL83gyyiC+fuNd4UyBJaGNDqYq7TfQyge/f7
TlpLyZoc8K706KU9ZWQRbTXNBNtsZAl96VVoqKCAe+h4b6Gwt3aCerngLWk5
8fKHZBH9RP3a6NBxD606rfRHpHEPnaBOss8beb9HwaNbN1X3lPB+0UmOjSlx
2/m80a22NVmyMr5v6PbFxY6RG3zfrOBEU7M9nf8HIvp8XbR58BT30Fd3nkju
nxmjHjr1wrsSY8Y49Y6B1zldbtVCkHroBbn2zIs+soS+3D1cpwiRA+gPQz93
yNfyeR//79+qK+40
        "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh2mfDVO/cH4zB7MV4jC4O/6tHPqIk4oPwGT
f/X1cp4vylD+Akz+y/XXb0qqQPkPMPn5CdUix7Vh9kVj8Pet51j+UxZmHyaf
1f72pB0GMPsw+d3tTTOLvWD2YfJFhJonPYqC2ReDwf+z8f/15DCYfZj8N9JH
GSszYfZh8nkZtNfuvACzD5M/Q+t2eMFXmH2xGPygeXMPrCt6DLUPk7/n3bFX
e2Kg/AWYfJfbdUbbwqD8B5j8859s83+vgPIV4jD411Ilc9v3wuzD5Dt8yZ/M
8vgJ1D5Mfmdn1KapQY+g9iH4APE+26k=
        "]]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       LineBox[{{-0.5, 0.31153424732090806`}, {0.5, 0.31153424732090806`}}], 
       LineBox[CompressedData["
1:eJxl0l9IU2EYx/FD6EUUc86sFmabTaxcuGnNWdOzaqmLqJw1YjWVhRcOJUpm
bGYtshZ20R8YzFwQZLR1EQy0pBWNQt3arCxJIRiSgWmQU8KiRlb4Pl30O3A4
fODL+7y875Fajhvql3AcZ/nz/v0uPt/5A+kdwYjwJb/oFO3/djS91zhSycvB
3equqMg9xCwCq2/deHa4lrwSLDONW20byGvAIkkv5y+NMWeDHy2omp1pZCm4
kT/mWrWXvB7MZZhlMyZyLnguq0r+MR5lzgP7Pk9+44bJG8HtQf9Ys4CcDxaM
//KNusibwe88QZttHe2nAHxdUpBfLWR2KsCK/UVn6lVkJdhxKBFyK9k8ZyF4
34TkcWcHuw9nEdhqb71cHaf1toAbH/S2RCvZ/+LcCr44n2iIaMgq8AdLy6mM
cnIx+H5YUXvCTFaDs0uaBnIv0X5KwJ/iVQG5iPpt4HtC98K0m7wdfM17195/
9jWzBuydOh0WCV8xl4KPelpv3zFQXwZO6pOhZAWZB3M9sqeZ59l6Wi24RuN/
PqRnDqET5ps98wbqd4DflBXajefYvBA68+HS6bVWZu1O8I+Ts+KAjp1XCD2X
NdrOc9TvAscm+D1tMXZfIXSdSXq1rpNZqwMLvroHi5fRPHTf8BVxyooXrN8N
NtaMvXX9jLAevdqbY5vpZtaWg7m+2GRXA/VoXV7ayMF06ivAhviIpy2VerQq
kCPmjoRZXwn+4ptSDjwZZD1abp+9YNzUz3r9P/8GryTUpw==
        "]], LineBox[CompressedData["
1:eJxl0l1IU2Ecx/GjjKCtmvMiNhDacAUxPEixXrEdbFjpnG6rudVFD9EyI5hD
ZmUz1F6EpMIRVF7EURCid1dnGWKztQyJIIwyB43DiBwEJeFFRNCL/Z9ufoMx
PvDj+Z7nMMuBsDdULAgC+/P9+7v4kWql0vxgTd2XjGPRE+iSiVKl6+Lzf5bq
wK1vmpLfFp7RHu2aSq3ep6XzJBc4oY9kG6f5Hv1Jt3VGTPF9PVi2Kc3iOH9e
9GhLm0H28b0bfPzJmhlpkO/R5+/0jhTl+b4BPF+dtGWu8T06NxrZNtxNNjei
u8MOQw2Zoa0fQ4XepWQZHasuMym/6H2p6Ju75uIrM2SzB7yi2L1zXTuZofMG
u0m8kqYeOvEh53Ftp/+Dih44+WD5FmGSel6wUT2cUE7TnqHf6y6lolUvqIdu
95+YXJ+j81S0EFnlte6nvdkH3rC5UnU4yQxtDjQYHpXwHnroq037qof30OmO
BX/rIX7f3eDseHDTsJ3M0Gfk6VNdY/Q+ZLSmrbA2IPEe2u8Y2vuug/f2gKti
YbuFm6Hrb78+qCnn90Vbz8XLtT0PqYc2Ot0VY3qFen5wWcGtzr9NUg8d2NgZ
dfbfpx5abQ7Hr3eSVfT37OXQ4/571GsCsymPmO6jPUPfmH1qOhK7RT20VKSJ
XhDpPBVtNFZarL671AuAl+34PLvExe+LPir86KsIJqiH/qk/Jr8c4PdFX9XN
1bac5b3gf/8GWfTNxg==
        "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh06GD4Zm9qusgfzFaIw+By1q9SYz62E8BMw
+ScKbk36ar4Cwl+AyZ/x60So1JHFEP4DTH7BgwthrFcXQe2LxuA38DEFrzVY
CLUPk9+xe+fBlHQofwEmP2C5w/SQ82ug9mHyZ0zfJvnt6RKofTEYfIHaBWs2
mkLdm4DJb7h75lmF2FKofZj8H78q7ynqQd3zAJOvsPjhde2NUL5CLAb/QYve
oQtZs6D2YfIPSB1bvU1jDtQ+TP6EoIN1765OgtqHyWcQezr50o/JUPviMPgf
5jXPvTobqj4Bk//g08/jl1707YfYh8m3sLyQMWPSIgj/AYIPAAZz1/k=
        "]]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       LineBox[{{-0.5, 0.777378442000492}, {0.5, 0.777378442000492}}], 
       LineBox[CompressedData["
1:eJxl01tIE1Acx/Ep0WQugxmWsc2NGqKbrm1qui5bc1tbWtHAzBhJkzIqL4sc
mRWj7AJhDAoWQtAsRvaw2HxQCluIEWJFF6GHIMUhFBIEZSkTu+B+e+h34HD4
wBfO4Q9H6WlzHckUCASev/vfubzmTRrNuubFC59Ny15h/t/u2cGhiW5YTA7Y
hUrnMVhCdgkn9bIWOI/cdDneWdgKrye78250jhTDcrK4xZgYUMNK8vF46IQ2
F95AvtfwakxeA6vI8pW24ve/4EKyzHepa3wSLiIvlSxI1oZgNTlgONkYdcEl
5N7+8HBpep5a8sPpQGwE8/RvIi/8+BBdvAjryJXSiuxqP6wnX8kMzmfhvX4D
2eFLukJpl5HnYtn1bwbgcrK8zl4nisAV5NN3OwZbX8KbyfqlWPS89EvKleTb
RbusagtcRZ6+OmMznIWN5DV3Mhr3nYO3kKfMYz2O5/BWctt+X8MDNbyNLFIk
DuR64O1kjbc35G2GTeSNs8Lwx/6UzWby690K/Uwk5Wfsd6PeYWkc/Q6y9pBj
tC+Jnu2p9B7O+Y3eQp7KsT61HkXPXvXCqCt/hL6a3K3S+YNd6NkjbsP1vUH0
VvInyc2Cg9fQs+dWt9eP70FvI9+PDCW+16JnZ/lUiiYTejs588yt0rIq9OxT
PQWPa0Xod5InxE5LSIae3S7Jf9uXvs9B/hmp+SrPQM/+Fs5PPulI/SezM+0/
atHQKQ==
        "]], LineBox[CompressedData["
1:eJxl0lFIU2EYxvExh4JGQW3SQuu4ZpFdREYSTnBQF2Wam9apYehpaM3GaASu
WCJBaZgQMdnFJHNZbJVihqJkQRLEiVzNEjdQg5nZInAORGJQUNn7dvMcOBx+
8MD/fPDlWS9UNSgVCoX05/37XXuMZcY5y7xT1/2tdM3j6HiG92lP59d/Nh4F
t6aimvRM8jjaURezD+XwvhyciHyoO7ee92jFj4Wrspn3FWC7Wl/i/c57dK7Y
3R6Y5v0xcMNCvXN4lvdovdbTo/rJ+0qw8k7erF0Vpz16eGrCIWeSBRNYHx07
n7GBLKHDwejSQBbZj369f1Ph6EZyDF1f5nszOUP/K5jB1tF1cudu7qGLXkXk
7FXa+9G2HEeoNEmOobuW9z2bN/B5q8BZBnWfZhf30FI4YL4p8nnRD/JFdfVZ
Pi86mNrRm+vhXjU40NHq3eLjHto6dOlgxQ3uoWvDNcV7EovUQ7ecibvakmTh
OFjVUaJfWiFL6EeJewODc2Q/+t21xanmT9xDhywFd13Z3DsBbumyHdiu4x76
4Uj+trQm7qE3RyZMxZe5h955qM3kvsI9EXz6ZaGY6uce2hhyPk8a+L6hXalK
l+c23zd0v1Z3X9nO9/0k+OKvj31vPWQJfUub7h5r5B76veFJcLX2M/XQj2eO
FLgGycIpsHta6k0r/0I9dHOjzSdryH701snre18UkWNov2OkZuUwWbD8929q
MPLi
        "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh1uSS/97uzwxB7MV4jC4B/rX1m12g3KT8Dk
666ec902HMpfgMlfVNoq2xoG5T/A5Ht+Dn5rFwOzLxqDz3PY3TDOF2YfJp/F
XXrXqTiYfZj8Bz+msHC3wezD5Kd1ddmodMHsi8HkM7Dbb2mG2YfJP794Ufvu
6TD7MPnHlttybvgAsw+Tz6Lk9OaD0FOofbEY/NYd28Oarz+E2ofJXxPtun7l
ESh/ASbfbYmO0c4dUP4DTP7DlQdWr2N5BLUvDoMvMGWPaYsYlJ+Ayb+h936y
AfdjqH2Y/DnaN76lL3kAtQ/BBwC9ds+/
        "]]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{2, 2, 0.6, 2}], 
       LineBox[{{-0.5, 0.348968155821946}, {0.5, 0.348968155821946}}], 
       LineBox[CompressedData["
1:eJxl0mtIU3EYx/GxWgaFkaMER9kaYjF2amtuNm3naDU3JDnYhehCNCymwTJM
jCibmSaT0bwU3RmKtIiCwjf2ok52MQtz1mxlbNEodetFFCFChhX+H1/0O/Dn
8IEv/+fAc9TOw6UH5DKZzPn3/HvPPJO8MTjATfUO8TOeK/zveSlnhZ4H5IVg
57IuoaqRnAb2B4N1DW7yUrBoseurtpMzwIa7buFGLMS8HBwue97c3k9Wg0/t
9GV7PpE1YEdQHhC/k7PAlXxK6/wwORuc+jSS1T87bzV4wf6mYf4gWQvWXhi9
VdNC1oFV16/ld46Q14CHG8v5Nvoez1qw6SOnqU2Q9eBfxvS+FUfIBrBJVW17
5GX78KwDu8ZGAx15ZCPYHJUds3wh54C5pt8VfTGyCTz5ZEr8NkY2gyu6J87v
+EnOBf+wm7lBHXk9+DEfUE5/JVvA40FlUXLVa+Y8cHmywdcpvmHOB2tFTWbm
Nuo3gN8qThYb0qm3gs+4FP6CVDIP3ldaWK3zsfsEAezquVjSW88sob2exc/a
vNQXgBMutze0i82T0G71lTK5jVkoBDcP5QYUMpqH5s7V3Q5FaN5G8OdxMRxx
sH1I6BNdu++06JmFTWDvlpWH0mifEnp65KZfvoj978Jm8P1L7aePzmGW0MnK
wIvEvUHW28B7uh3RvceZJXRU+c6qyqC+CFxs/aB3L6EefXWiRtNa/4r1dnA8
52FtPDbAenQofvl9x9aXrHfM+g+XCt4v
        "]], LineBox[CompressedData["
1:eJxl0mFIE3EYx/GRUItCkkaSpF2ByNBIcHthWB2Z1pZpmzM1RS5jZRRblOnM
eqt1kIhJW0axvRGzF2XTxpbVNXJ4uSysRSXNMwVDl6ZhEJFU8vx78zs4jg88
8P0/f25Ltd1sXaFSqYS/77/v8sMb+SPjR6Ma7dDuZUvoG7aJHllD5g+AKzMf
Fk7bZZpHV8WO6W9eIfMF4MT9ewoaTGwePWXr9PzgX9D8QbCo3zqbc4YsoW9/
7HPa1Wy+EGz1vHcPmNg8+rWy19LnZPNF4Nb88sqfpWwendWcOhjJJXOHwNEn
FUkn48kC+qlzlXwnQvfhRo9qM30Tw2QFPZ9sjyY2kTkTOOVesPZUGVlAByJ5
tlcNg9RDR9MNm49/pfMq6Df13nCtl/4XzgzWd+t0UzvIAvpd0YOM52Nh6qGl
3lBHzlWygnbFzSZMJrykXjFY9i6MnvhF8wI6f6yjxBhiPfTngU0Z+yQ6r4Lu
mnFcXuhk+1rAp3uLV6Y3sn3RjtVfFqviyG70kjh3cegS66HFkaB46xzrlYDj
P+Vd89WxHromuKH1QwrbFx3btr3Hb5Goh55ra9sZu07mDoOH+3+vuV//jHro
2PdkQ0vzY+qhHe1pLZN3yQpayvZ3hVVkrhRcs9TYbg6QBbTGY+hWr31EPbRr
5jw/nhqgHvqb9qyxetFPvTKwz2VVj4ToPgT0hTrddJrM9kWv00Z2vc3tpx66
aV60bVxP5+XK//sPyk/4xg==
        "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh2Ybp7xKRXdaQ/mK0Rh8MMcF/0ofLYDwk/A
5HdNLT2xSBHKX4DJVxCcePmU5jYI/wEm/8nUV4c792+F2heNwQ9Zln1pw5ct
UPsw+T7L71jySkLVL8DkNwhGyb8v2AW1D5P/44H2PqcLUPcoxGDwj+zk9Ixm
hfITMPksz/bf8X0P5S/A5P+Y0sbWHAN1zwNMPssm1eCT62D+jcXgP7JKUZHq
3gi1D5N/xs3fsuEplL8Akx/i1RShUbQeah8mX84268ZJnQ1Q++Iw+AHXzh7n
uABVn4DJdwj/sPV2wkKofZj8D2F1M7pcGqH2IfgAS+HLxw==
        "]]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{2, 2, 0.6, 2}], 
       LineBox[{{-0.5, 0.7399445334994541}, {0.5, 0.7399445334994541}}], 
       LineBox[CompressedData["
1:eJxl1F1IU3EYx/HDnLlCoaKt2XQxNO2FMKfLl9l2dJWZ2wLLoFoEMq2B5YWK
ibKEZRNDmRRIZBGS2AvCRggyYa0wydG60S21okz3EpO8GSjuwhLPs4t+Bw6H
D3z5P8//5shqGqpqeQzD1Px7N79bz5q67tsDl10WUm+Zz/7vAs3rYX8WORks
uPc478IO8m6w+Ipj0J5CFoEnzNPK+3HvA39MvJs65wlyloJt6xnOqbhl4G2L
b4qaR8kZYNXZxTL5b/IB8OBI9bK1k/bJBnf09mVlN5APgS/XX5M+zCUfAZuf
jTVGIjTvKPi9e7LdyaM+B2wMDX/vSeLccQx8+JJ3wy8h54LF/cG94j1kOfjt
iHFCryLngf/8rAsYleR8cNQxtlZ7nqwAv/ysWZ/VkY+D7f6Z5ZiJXAAe8DV3
Nr4gF4KvT09JdV5yEdj5wxR2CcKci8Ge5KuxiylkJTiaOm+ZM5BLwO5wQvuT
DzTvBFhn+sX3bpBV4PCCsPgcn85Tg7XpC9FyJWeWBctZV1uLmrMbvd1gs9r0
1JeCMytejQd6qUcrLAcz0/qoLwPP8p7n31rl7uNGr/QEBuo11GvApYklPi1D
89A7Yy2C6l3UnwSnm0JfnwqpRy+J7ggrP3H7sKfAhlZjv8RD+6JnmMnupXHq
T4MjhQpHwij1aG3Vzf2SLurLwb6mpLShR9SjRe8sejOdx54BOytF819uU4+2
anOCN+h/w1bE/RfC8ei1
        "]], LineBox[CompressedData["
1:eJxl0m9IE3Ecx/FrlZB50p9HCa3lipKSoKgHiXhUA52tlmurFdYliiHVYuKj
CnxgMTSOymFmaWeEiYH9ZTEsWT2pMGYLgkGi17ZMrNnWIEetrOz77cnn4Dhe
8IH3/Y5bWeWqqNEJgiD/uf8+Zy/JLGUfSGafzP1YMusA2jQiu8WNH/5ZKgeb
qwIbSm/HaI/udUzXRh+TpZ3gt57K7Z39vEeX6MsUe5L3FnAi5OkInaH3CaBj
/pxe91F+313gvrp0cauL92jbq4jvssL73eC8d2ll1Mt7tF47VF7UQTZYwbHn
M/XJa2QZPbH1TkNPO1lFx4uU5k9dZA1tsz9qsNZxbw9Yf/7LqfkPuIeWLl5y
nzjNPfSoZ4nTf5Z76JZE/YKlw9yrADeVdpvLBriHln9V+r7FuYdeHNw2duE7
99Bz7JvuH189Tj0bWBf3tlnXkWV0e6jaPbGMrKKDV8buve6i/1FDm0znJmtU
smEv+LA4eLflBllGH/OOLPI3k1V08IlxZoXCPbSwOf/NjnCUenawWZdSf0bI
MnqL0dknLuQe+sjBr2stKdpr6KnaoR7fNPcc4PWFxa6hAj4vuv9hpnFNJ/fQ
0VTY93KSz4teJVXfnBfh770PHPKJ19OfuYfOmuvMEgLcQ7sGE4588T310FNt
ucaMg2zYDy4MN/0Yjkaohx7I67a8uEVW0Zkc//KrT8kauqCx9dl4kGxw/vdv
RKEFcQ==
        "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAGIQDQYPIh0OLfBamHHwkT2YrxCFwc9+/z937zEoPwGT
H2S5aSrzeSh/ASZf/XF+Ru9ZKP8BJn/KOmeueRdh9kVj8LXytd5cgrknAZN/
yfd3nPwlmH2YfNWDslmPWB5D7cPkHyxPcKv+B7MvBoP/78L6D8nfYPZh8p+V
lEdZckPNW4DJv14ScowxAmYfJv9ba3S9VgWUrxCLwQ9YajOjrPIB1D5M/orF
lbH2mVD+Aky+adcsBbcIKP8BJv9tVxDrnXlQvkIcBn/xZe2wpHUw+zD5Mx0L
eusrH0Ltw+RHxV7qjsi5B7UPwQcAyC3WFQ==
        "]]}}, {
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[1.5]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{2, 2, 0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{2, 2, 0.6, 2}]}}, {
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[1.5]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{2, 2, 0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{
        2, 2, 0.6, 
         2}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}}, {
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[1.5]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{2, 2, 0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.004583333333333334], AbsoluteThickness[0.8], 
       AbsoluteDashing[{
        2, 2, 0.6, 
         2}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}}}, {{}, {}}}, {{}, {{{}, {}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       1.5], LineBox[{{16.5, 0.4913233494032}, {16.5, 0.4900202991654}, {17.5,
         0.4900202991654}, {17.5, 0.4890538411644}}], 
       LineBox[{{23.5, 0.5057343443158}, {23.5, 0.5021456384647}, {24.5, 
        0.5021456384647}, {24.5, 0.5061160827953}}], 
       LineBox[{{31.5, 0.5241355915517}, {31.5, 0.5153157047558}, {32.5, 
        0.5153157047558}, {32.5, 0.510617792648}, {33.5, 0.510617792648}, {
        33.5, 0.5246492424962}}], 
       LineBox[{{35.5, 0.5349307068445}, {35.5, 0.5151222752566}, {36.5, 
        0.5151222752566}, {36.5, 0.5076297775378}, {37.5, 0.5076297775378}, {
        37.5, 0.4945776451298}, {38.5, 0.4945776451298}, {38.5, 
        0.4929791794736}, {39.5, 0.4929791794736}, {39.5, 0.4907446178952}, {
        40.5, 0.4907446178952}, {40.5, 0.4939576256322}, {41.5, 
        0.4939576256322}, {41.5, 0.4721077703455}, {42.5, 0.4721077703455}, {
        42.5, 0.4968161216776}}], 
       LineBox[{{44.5, 0.4946668124107}, {44.5, 0.4911944178924}, {45.5, 
        0.4911944178924}, {45.5, 0.4859062387127}, {46.5, 0.4859062387127}}], 
       LineBox[{{47.5, 0.4901734967653}, {47.5, 0.4779417630367}, {48.5, 
        0.4779417630367}, {48.5, 0.4567355202808}, {49.5, 0.4567355202808}, {
        49.5, 0.464863207737}}], 
       LineBox[{{49.5, 0.464863207737}, {50.5, 0.464863207737}, {49.5, 
        0.464863207737}, {50.5, 0.464863207737}}], 
       LineBox[{{60.5, 0.4361912142274}, {60.5, 0.4362172051235}, {61.5, 
        0.4362172051235}, {61.5, 0.4375460358412}, {62.5, 0.4375460358412}, {
        62.5, 0.4401161429093}}], 
       LineBox[{{85.5, 0.4180096441577}, {85.5, 0.3760103313598}, {86.5, 
        0.3760103313598}}], 
       LineBox[{{87.5, 0.3755177457284}, {87.5, 0.3742729979572}, {88.5, 
        0.3742729979572}, {88.5, 0.3767453513734}, {89.5, 0.3767453513734}, {
        89.5, 0.3797667716879}}], 
       LineBox[{{99.5, 0.3467583510969}, {100.5, 0.3467583510969}, {99.5, 
        0.3467583510969}, {100.5, 0.3467583510969}, {99.5, 0.3467583510969}, {
        100.5, 0.3467583510969}}], 
       LineBox[{{105.5, 0.3420132818436}, {105.5, 0.3377337011246}, {106.5, 
        0.3377337011246}, {106.5, 0.33708352119}}], 
       LineBox[{{109.5, 0.3340094149749}, {109.5, 0.3339935602594}, {110.5, 
        0.3339935602594}, {110.5, 0.3346004824318}, {111.5, 
        0.3346004824318}, {111.5, 0.3413399738709}}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{0.6, 2}], 
       LineBox[{{16.5, 0.16788706978171597`}, {16.5, 0.162068150101721}, {
        17.5, 0.162068150101721}, {17.5, 0.16023481678040002`}}], 
       LineBox[{{23.5, 0.18569125847257395`}, {23.5, 0.16621876112029893`}, {
        24.5, 0.16621876112029893`}, {24.5, 0.1694415570642519}}], 
       LineBox[{{31.5, 0.20347310492459497`}, {31.5, 0.19255730556751194`}, {
        32.5, 0.19255730556751194`}, {32.5, 0.18288843160649804`}, {33.5, 
        0.18288843160649804`}, {33.5, 0.19187544290758002`}}], 
       LineBox[{{35.5, 0.20559643504599795`}, {35.5, 0.18478181716027403`}, {
        36.5, 0.18478181716027403`}, {36.5, 0.17756082759589098`}, {37.5, 
        0.17756082759589098`}, {37.5, 0.16176714943335502`}, {38.5, 
        0.16176714943335502`}, {38.5, 0.15740247232270999`}, {39.5, 
        0.15740247232270999`}, {39.5, 0.14601370444496103`}, {40.5, 
        0.14601370444496103`}, {40.5, 0.14707694497625906`}, {41.5, 
        0.14707694497625906`}, {41.5, 0.11991877873331097`}, {42.5, 
        0.11991877873331097`}, {42.5, 0.14752116445216396`}}], 
       LineBox[{{44.5, 0.14478535333104398`}, {44.5, 0.14287521173653694`}, {
        45.5, 0.14287521173653694`}, {45.5, 0.13693487628420703`}, {46.5, 
        0.13693487628420703`}}], 
       LineBox[{{47.5, 0.13984915638181994`}, {47.5, 0.125805376574053}, {
        48.5, 0.125805376574053}, {48.5, 0.10068106042939201`}, {49.5, 
        0.10068106042939201`}, {49.5, 0.10881465347819502`}}], 
       LineBox[{{49.5, 0.10881465347819502`}, {50.5, 0.10881465347819502`}, {
        49.5, 0.10881465347819502`}, {50.5, 0.10881465347819502`}}], 
       LineBox[{{60.5, 0.10643775781969}, {60.5, 0.10577702668038097`}, {61.5,
         0.10577702668038097`}, {61.5, 0.10773586401319701`}, {62.5, 
        0.10773586401319701`}, {62.5, 0.10824144207896202`}}], 
       LineBox[{{85.5, 0.12984149612181195`}, {85.5, 0.025888145598451984`}, {
        86.5, 0.025888145598451984`}}], 
       LineBox[{{87.5, 0.024343356823259055`}, {87.5, 0.023048578613796}, {
        88.5, 0.023048578613796}, {88.5, 0.025497406593175953`}, {89.5, 
        0.025497406593175953`}, {89.5, 0.005242848906872988}}], 
       LineBox[{{99.5, 0.00540532251058401}, {100.5, 0.00540532251058401}, {
        99.5, 0.00540532251058401}, {100.5, 0.00540532251058401}, {99.5, 
        0.00540532251058401}, {100.5, 0.00540532251058401}}], 
       LineBox[{{105.5, -0.004649595632007009}, {
        105.5, -0.016421430528431036`}, {106.5, -0.016421430528431036`}, {
        106.5, -0.01773981556228299}}], 
       LineBox[{{109.5, -0.023140252690035}, {
        109.5, -0.024234691464524005`}, {110.5, -0.024234691464524005`}, {
        110.5, -0.02575274751295703}, {111.5, -0.02575274751295703}, {
        111.5, -0.015914418480810044`}}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{0.6, 2}], 
       LineBox[{{16.5, 0.814759629024684}, {16.5, 0.817485667268796}, {17.5, 
        0.817485667268796}, {17.5, 0.8178728655484}}], 
       LineBox[{{23.5, 0.825777430159026}, {23.5, 0.8270890118849579}, {24.5, 
        0.8270890118849579}, {24.5, 0.842790608526348}}], 
       LineBox[{{31.5, 0.8447980781788049}, {31.5, 0.835248253944873}, {32.5, 
        0.835248253944873}, {32.5, 0.838347153689502}, {33.5, 
        0.838347153689502}, {33.5, 0.8574230420848201}}], 
       LineBox[{{35.5, 0.8642649786430019}, {35.5, 0.8454627333529261}, {36.5,
         0.8454627333529261}, {36.5, 0.8376987274797091}, {37.5, 
        0.8376987274797091}, {37.5, 0.827388140826245}, {38.5, 
        0.827388140826245}, {38.5, 0.82855588662449}, {39.5, 
        0.82855588662449}, {39.5, 0.835475531345439}, {40.5, 
        0.835475531345439}, {40.5, 0.840838306288141}, {41.5, 
        0.840838306288141}, {41.5, 0.8242967619576891}, {42.5, 
        0.8242967619576891}, {42.5, 0.8461110789030359}}], 
       LineBox[{{44.5, 0.844548271490356}, {44.5, 0.839387597480432}, {45.5, 
        0.839387597480432}, {45.5, 0.8348776011411929}, {46.5, 
        0.8348776011411929}}], 
       LineBox[{{47.5, 0.84049783714878}, {47.5, 0.830078149499347}, {48.5, 
        0.830078149499347}, {48.5, 0.811685192358621}, {49.5, 
        0.811685192358621}, {49.5, 0.8209117619958051}}], 
       LineBox[{{49.5, 0.8209117619958051}, {50.5, 0.8209117619958051}, {49.5,
         0.8209117619958051}, {50.5, 0.8209117619958051}}], 
       LineBox[{{60.5, 0.76594467063511}, {60.5, 0.766529872191066}, {61.5, 
        0.766529872191066}, {61.5, 0.767356207669203}, {62.5, 
        0.767356207669203}, {62.5, 0.771990843739638}}], 
       LineBox[{{85.5, 0.706177792193588}, {85.5, 0.711018168443222}, {86.5, 
        0.711018168443222}}], 
       LineBox[{{87.5, 0.726692134633541}, {87.5, 0.7254974173006039}, {88.5, 
        0.7254974173006039}, {88.5, 0.727993296153624}, {89.5, 
        0.727993296153624}, {89.5, 0.754290694468927}}], 
       LineBox[{{99.5, 0.688111379683216}, {100.5, 0.688111379683216}, {99.5, 
        0.688111379683216}, {100.5, 0.688111379683216}, {99.5, 
        0.688111379683216}, {100.5, 0.688111379683216}}], 
       LineBox[{{105.5, 0.688676159319207}, {105.5, 0.686870215741202}, {
        106.5, 0.686870215741202}, {106.5, 0.691906857942283}}], 
       LineBox[{{109.5, 0.691159082639835}, {109.5, 0.6922218119833241}, {
        110.5, 0.6922218119833241}, {110.5, 0.694953712376557}, {111.5, 
        0.694953712376557}, {111.5, 0.69859436622261}}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], LineBox[{{16.5, 0.219248195730192}, {16.5, 0.214146388365052}, {
        17.5, 0.214146388365052}, {17.5, 0.21245071335640003`}}], 
       LineBox[{{23.5, 0.236513551074288}, {23.5, 0.21956337254408798`}, {
        24.5, 0.21956337254408798`}, {24.5, 0.22290489376832395`}}], 
       LineBox[{{31.5, 0.25439375730743996`}, {31.5, 0.24511863566554398`}, {
        32.5, 0.24511863566554398`}, {32.5, 0.23493129151437603`}, {33.5, 
        0.23493129151437603`}, {33.5, 0.24471935099676}}], 
       LineBox[{{35.5, 0.25789415202687593`}, {35.5, 0.23723931479788807`}, {
        36.5, 0.23723931479788807`}, {36.5, 0.22997521020469203`}, {37.5, 
        0.22997521020469203`}, {37.5, 0.21461688480146002`}, {38.5, 
        0.21461688480146002`}, {38.5, 0.21069147732091997`}, {39.5, 
        0.21069147732091997`}, {39.5, 0.20075638168813204`}, {40.5, 
        0.20075638168813204`}, {40.5, 0.20216100156110806`}, {41.5, 
        0.20216100156110806`}, {41.5, 0.17584578598503203`}, {42.5, 
        0.17584578598503203`}, {42.5, 0.20298860401156799`}}], 
       LineBox[{{44.5, 0.200345928378028}, {44.5, 0.198293717466416}, {45.5, 
        0.198293717466416}, {45.5, 0.19235092954538402`}, {46.5, 
        0.19235092954538402`}}], 
       LineBox[{{47.5, 0.19548006021953995`}, {47.5, 0.181724030218336}, {
        48.5, 0.181724030218336}, {48.5, 0.15722189740150405`}, {49.5, 
        0.15722189740150405`}, {49.5, 0.16535455265234}}], 
       LineBox[{{49.5, 0.16535455265234}, {50.5, 0.16535455265234}, {49.5, 
        0.16535455265234}, {50.5, 0.16535455265234}}], 
       LineBox[{{60.5, 0.15880204059687997`}, {60.5, 0.158250359737872}, {
        61.5, 0.158250359737872}, {61.5, 0.160109153101764}, {62.5, 
        0.160109153101764}, {62.5, 0.160942574828844}}], 
       LineBox[{{85.5, 0.175602103320644}, {85.5, 0.08148694762922398}, {86.5,
         0.08148694762922398}}], 
       LineBox[{{87.5, 0.08010924690690807}, {87.5, 0.078822413445152}, {88.5,
         0.078822413445152}, {88.5, 0.08127497722351196}, {89.5, 
        0.08127497722351196}, {89.5, 0.06471660488497599}}], 
       LineBox[{{99.5, 0.059611597436308006`}, {100.5, 
        0.059611597436308006`}, {99.5, 0.059611597436308006`}, {100.5, 
        0.059611597436308006`}, {99.5, 0.059611597436308006`}, {100.5, 
        0.059611597436308006`}}], 
       LineBox[{{105.5, 0.05039987418171604}, {105.5, 0.03981779638642802}, {
        106.5, 0.03981779638642802}, {106.5, 0.03860552117520405}}], 
       LineBox[{{109.5, 0.033574501402680035`}, {109.5, 
        0.032651339925112044`}, {110.5, 0.032651339925112044`}, {110.5, 
        0.03147072677011603}, {111.5, 0.03147072677011603}, {111.5, 
        0.04081696571237997}}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], LineBox[{{16.5, 0.763398503076208}, {16.5, 0.765894209965748}, {
        17.5, 0.765894209965748}, {17.5, 0.7656569689724}}], 
       LineBox[{{23.5, 0.774955137557312}, {23.5, 0.7762151018632959}, {24.5, 
        0.7762151018632959}, {24.5, 0.7893272718222759}}], 
       LineBox[{{31.5, 0.79387742579596}, {31.5, 0.784443514374076}, {32.5, 
        0.784443514374076}, {32.5, 0.786304293781624}, {33.5, 
        0.786304293781624}, {33.5, 0.8045791339956401}}], 
       LineBox[{{35.5, 0.811967261662124}, {35.5, 0.793005235715312}, {36.5, 
        0.793005235715312}, {36.5, 0.785284344870908}, {37.5, 
        0.785284344870908}, {37.5, 0.77453840545814}, {38.5, 
        0.77453840545814}, {38.5, 0.77526688162628}, {39.5, 
        0.77526688162628}, {39.5, 0.780732854102268}, {40.5, 
        0.780732854102268}, {40.5, 0.785754249703292}, {41.5, 
        0.785754249703292}, {41.5, 0.768369754705968}, {42.5, 
        0.768369754705968}, {42.5, 0.790643639343632}}], 
       LineBox[{{44.5, 0.788987696443372}, {44.5, 0.784095118318384}, {45.5, 
        0.784095118318384}, {45.5, 0.779461547880016}, {46.5, 
        0.779461547880016}}], 
       LineBox[{{47.5, 0.78486693331106}, {47.5, 0.7741594958550639}, {48.5, 
        0.7741594958550639}, {48.5, 0.755751284821352}, {49.5, 
        0.755751284821352}, {49.5, 0.76437186282166}}], 
       LineBox[{{49.5, 0.76437186282166}, {50.5, 0.76437186282166}, {49.5, 
        0.76437186282166}, {50.5, 0.76437186282166}}], 
       LineBox[{{60.5, 0.71358038785792}, {60.5, 0.7141840505091279}, {61.5, 
        0.7141840505091279}, {61.5, 0.714982918580636}, {62.5, 
        0.714982918580636}, {62.5, 0.719289710989756}}], 
       LineBox[{{85.5, 0.660417184994756}, {85.5, 0.665284613457764}, {86.5, 
        0.665284613457764}}], 
       LineBox[{{87.5, 0.670926244549892}, {87.5, 0.669723582469248}, {88.5, 
        0.669723582469248}, {88.5, 0.672215725523288}, {89.5, 
        0.672215725523288}, {89.5, 0.694816938490824}}], 
       LineBox[{{99.5, 0.633905104757492}, {100.5, 0.633905104757492}, {99.5, 
        0.633905104757492}, {100.5, 0.633905104757492}, {99.5, 
        0.633905104757492}, {100.5, 0.633905104757492}}], 
       LineBox[{{105.5, 0.6336266895054841}, {105.5, 0.6317093151026241}, {
        106.5, 0.6317093151026241}, {106.5, 0.635561521204796}}], 
       LineBox[{{109.5, 0.63444432854712}, {109.5, 0.635335780593688}, {110.5,
         0.635335780593688}, {110.5, 0.637730238093484}, {111.5, 
        0.637730238093484}, {111.5, 0.6418629820294199}}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{2, 2, 0.6, 2}], 
       LineBox[{{16.5, 0.262974559713354}, {16.5, 0.2584832668865365}, {17.5, 
        0.2584832668865365}, {17.5, 0.2569047874684}}], 
       LineBox[{{23.5, 0.279781178559531}, {23.5, 0.26497837956704345`}, {
        24.5, 0.26497837956704345`}, {24.5, 0.2684209777190879}}], 
       LineBox[{{31.5, 0.2977451235252675}, {31.5, 0.2894405788261755}, {32.5,
         0.2894405788261755}, {32.5, 0.279238050625137}, {33.5, 
        0.279238050625137}, {33.5, 0.28970808355917}}], 
       LineBox[{{35.5, 0.30241788405113695`}, {35.5, 0.2818990763001811}, {
        36.5, 0.2818990763001811}, {36.5, 0.2745982656689415}, {37.5, 
        0.2745982656689415}, {37.5, 0.2596105784256575}, {38.5, 
        0.2596105784256575}, {38.5, 0.25605914373831495`}, {39.5, 
        0.25605914373831495`}, {39.5, 0.24736163393569652`}, {40.5, 
        0.24736163393569652`}, {40.5, 0.24905688757253355`}, {41.5, 
        0.24905688757253355`}, {41.5, 0.22345931918582151`}, {42.5, 
        0.22345931918582151`}, {42.5, 0.25021088363646593`}}], 
       LineBox[{{44.5, 0.24764749902613598`}, {44.5, 0.24536704432059198`}, {
        45.5, 0.24536704432059198`}, {45.5, 0.23952946137584552`}, {46.5, 
        0.23952946137584552`}}], 
       LineBox[{{47.5, 0.24284150537867996`}, {47.5, 0.22933045156414447`}, {
        48.5, 0.22933045156414447`}, {48.5, 0.20535801536424803`}, {49.5, 
        0.20535801536424803`}, {49.5, 0.21348987221951754`}}], 
       LineBox[{{49.5, 0.21348987221951754`}, {50.5, 0.21348987221951754`}, {
        49.5, 0.21348987221951754`}, {50.5, 0.21348987221951754`}}], 
       LineBox[{{60.5, 0.20338244350178497`}, {60.5, 0.2029236027462765}, {
        61.5, 0.2029236027462765}, {61.5, 0.2046972235420305}, {62.5, 
        0.2046972235420305}, {62.5, 0.205809755413203}}], 
       LineBox[{{85.5, 0.21456045809802798`}, {85.5, 0.128821062871638}, {
        86.5, 0.128821062871638}}], 
       LineBox[{{87.5, 0.12758561278893354`}, {87.5, 0.12630554309887398`}, {
        88.5, 0.12630554309887398`}, {88.5, 0.12876128735474396`}, {89.5, 
        0.12876128735474396`}, {89.5, 0.11534966740687452`}}], 
       LineBox[{{99.5, 0.10576018284604602`}, {100.5, 0.10576018284604602`}, {
        99.5, 0.10576018284604602`}, {100.5, 0.10576018284604602`}, {99.5, 
        0.10576018284604602`}, {100.5, 0.10576018284604602`}}], 
       LineBox[{{105.5, 0.0972663146988045}, {105.5, 0.08769713821934849}, {
        106.5, 0.08769713821934849}, {106.5, 0.08657519974901051}}], 
       LineBox[{{109.5, 0.08185868394107249}, {109.5, 0.081081339621694}, {
        110.5, 0.081081339621694}, {110.5, 0.08018800893002953}, {111.5, 
        0.08018800893002953}, {111.5, 0.08911530630928499}}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{2, 2, 0.6, 2}], 
       LineBox[{{16.5, 0.7196721390930461}, {16.5, 0.7215573314442636}, {17.5,
         0.7215573314442636}, {17.5, 0.7212028948603999}}], 
       LineBox[{{23.5, 0.731687510072069}, {23.5, 0.7329035298178269}, {24.5, 
        0.7329035298178269}, {24.5, 0.743811187871512}}], 
       LineBox[{{31.5, 0.7505260595781325}, {31.5, 0.7411908306854245}, {32.5,
         0.7411908306854245}, {32.5, 0.7419975346708629}, {33.5, 
        0.7419975346708629}, {33.5, 0.7595904014332301}}], 
       LineBox[{{35.5, 0.767443529637863}, {35.5, 0.748345474213019}, {36.5, 
        0.748345474213019}, {36.5, 0.7406612894066585}, {37.5, 
        0.7406612894066585}, {37.5, 0.7295447118339425}, {38.5, 
        0.7295447118339425}, {38.5, 0.729899215208885}, {39.5, 
        0.729899215208885}, {39.5, 0.7341276018547035}, {40.5, 
        0.7341276018547035}, {40.5, 0.7388583636918665}, {41.5, 
        0.7388583636918665}, {41.5, 0.7207562215051785}, {42.5, 
        0.7207562215051785}, {42.5, 0.743421359718734}}], 
       LineBox[{{44.5, 0.741686125795264}, {44.5, 0.737021791464208}, {45.5, 
        0.737021791464208}, {45.5, 0.7322830160495545}, {46.5, 
        0.7322830160495545}}], 
       LineBox[{{47.5, 0.73750548815192}, {47.5, 0.7265530745092555}, {48.5, 
        0.7265530745092555}, {48.5, 0.708113025197352}, {49.5, 
        0.708113025197352}, {49.5, 0.7162365432544825}}], 
       LineBox[{{49.5, 0.7162365432544825}, {50.5, 0.7162365432544825}, {49.5,
         0.7162365432544825}, {50.5, 0.7162365432544825}}], 
       LineBox[{{60.5, 0.668999984953015}, {60.5, 0.6695108075007234}, {61.5, 
        0.6695108075007234}, {61.5, 0.6703948481403695}, {62.5, 
        0.6703948481403695}, {62.5, 0.674422530405397}}], 
       LineBox[{{85.5, 0.621458830217372}, {85.5, 0.623199599847962}, {86.5, 
        0.623199599847962}}], 
       LineBox[{{87.5, 0.6234498786678665}, {87.5, 0.622240452815526}, {88.5, 
        0.622240452815526}, {88.5, 0.624729415392056}, {89.5, 
        0.624729415392056}, {89.5, 0.6441838759689256}}], 
       LineBox[{{99.5, 0.587756519347754}, {100.5, 0.587756519347754}, {99.5, 
        0.587756519347754}, {100.5, 0.587756519347754}, {99.5, 
        0.587756519347754}, {100.5, 0.587756519347754}}], 
       LineBox[{{105.5, 0.5867602489883955}, {105.5, 0.584748007802213}, {
        106.5, 0.584748007802213}, {106.5, 0.5875918426309895}}], 
       LineBox[{{109.5, 0.5861601460087276}, {109.5, 0.5869057808971061}, {
        110.5, 0.5869057808971061}, {110.5, 0.5890129559335705}, {111.5, 
        0.5890129559335705}, {111.5, 0.593564641432515}}]}}, {
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       1.5]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{2, 2, 0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{2, 2, 0.6, 2}]}}, {
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       1.5]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{2, 2, 0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{
        2, 2, 0.6, 
         2}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}}, {
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       1.5]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{2, 2, 0.6, 2}]}, 
      {GrayLevel[0], PointSize[0.0055000000000000005`], AbsoluteThickness[
       0.8], AbsoluteDashing[{
        2, 2, 0.6, 
         2}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}}}, {{}, {}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  AxesStyle->{{
     AbsoluteThickness[0.8]}, {
     AbsoluteThickness[0.8]}},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  LabelStyle->{FontFamily -> "Cmr10", FontSize -> 12},
  Method->{
   "OptimizePlotMarkers" -> True, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{-0.5, 123.5}, {-0.088786725066754, 0.864855688298265}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.782407656863139*^9, {3.7824077028720636`*^9, 3.7824077098992653`*^9}, {
   3.7824077453155527`*^9, 3.782407843500877*^9}, 3.78240787539855*^9, {
   3.782408069793538*^9, 3.7824080802754993`*^9}, {3.7824081364372644`*^9, 
   3.782408161831334*^9}, 3.782408240891882*^9, {3.782408300923259*^9, 
   3.7824083199324107`*^9}, 3.782408523950655*^9, 3.7824103706486845`*^9},
 CellLabel->
  "Out[782]=",ExpressionUUID->"7f2be36e-4830-4871-9fb7-e72184320630"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<c:/dropbox/mystuff/sparsity/revision/Lasso.pdf\>\"", ",", "p"}], 
  "]"}]], "Input",
 CellLabel->
  "In[783]:=",ExpressionUUID->"3113609e-3425-4b42-a354-360c8548a4d7"],

Cell[BoxData["\<\"c:/dropbox/mystuff/sparsity/revision/Lasso.pdf\"\>"], \
"Output",
 CellChangeTimes->{3.78240832473955*^9, 3.7824103813051777`*^9},
 CellLabel->
  "Out[783]=",ExpressionUUID->"99c7da3d-0c8d-4122-b388-f68d40a9d599"]
}, Open  ]]
},
WindowSize->{1898, 954},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 814, 20, 73, "Input",ExpressionUUID->"3d4ac21e-7a3a-48f4-9649-5da9cf0516ed"],
Cell[1375, 42, 3935, 114, 218, "Input",ExpressionUUID->"9edc577c-7c94-401f-853c-b9d64fbbb3b7"],
Cell[CellGroupData[{
Cell[5335, 160, 244, 4, 43, "Input",ExpressionUUID->"a043ac67-3015-4b9f-bc44-090fa1b49c07"],
Cell[5582, 166, 377, 8, 34, "Print",ExpressionUUID->"18548309-c5de-4571-ae65-15cf6b08f666"],
Cell[5962, 176, 416, 6, 49, "Output",ExpressionUUID->"7e281518-edc0-44fb-bb1e-3e85b0b3fed5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6415, 187, 1711, 52, 102, "Input",ExpressionUUID->"325567e3-c8e7-4dc2-bc13-8d12ca1d2914"],
Cell[8129, 241, 5740, 158, 240, "Output",ExpressionUUID->"80a93319-563b-46d7-a76d-6ccf08771903"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13906, 404, 1616, 40, 43, "Input",ExpressionUUID->"d99009ef-d922-4ab5-a9d9-5c8e018b5621"],
Cell[15525, 446, 11598, 301, 489, "Output",ExpressionUUID->"5092f30a-c9ee-48d9-a492-09c047c6d06d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27160, 752, 4376, 119, 187, "Input",ExpressionUUID->"32468bd9-1d52-4e63-907d-117dde05c155"],
Cell[31539, 873, 4665, 125, 185, "Output",ExpressionUUID->"1e7b2ddd-2390-470b-8e9e-03839bceba9c"]
}, Open  ]],
Cell[36219, 1001, 512, 11, 73, "Input",ExpressionUUID->"745ceb9c-b6b4-4718-aace-016ad6ad4832"],
Cell[36734, 1014, 690, 14, 73, "Input",ExpressionUUID->"2d68e2c8-fb95-4903-9bde-9c3100eeb4c0"],
Cell[37427, 1030, 636, 13, 43, "Input",ExpressionUUID->"d1e25160-3ac7-4e6e-acca-6c7cca25c18b"],
Cell[CellGroupData[{
Cell[38088, 1047, 177, 2, 43, "Input",ExpressionUUID->"268b46ae-c5cb-4662-b0d4-9b273e8ba1db"],
Cell[38268, 1051, 173, 2, 49, "Output",ExpressionUUID->"c6bf5b44-4f59-4e67-94a8-0f2eb768110c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38478, 1058, 5662, 133, 682, "Input",ExpressionUUID->"bd89a553-9c87-42d4-8ef5-027f3d36348e"],
Cell[44143, 1193, 3807, 75, 152, "Output",ExpressionUUID->"c3d33049-202c-4640-a648-2ce8044daab3"],
Cell[47953, 1270, 1980, 28, 49, "Output",ExpressionUUID->"902a7181-7c29-40dd-a635-b8fade1d4769"],
Cell[49936, 1300, 1963, 27, 49, "Output",ExpressionUUID->"fde1b8d8-79b6-479d-afd0-6bf2ae4564da"],
Cell[51902, 1329, 1962, 27, 49, "Output",ExpressionUUID->"94513750-5b8d-4e31-8135-765676c94f57"],
Cell[53867, 1358, 1982, 28, 49, "Output",ExpressionUUID->"306f2c92-d7c7-4b60-967f-51e1fc990595"],
Cell[55852, 1388, 1965, 27, 49, "Output",ExpressionUUID->"6e1ccbad-112d-4869-9f25-5916942c5317"],
Cell[57820, 1417, 1996, 28, 49, "Output",ExpressionUUID->"0f0cc9c7-1936-478f-850c-9aceb841142e"],
Cell[59819, 1447, 1990, 28, 49, "Output",ExpressionUUID->"2f5421b3-5656-4c11-80fe-5280790ebe4e"],
Cell[61812, 1477, 1972, 27, 49, "Output",ExpressionUUID->"993da9a5-a51c-492c-9462-8b781763db7b"],
Cell[63787, 1506, 1995, 28, 49, "Output",ExpressionUUID->"9bdd624c-c8c9-46ed-85cf-fb3afcfe8d0b"],
Cell[65785, 1536, 2065, 31, 49, "Output",ExpressionUUID->"814b16ac-1cc6-4904-a0a9-b8f8707b97fc"],
Cell[67853, 1569, 1974, 27, 49, "Output",ExpressionUUID->"3bda289b-9058-4119-ab9d-180b14514806"],
Cell[69830, 1598, 1988, 28, 49, "Output",ExpressionUUID->"be3a3ccb-bf25-4d70-ac50-bd8701468353"],
Cell[71821, 1628, 1952, 27, 49, "Output",ExpressionUUID->"393bed63-a279-4905-a0ad-383b0688c119"],
Cell[73776, 1657, 2169, 34, 49, "Output",ExpressionUUID->"90399d78-fb33-49d1-90af-7025bbd21741"],
Cell[75948, 1693, 2153, 32, 49, "Output",ExpressionUUID->"c6d6f665-2b60-4cbc-849e-30650d3f7daf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78138, 1730, 12713, 286, 537, "Input",ExpressionUUID->"65f8f8be-4de0-4a0d-94a4-e22b83d33f79"],
Cell[90854, 2018, 18658, 343, 112, "Output",ExpressionUUID->"07114913-061a-406a-b686-edacaafa4912"],
Cell[109515, 2363, 4380, 59, 49, "Output",ExpressionUUID->"cc00b8bd-d7ab-4f26-8191-d682cb006afe"],
Cell[113898, 2424, 16111, 274, 353, "Output",ExpressionUUID->"f3608ea9-185e-4bb9-a093-422af2cfaa56"]
}, Open  ]],
Cell[CellGroupData[{
Cell[130046, 2703, 446, 9, 43, "Input",ExpressionUUID->"009a8c7f-c845-4cbe-aeee-b0876a556136"],
Cell[130495, 2714, 283, 5, 49, "Output",ExpressionUUID->"babbd020-e8e4-4ca8-820a-e8b4a0fadd9a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[130815, 2724, 15422, 427, 1146, "Input",ExpressionUUID->"65b498f2-369b-451c-89e6-d2dd05ab5e69"],
Cell[146240, 3153, 681, 13, 49, "Output",ExpressionUUID->"eddbde4b-7f08-4ba8-995c-85cb7134c009"],
Cell[146924, 3168, 501, 8, 49, "Output",ExpressionUUID->"c8205f10-d389-4c61-a1ac-97d059248fc8"],
Cell[147428, 3178, 19201, 354, 352, "Output",ExpressionUUID->"bc10346d-2f3f-4410-8ac4-76f032a0bd65"],
Cell[166632, 3534, 501, 8, 49, "Output",ExpressionUUID->"e3c42641-0979-4750-9d3a-788554e4f79e"],
Cell[167136, 3544, 3703, 106, 137, "Output",ExpressionUUID->"90ef2398-463e-48ac-a202-31e46009d0f2"],
Cell[170842, 3652, 22915, 378, 350, "Output",ExpressionUUID->"4f180874-b83d-4dc0-b29d-20f4e4a9aa5d"],
Cell[193760, 4032, 40935, 690, 352, "Output",ExpressionUUID->"7f2be36e-4830-4871-9fb7-e72184320630"]
}, Open  ]],
Cell[CellGroupData[{
Cell[234732, 4727, 224, 6, 43, "Input",ExpressionUUID->"3113609e-3425-4b42-a354-360c8548a4d7"],
Cell[234959, 4735, 231, 4, 49, "Output",ExpressionUUID->"99c7da3d-0c8d-4122-b388-f68d40a9d599"]
}, Open  ]]
}
]
*)

