(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     76875,       1441]
NotebookOptionsPosition[     75163,       1410]
NotebookOutlinePosition[     75509,       1425]
CellTagsIndexPosition[     75466,       1422]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"lvs", "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "5", ",", "10"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"adj", "=", 
    RowBox[{"{", 
     RowBox[{"0.025", ",", "0.008", ",", "0.007"}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xgrid", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.0001", ",", "2", ",", "5", ",", "8", ",", "12", ",", "25", ",", 
       "50"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"outtab", "=", 
     RowBox[{"{", "xgrid", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"cvtab", "=", 
       RowBox[{"Import", "[", 
        RowBox[{
         RowBox[{"\"\<c:/dropbox/mystuff/sparsity/revision/cvmat_\>\"", "<>", 
          RowBox[{"ToString", "[", 
           RowBox[{"lvs", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "]"}], "<>", "\"\<.txt\>\""}], 
         ",", "\"\<Table\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"f", "=", 
       RowBox[{"ListInterpolation", "[", 
        RowBox[{"cvtab", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0.025", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0.025", ",", "1"}], "}"}]}], "}"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"g", "=", 
       RowBox[{"f", "[", 
        RowBox[{
         RowBox[{"0.5", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"0.5", 
             RowBox[{
              RowBox[{"Log", "[", 
               RowBox[{
                RowBox[{"kg", "^", "2"}], "+", 
                RowBox[{"wb", "^", "2"}]}], "]"}], "/", 
              RowBox[{"Log", "[", "200.0", "]"}]}]}], "+", "1"}], ")"}]}], 
         ",", 
         RowBox[{"2", " ", 
          RowBox[{
           RowBox[{"ArcTan", "[", 
            RowBox[{"kg", "/", "wb"}], "]"}], "/", "Pi"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"g", "=", 
       RowBox[{
        RowBox[{"g", "/.", 
         RowBox[{"wb", " ", "\[Rule]", "x"}]}], "/.", 
        RowBox[{"kg", "\[Rule]", "100"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{
        RowBox[{"adj", "[", 
         RowBox[{"[", "j", "]"}], "]"}], "+", 
        RowBox[{"(", 
         RowBox[{"g", "/.", 
          RowBox[{"x", "\[Rule]", "xgrid"}]}], ")"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"outtab", ",", 
        RowBox[{
         RowBox[{"adj", "[", 
          RowBox[{"[", "j", "]"}], "]"}], "+", 
         RowBox[{"(", 
          RowBox[{"g", "/.", 
           RowBox[{"x", "\[Rule]", "xgrid"}]}], ")"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", "outtab", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"gx", "=", 
       RowBox[{"ListInterpolation", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"adj", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "+", "g"}], "/.", 
          RowBox[{"x", "\[Rule]", "xgrid"}]}], ",", "xgrid", ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"g", "-", 
           RowBox[{"gx", "[", "x", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", "30"}], "}"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"Max", "[", "cvtab", "]"}], "]"}], ";"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"outtab", "//", "MatrixForm"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBWIQ/Wh3oxp/8hvHby8qtEC07N8pxiA6cL+uGYjms99n
D6KDpf65g2jt/Gc+INpA4X0AiFaRy4oA0c9dRSNB9PnlcUkgmmFBMph2ri3M
AdF7vn3JBdE2N0uLQLSyXGANiG7Nj/grDKSZJt/jFgHSsw+rCIHortOxwiB6
QekrSRAdlX9JBkSLFMUpgWiBRB8LEC2WtccZRCcpOPqD6JiOn2EgesYatnAQ
nfx0UTyI5mJTywLRE1jn+ooC6TCGvWDaSPNJIIj23ySZAqKjgmoyQPT3BRF5
IHrHLfNiEN3rPxdMC1jnl4NorqyEZhB9S+dQO4iuyhbqANEA96mNWA==
  "],ExpressionUUID->"c2fc1edf-838b-4c3a-9e89-428f3afb5b23"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.025`", ",", "0.008`", ",", "0.007`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.8100319575445166`*^9, 3.8100320374076257`*^9, 3.810032152806321*^9, 
   3.8100321929570036`*^9, 3.810032232075467*^9, 3.810032263849267*^9, {
   3.810032324516182*^9, 3.810032329219882*^9}, 3.8100324037359962`*^9, {
   3.8100324877811832`*^9, 3.8100324963599353`*^9}, {3.8100325332100773`*^9, 
   3.8100326111775727`*^9}, {3.810041860778966*^9, 3.8100419517777452`*^9}, {
   3.8100420023302484`*^9, 3.8100420114546013`*^9}, 3.810042068535478*^9, {
   3.8100422129033766`*^9, 3.8100422446441603`*^9}, {3.8100422778371763`*^9, 
   3.8100423072034893`*^9}, {3.810042400549141*^9, 3.810042490724763*^9}, 
   3.8100425535484157`*^9, {3.8100426071208553`*^9, 3.8100427059668508`*^9}, 
   3.8100447054899197`*^9, 3.8100447874378195`*^9, 3.8100448395360045`*^9, 
   3.8100448714135838`*^9, {3.810044906103722*^9, 3.8100449556890717`*^9}, 
   3.8100449931770067`*^9},ExpressionUUID->"2d9f1a66-78bf-4345-9e55-\
91b6901c8b00"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "6.662993890336463`", ",", "6.931344617191661`", ",", "7.170343740200989`", 
   ",", "7.217932075059413`", ",", "7.250580879051633`", ",", 
   "7.2868166375610945`", ",", "7.305563113241673`"}], "}"}]], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.8100449931839886`*^9},ExpressionUUID->"f988f085-fea1-464c-b826-\
198ac020b675"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.0001`", ",", "2", ",", "5", ",", "8", ",", "12", ",", "25", ",", 
     "50"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "6.662993890336463`", ",", "6.931344617191661`", ",", 
     "7.170343740200989`", ",", "7.217932075059413`", ",", 
     "7.250580879051633`", ",", "7.2868166375610945`", ",", 
     "7.305563113241673`"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.810044993187978*^9},ExpressionUUID->"834abf7d-2940-41d1-a8b0-\
4a127d6a7d7f"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwV2Xk4lF0UAPCJKIWEECVkKaRItKgRkRBCQoqUXfadsu/bmBnMWCJLKREq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       "]]},
     Annotation[#, "Charting`Private`Tag$50266#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.810044993272751*^9},ExpressionUUID->"14a99455-1807-4bdd-94b0-\
26c142221c89"],

Cell[BoxData["7.291828488148023091`18.86283644501765"], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.8100449932777386`*^9},ExpressionUUID->"2196d43e-8495-4dc7-8854-\
a736f6c1332f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "3.8449327379596623`", ",", "3.9593887662450364`", ",", 
   "4.080759716672764`", ",", "4.142277792261451`", ",", "4.173740112881654`",
    ",", "4.203052370634878`", ",", "4.217888081952018`"}], "}"}]], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.8100449933076572`*^9},ExpressionUUID->"1178b720-5cfc-44c7-99d4-\
1272eb49705d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.0001`", ",", "2", ",", "5", ",", "8", ",", "12", ",", "25", ",", 
     "50"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "6.662993890336463`", ",", "6.931344617191661`", ",", 
     "7.170343740200989`", ",", "7.217932075059413`", ",", 
     "7.250580879051633`", ",", "7.2868166375610945`", ",", 
     "7.305563113241673`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3.8449327379596623`", ",", "3.9593887662450364`", ",", 
     "4.080759716672764`", ",", "4.142277792261451`", ",", 
     "4.173740112881654`", ",", "4.203052370634878`", ",", 
     "4.217888081952018`"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.8100449933116465`*^9},ExpressionUUID->"b18d66a0-0495-45a4-8c2e-\
58f58963f509"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwd23k8VO0XAPBJKVokhJCQJEshsoQZ+5qdkMwYa8g6drOEZC2VItkqoqRQ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       "]]},
     Annotation[#, "Charting`Private`Tag$50350#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, -0.008000667261697902},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.8100449933864465`*^9},ExpressionUUID->"2e771a1f-0dbf-47be-bf8c-\
2472870fecff"],

Cell[BoxData["4.219480218506534541`18.625258955194436"], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.8100449933924313`*^9},ExpressionUUID->"6e548389-a2f8-4ee5-8b00-\
16054b894f7c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2.7110843490052248`", ",", "2.7500694517027076`", ",", 
   "2.809936833053699`", ",", "2.870193964850572`", ",", 
   "2.8975180933231552`", ",", "2.9260291795416826`", ",", 
   "2.9397592561832964`"}], "}"}]], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.8100449934253473`*^9},ExpressionUUID->"9af7f3d6-64fa-4c26-ad12-\
defa6014231e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.0001`", ",", "2", ",", "5", ",", "8", ",", "12", ",", "25", ",", 
     "50"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "6.662993890336463`", ",", "6.931344617191661`", ",", 
     "7.170343740200989`", ",", "7.217932075059413`", ",", 
     "7.250580879051633`", ",", "7.2868166375610945`", ",", 
     "7.305563113241673`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "3.8449327379596623`", ",", "3.9593887662450364`", ",", 
     "4.080759716672764`", ",", "4.142277792261451`", ",", 
     "4.173740112881654`", ",", "4.203052370634878`", ",", 
     "4.217888081952018`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "2.7110843490052248`", ",", "2.7500694517027076`", ",", 
     "2.809936833053699`", ",", "2.870193964850572`", ",", 
     "2.8975180933231552`", ",", "2.9260291795416826`", ",", 
     "2.9397592561832964`"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.810044993428334*^9},ExpressionUUID->"d06709df-0efe-46d8-af23-\
376a4671f4d4"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwd2nk4VV0XAPD7UkiSpIxJQkUJlSl1ZciYKcQlXJmnkPE6V0KSKUURkoRE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       "]]},
     Annotation[#, "Charting`Private`Tag$50434#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, -0.007200018800114005},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.8100449934921627`*^9},ExpressionUUID->"c753860d-d8ef-4ef0-b06f-\
8d31cd533db3"],

Cell[BoxData["2.941057854474745437`18.468503567734544"], "Print",
 CellChangeTimes->{
  3.8100447055836716`*^9, 3.8100447875086308`*^9, 3.8100448396018305`*^9, 
   3.810044871444501*^9, {3.810044906109706*^9, 3.8100449556960216`*^9}, 
   3.810044993496666*^9},ExpressionUUID->"dced8f9e-e210-410f-ba76-\
8336f16ac7dd"]
}, Open  ]],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.0001`", "2", "5", "8", "12", "25", "50"},
     {"6.662993890336463`", "6.931344617191661`", "7.170343740200989`", 
      "7.217932075059413`", "7.250580879051633`", "7.2868166375610945`", 
      "7.305563113241673`"},
     {"3.8449327379596623`", "3.9593887662450364`", "4.080759716672764`", 
      "4.142277792261451`", "4.173740112881654`", "4.203052370634878`", 
      "4.217888081952018`"},
     {"2.7110843490052248`", "2.7500694517027076`", "2.809936833053699`", 
      "2.870193964850572`", "2.8975180933231552`", "2.9260291795416826`", 
      "2.9397592561832964`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.8100319575445166`*^9, 3.8100320374076257`*^9, 3.810032152806321*^9, 
   3.8100321929570036`*^9, 3.810032232075467*^9, 3.810032263849267*^9, {
   3.810032324516182*^9, 3.810032329219882*^9}, 3.8100324037359962`*^9, {
   3.8100324877811832`*^9, 3.8100324963599353`*^9}, {3.8100325332100773`*^9, 
   3.8100326111775727`*^9}, {3.810041860778966*^9, 3.8100419517777452`*^9}, {
   3.8100420023302484`*^9, 3.8100420114546013`*^9}, 3.810042068535478*^9, {
   3.8100422129033766`*^9, 3.8100422446441603`*^9}, {3.8100422778371763`*^9, 
   3.8100423072034893`*^9}, {3.810042400549141*^9, 3.810042490724763*^9}, 
   3.8100425535484157`*^9, {3.8100426071208553`*^9, 3.8100427059668508`*^9}, 
   3.8100447054899197`*^9, 3.8100447874378195`*^9, 3.8100448395360045`*^9, 
   3.8100448714135838`*^9, {3.810044906103722*^9, 3.8100449556890717`*^9}, 
   3.8100449935280437`*^9},ExpressionUUID->"5dec5e45-1b70-494e-85a0-\
8059d9367fd4"]
}, Open  ]]
},
WindowSize->{958, 959},
WindowMargins->{{-8, Automatic}, {Automatic, 0}},
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 4452, 118, 624, "Input",ExpressionUUID->"c2fc1edf-838b-4c3a-9e89-428f3afb5b23"],
Cell[5035, 142, 1038, 16, 49, "Output",ExpressionUUID->"2d9f1a66-78bf-4345-9e55-91b6901c8b00"],
Cell[CellGroupData[{
Cell[6098, 162, 507, 10, 34, "Print",ExpressionUUID->"f988f085-fea1-464c-b826-198ac020b675"],
Cell[6608, 174, 685, 17, 63, "Print",ExpressionUUID->"834abf7d-2940-41d1-a8b0-4a127d6a7d7f"],
Cell[7296, 193, 21673, 374, 322, "Print",ExpressionUUID->"14a99455-1807-4bdd-94b0-26c142221c89"],
Cell[28972, 569, 318, 5, 34, "Print",ExpressionUUID->"2196d43e-8495-4dc7-8854-a736f6c1332f"],
Cell[29293, 576, 508, 10, 34, "Print",ExpressionUUID->"1178b720-5cfc-44c7-99d4-1272eb49705d"],
Cell[29804, 588, 940, 23, 91, "Print",ExpressionUUID->"b18d66a0-0495-45a4-8c2e-58f58963f509"],
Cell[30747, 613, 21179, 366, 335, "Print",ExpressionUUID->"2e771a1f-0dbf-47be-bf8c-2472870fecff"],
Cell[51929, 981, 319, 5, 34, "Print",ExpressionUUID->"6e548389-a2f8-4ee5-8b00-16054b894f7c"],
Cell[52251, 988, 515, 11, 34, "Print",ExpressionUUID->"9af7f3d6-64fa-4c26-ad12-defa6014231e"],
Cell[52769, 1001, 1194, 29, 119, "Print",ExpressionUUID->"d06709df-0efe-46d8-af23-376a4671f4d4"],
Cell[53966, 1032, 18771, 326, 327, "Print",ExpressionUUID->"c753860d-d8ef-4ef0-b06f-8d31cd533db3"],
Cell[72740, 1360, 317, 5, 34, "Print",ExpressionUUID->"dced8f9e-e210-410f-ba76-8336f16ac7dd"]
}, Open  ]],
Cell[73072, 1368, 2075, 39, 124, "Output",ExpressionUUID->"5dec5e45-1b70-494e-85a0-8059d9367fd4"]
}, Open  ]]
}
]
*)

